{
VOLLSTAENDIG: JA
SYNTAKTISCH: NEIN
AUSGETESTET: NEIN
BEMERKUNGEN:

R. Lohner  05.04.90  Siehe Bem. bei DIAM( CINTERVAL )
R. Lohner  11.06.90  ABS( CINTERVAL ) kann unnoetigen overflow produzieren.
                     sollte noch geaendert werden.

R. Lohner  27.06.90  Fuer alle zusaetzlichen Standardfunktionen ( 5.10 ) sind
                     zwar die Schnittstellen vorhanden, aber keine Implemen-
                     tierungen !!!
}

MODULE ci_ari;         {  Komplexe Intervall-Arithmetik,  Stand : 27.06.90  }

$off

{ Nur ATARI System }

USE L_ARI;

$on


USE i_ari, c_ari;
 
USE c_ariaux;    { Hilfsroutinen und Konstanten fuer komplexe Division }

$off
 
PROCEDURE _MATH_ERROR  ( err_num : INTEGER );   EXTERNAL;

$on


{******************************************************************}
{                                                                  }
{      PASCAL-SC ARITHMETIC ERRORHANDLER VERSION 1.0               }
{                                                                  }
{******************************************************************}

procedure traceback (var t:text) ; external f_back ;
const   stderr = 2 ; { standard error }
procedure rewrite (var t : text ; nr : integer) ; external f_rwrn ;
procedure exit    (retcode : integer)           ; external a_exit ;

global  { _ci_math_error must be global, if ci_ari is a library } 
procedure _ci_math_error (errnr : integer) ;
  var message : text;
  begin
    rewrite(message,stderr);
    case  errnr  of
       92: writeln (message, 'Illegal notation of complex number in read complex') ;
      250: writeln (message, 'Function not yet implemented') ;
     else: writeln (message, 'Unknown error') ;
    end ;
    traceback (message)  ;
    exit (-1) ;
  end { _ci_math_error } ;





{---------------------------------------------------------------------------}
{ 0. Vereinbarungen                                                         }
{---------------------------------------------------------------------------}




{   --- es werden keine benoetigt ---                                       }




{---------------------------------------------------------------------------}
{ 1. Transferfunktionen                                                     }
{---------------------------------------------------------------------------}
{    1.0 Zuweisungen                                                        }
{---------------------------------------------------------------------------}



GLOBAL OPERATOR := ( VAR A : CINTERVAL; B : REAL );

BEGIN
  A.RE.INF:= B;
  A.RE.SUP:= B;
  A.IM.INF:= 0.0;
  A.IM.SUP:= 0.0;
END;



GLOBAL OPERATOR := ( VAR A : CINTERVAL; VAR B : COMPLEX );

BEGIN
  A.RE.INF:= B.RE;
  A.RE.SUP:= B.RE;
  A.IM.INF:= B.IM;
  A.IM.SUP:= B.IM;
END;



GLOBAL OPERATOR := ( VAR A : CINTERVAL; VAR B : INTERVAL );

BEGIN
  A.RE    := B;
  A.IM.INF:= 0.0;
  A.IM.SUP:= 0.0;
END;




{---------------------------------------------------------------------------}
{    1.1 eigentliche Transferfunktionen                                     }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION COMPL ( VAR A : INTERVAL ) : CINTERVAL;

BEGIN
  COMPL.RE    := A;
  COMPL.IM.INF:= 0.0;
  COMPL.IM.SUP:= 0.0;
END;




GLOBAL FUNCTION COMPL ( A : REAL; VAR B : INTERVAL ) : CINTERVAL;

BEGIN
  COMPL.RE.INF:= A;
  COMPL.RE.SUP:= A;
  COMPL.IM    := B;
END;


GLOBAL FUNCTION COMPL ( VAR A : INTERVAL; B : REAL ) : CINTERVAL;

BEGIN
  COMPL.RE    := A;
  COMPL.IM.INF:= B;
  COMPL.IM.SUP:= B;
END;




GLOBAL FUNCTION COMPL ( VAR A, B : INTERVAL ) : CINTERVAL;

BEGIN
  COMPL.RE:= A;
  COMPL.IM:= B;
END;




GLOBAL FUNCTION RE ( VAR A : CINTERVAL ) : INTERVAL;

BEGIN
  RE:= A.RE
END;




GLOBAL FUNCTION IM ( VAR A : CINTERVAL ) : INTERVAL;

BEGIN
  IM:= A.IM
END;
 


GLOBAL FUNCTION INTVAL ( VAR A : COMPLEX ) : CINTERVAL;

BEGIN
  INTVAL.RE.INF:= A.RE;
  INTVAL.RE.SUP:= A.RE;
  INTVAL.IM.INF:= A.IM;
  INTVAL.IM.SUP:= A.IM
END;




GLOBAL FUNCTION INTVAL ( A : REAL; VAR B : COMPLEX ) : CINTERVAL;

BEGIN
  INTVAL.RE:= INTVAL( A  , B.RE );
  INTVAL.IM:= INTVAL( 0.0, B.IM )
END;




GLOBAL FUNCTION INTVAL ( VAR A : COMPLEX; B : REAL ) : CINTERVAL;

BEGIN
  INTVAL.RE:= INTVAL( A.RE, B   );
  INTVAL.IM:= INTVAL( A.IM, 0.0 )
END;




GLOBAL FUNCTION INTVAL ( VAR A, B : COMPLEX ) : CINTERVAL;

BEGIN
  INTVAL.RE:= INTVAL( A.RE, B.RE );
  INTVAL.IM:= INTVAL( A.IM, B.IM )
END;




GLOBAL FUNCTION INF ( VAR A : CINTERVAL ) : COMPLEX;

BEGIN
  INF.RE:= A.RE.INF;
  INF.IM:= A.IM.INF
END;




GLOBAL FUNCTION SUP ( VAR A : CINTERVAL ) : COMPLEX;

BEGIN
  SUP.RE:= A.RE.SUP;
  SUP.IM:= A.IM.SUP
END;




GLOBAL FUNCTION CINTVAL ( A : REAL ) : CINTERVAL;     { ergaenzt 9.4.90 }

BEGIN
  CINTVAL.RE:= A;
  CINTVAL.IM:= 0.0
END;



{---------------------------------------------------------------------------}
{ 2. Spezielle Funktionen                                                   }
{---------------------------------------------------------------------------}
{    2.1 Konjugation                                                        }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION CONJ ( VAR A : CINTERVAL ) : CINTERVAL;
BEGIN
  CONJ.RE:=  A.RE;
  CONJ.IM:= -A.IM
END;




{---------------------------------------------------------------------------}
{    2.2 Mittelpunkt                                                        }
{---------------------------------------------------------------------------}

 
GLOBAL FUNCTION MID( VAR A : CINTERVAL ) : COMPLEX;
 
BEGIN
  MID.RE:= MID( A.RE );
  MID.IM:= MID( A.IM )
END;

 


{---------------------------------------------------------------------------}
{    2.3 Durchmesser                                                        }
{---------------------------------------------------------------------------}

 
GLOBAL FUNCTION DIAM( VAR A : CINTERVAL ) : REAL;
 
BEGIN
  {  U.U. nicht max. genau !          ( -R.L.-,  5.4.90)            }
  {  evtl. besser mit SQRT(Longreal) ?? Dann nicht mehr portabel !! }
  {                                                                 }
  {  Es sollte gelten :  A  enthalten in  ( mid(A), diam(A) /> 2 ), }
  {  wo letzteres ein Kreisintervall ist.                           }
  {  U.U. darf deshalb sogar diam(A)  n i c h t  max. genau sein.   }
  {  Dies sollte noch untersucht werden !!!                         }

  WITH A DO
    DIAM:= SUP( SQRT( ##(    RE.SUP * RE.SUP  +  RE.INF * RE.INF
                          -  RE.SUP * RE.INF  -  RE.SUP * RE.INF
                          +  IM.SUP * IM.SUP  +  IM.INF * IM.INF
                          -  IM.SUP * IM.INF  -  IM.SUP * IM.INF )  ) );
END;
 



{---------------------------------------------------------------------------}
{ 3. Vergleiche                                                             }
{---------------------------------------------------------------------------}
{    3.1 Vergleiche REAL, COMPLEX mit INTERVAL, CINTERVAL                   }
{---------------------------------------------------------------------------}
{SEKTOR V12                                                                 }
{---------------------------------------------------------------------------}
{        3.1.1 Vergleiche REAL mit INTERVAL                                 }
{---------------------------------------------------------------------------}




{         ... sind bereits im Modul I_ARI definiert.                        }




{---------------------------------------------------------------------------}
{        3.1.2 Vergleiche REAL mit CINTERVAL                                }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( A : REAL; VAR B : CINTERVAL ) INRCIR : BOOLEAN;

BEGIN
  INRCIR:= ( A IN B.RE ) AND ( 0.0 IN B.IM )
END;




GLOBAL OPERATOR =  ( A : REAL; VAR B : CINTERVAL ) EQRCIR : BOOLEAN;

BEGIN
  EQRCIR:= ( A = B.RE ) AND ( 0.0 = B.IM )
END;




GLOBAL OPERATOR <> ( A : REAL; VAR B : CINTERVAL ) NERCIR : BOOLEAN;

BEGIN
  NERCIR:= ( A <> B.RE ) OR ( 0.0 <> B.IM )
END;




{---------------------------------------------------------------------------}
{        3.1.3 Vergleiche COMPLEX mit INTERVAL                              }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A : COMPLEX; VAR B : INTERVAL ) INCRIR : BOOLEAN;

BEGIN
  INCRIR:= ( A.RE IN B ) AND ( A.IM = 0.0 )
END;




GLOBAL OPERATOR =  ( VAR A : COMPLEX; VAR B : INTERVAL ) EQCRIR : BOOLEAN;

BEGIN
  EQCRIR:= ( A.RE = B ) AND ( A.IM = 0.0 )
END;




GLOBAL OPERATOR <> ( VAR A : COMPLEX; VAR B : INTERVAL ) NECRIR : BOOLEAN;

BEGIN
  NECRIR:= ( A.RE <> B ) OR ( A.IM <> 0.0 )
END;




{---------------------------------------------------------------------------}
{        3.1.4 Vergleiche COMPLEX mit CINTERVAL                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A : COMPLEX; VAR B : CINTERVAL ) INCRCIR : BOOLEAN;

BEGIN
  INCRCIR:= ( A.RE IN B.RE ) AND ( A.IM IN B.IM )
END;




GLOBAL OPERATOR =  ( VAR A : COMPLEX; VAR B : CINTERVAL ) EQCRCIR : BOOLEAN;

BEGIN
  EQCRCIR:= ( A.RE = B.RE ) AND ( A.IM = B.IM )
END;




GLOBAL OPERATOR <> ( VAR A : COMPLEX; VAR B : CINTERVAL ) NECRCIR : BOOLEAN;

BEGIN
  NECRCIR:= ( A.RE <> B.RE ) OR ( A.IM <> B.IM )
END;




{---------------------------------------------------------------------------}
{    3.2 Vergleiche INTERVAL, CINTERVAL mit REAL, COMPLEX                   }
{---------------------------------------------------------------------------}
{SEKTOR V21                                                                 }
{---------------------------------------------------------------------------}
{        3.2.1 Vergleiche INTERVAL mit REAL                                 }
{---------------------------------------------------------------------------}




{         ... sind bereits im Modul I_ARI definiert.                        }




{---------------------------------------------------------------------------}
{        3.2.2 Vergleiche INTERVAL mit COMPLEX                              }
{---------------------------------------------------------------------------}



GLOBAL OPERATOR =  ( VAR A : INTERVAL; VAR B : COMPLEX ) EQIRCR : BOOLEAN;

BEGIN
  EQIRCR:= ( A = B.RE ) AND ( B.IM = 0.0 )
END;




GLOBAL OPERATOR <> ( VAR A : INTERVAL; VAR B : COMPLEX ) NEIRCR : BOOLEAN;

BEGIN
  NEIRCR:= ( A <> B.RE ) OR ( B.IM <> 0.0 )
END;




{---------------------------------------------------------------------------}
{        3.2.3 Vergleiche CINTERVAL mit REAL                                }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR =  ( VAR A : CINTERVAL; B : REAL ) EQCIRR : BOOLEAN;

BEGIN
  EQCIRR:= ( A.RE = B ) AND ( A.IM = 0.0 )
END;




GLOBAL OPERATOR <> ( VAR A : CINTERVAL; B : REAL ) NECIRR : BOOLEAN;

BEGIN
  NECIRR:= ( A.RE <> B ) OR ( A.IM <> 0.0 )
END;




{---------------------------------------------------------------------------}
{        3.2.4 Vergleiche CINTERVAL mit COMPLEX                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR =  ( VAR A : CINTERVAL; VAR B : COMPLEX ) EQCIRCR : BOOLEAN;

BEGIN
  EQCIRCR:= ( A.RE = B.RE ) AND ( A.IM = B.IM )
END;




GLOBAL OPERATOR <> ( VAR A : CINTERVAL; VAR B : COMPLEX ) NECIRCR : BOOLEAN;

BEGIN
  NECIRCR:= ( A.RE <> B.RE ) OR ( A.IM <> B.IM )
END;




{---------------------------------------------------------------------------}
{    3.3 Vergleiche INTERVAL, CINTERVAL mit INTERVAL, CINTERVAL             }  
{---------------------------------------------------------------------------}
{SEKTOR V22                                                                 }
{---------------------------------------------------------------------------}
{        3.3.1 Vergleiche INTERVAL mit INTERVAL                             }
{---------------------------------------------------------------------------}




{         ... sind bereits im Modul I_ARI definiert.                        }




{---------------------------------------------------------------------------}
{        3.3.2 Vergleiche INTERVAL mit CINTERVAL                            }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR >< ( VAR A : INTERVAL; VAR B : CINTERVAL ) DISJIRCIR : BOOLEAN;

BEGIN
  DISJIRCIR:= ( A >< B.RE ) OR ( NOT ( 0.0 IN B.IM ) )
END;




GLOBAL OPERATOR =  ( VAR A : INTERVAL; VAR B : CINTERVAL ) EQIRCIR : BOOLEAN;

BEGIN
  EQIRCIR:= ( A = B.RE ) AND ( 0.0 = B.IM )
END;




GLOBAL OPERATOR <> ( VAR A : INTERVAL; VAR B : CINTERVAL ) NEIRCIR : BOOLEAN;

BEGIN
  NEIRCIR:= ( A <> B.RE ) OR ( 0.0 <> B.IM )
END;




GLOBAL OPERATOR <= ( VAR A : INTERVAL; VAR B : CINTERVAL ) LEIRCIR : BOOLEAN;

BEGIN
  LEIRCIR:= ( A <= B.RE ) AND ( 0.0 IN B.IM )
END;




GLOBAL OPERATOR < ( VAR A : INTERVAL; VAR B : CINTERVAL ) LTIRCIR : BOOLEAN;

BEGIN
  LTIRCIR:=   ( A <= B.RE ) AND ( 0.0 IN B.IM ) AND
            ( ( A <> B.RE ) OR  ( 0.0 <> B.IM ) )
END;




GLOBAL OPERATOR >= ( VAR A : INTERVAL; VAR B : CINTERVAL ) GEIRCIR : BOOLEAN;

BEGIN
  GEIRCIR:= ( A >= B.RE ) AND ( 0.0 = B.IM )
END;




GLOBAL OPERATOR > ( VAR A : INTERVAL; VAR B : CINTERVAL ) GTIRCIR : BOOLEAN;

BEGIN
  GTIRCIR:= ( A > B.RE ) AND ( 0.0 = B.IM )
END;



 
{---------------------------------------------------------------------------}
{        3.3.3 Vergleiche CINTERVAL mit INTERVAL                            }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR >< ( VAR A : CINTERVAL; VAR B : INTERVAL ) DISJCIRIR : BOOLEAN;

BEGIN
  DISJCIRIR:= ( A.RE >< B ) OR ( NOT ( 0.0 IN A.IM ) )
END;




GLOBAL OPERATOR =  ( VAR A : CINTERVAL; VAR B : INTERVAL ) EQCIRIR : BOOLEAN;

BEGIN
  EQCIRIR:= ( A.RE = B ) AND ( A.IM = 0.0 )
END;




GLOBAL OPERATOR <> ( VAR A : CINTERVAL; VAR B : INTERVAL ) NECIRIR : BOOLEAN;

BEGIN
  NECIRIR:= ( A.RE <> B ) OR ( A.IM <> 0.0 )
END;




GLOBAL OPERATOR <= ( VAR A : CINTERVAL; VAR B : INTERVAL ) LECIRIR : BOOLEAN;

BEGIN
  LECIRIR:= ( A.RE <= B ) AND ( A.IM = 0.0 )
END;




GLOBAL OPERATOR < ( VAR A : CINTERVAL; VAR B : INTERVAL ) LTCIRIR : BOOLEAN;

BEGIN
  LTCIRIR:= ( A.RE < B ) AND ( A.IM = 0.0 )
END;




GLOBAL OPERATOR >= ( VAR A : CINTERVAL; VAR B : INTERVAL ) GECIRIR : BOOLEAN;

BEGIN
  GECIRIR:= ( A.RE >= B ) AND ( 0.0 IN A.IM )
END;




GLOBAL OPERATOR > ( VAR A : CINTERVAL; VAR B : INTERVAL ) GTCIRIR : BOOLEAN;

BEGIN
  GTCIRIR:=   ( A.RE >= B ) AND ( A.IM >= INTVAL(0.0) ) AND
            ( ( A.RE <> B ) OR  ( A.IM <> 0.0 ) )
END;



 
{---------------------------------------------------------------------------}
{        3.3.4 Vergleiche CINTERVAL mit CINTERVAL                           }
{---------------------------------------------------------------------------}

 
 
GLOBAL OPERATOR >< ( VAR A, B : CINTERVAL ) DISJCIRCIR : BOOLEAN;

BEGIN
  DISJCIRCIR:= ( A.RE >< B.RE ) OR ( A.IM >< B.IM )
END;
 
 

 
GLOBAL OPERATOR =  ( VAR A, B : CINTERVAL ) EQCIRCIR : BOOLEAN;

BEGIN
  EQCIRCIR:= ( A.RE = B.RE ) AND ( A.IM = B.IM )
END;



 
GLOBAL OPERATOR <> ( VAR A, B : CINTERVAL ) NECIRCIR : BOOLEAN;

BEGIN
  NECIRCIR:= ( A.RE <> B.RE ) OR ( A.IM <> B.IM )
END;




GLOBAL OPERATOR <= ( VAR A, B : CINTERVAL ) LECIRCIR : BOOLEAN;

BEGIN
  LECIRCIR:= ( A.RE <= B.RE ) AND ( A.IM <= B.IM )
END;




GLOBAL OPERATOR < ( VAR A, B : CINTERVAL ) LTCIRCIR : BOOLEAN;

BEGIN
  LTCIRCIR:=   ( A.RE <= B.RE ) AND ( A.IM <= B.IM ) AND
             ( ( A.RE <> B.RE ) OR  ( A.IM <> B.IM ) )
END;




GLOBAL OPERATOR >= ( VAR A, B : CINTERVAL ) GECIRCIR : BOOLEAN;

BEGIN
  GECIRCIR:= ( A.RE >= B.RE ) AND ( A.IM >= B.IM )
END;




GLOBAL OPERATOR > ( VAR A, B : CINTERVAL ) GTCIRCIR : BOOLEAN;

BEGIN
  GTCIRCIR:=   ( A.RE >= B.RE ) AND ( A.IM >= B.IM ) AND
             ( ( A.RE <> B.RE ) OR  ( A.IM <> B.IM ) )
END;



 
{---------------------------------------------------------------------------}
{ 4. Arithmetische Operatoren ( + - * / ) und Verbandsoperatoren            }   
{---------------------------------------------------------------------------}
{    4.1 Monadische Operatoren                                              }
{---------------------------------------------------------------------------}
{SEKTOR A02                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CINTERVAL ) PLUSCIR : CINTERVAL;

BEGIN
  PLUSCIR:= A
END;




GLOBAL OPERATOR - ( VAR A : CINTERVAL ) MINUSCIR : CINTERVAL;

BEGIN
  MINUSCIR.RE:= -A.RE;
  MINUSCIR.IM:= -A.IM
END;




{---------------------------------------------------------------------------}
{    4.2 Operatoren mit Argumenten REAL, COMPLEX mit REAL, COMPLEX          }
{---------------------------------------------------------------------------}
{SEKTOR A11                                                                 }
{---------------------------------------------------------------------------}
{        4.2.1 Operatoren fuer REAL mit REAL                                }
{---------------------------------------------------------------------------}




{         ... sind bereits in die Run-time-Library integriert.              }




{---------------------------------------------------------------------------}
{        4.2.2 Operatoren fuer REAL mit COMPLEX                             }
{---------------------------------------------------------------------------}




{         ... sind bereits in die Run-time-Library integriert.              }




GLOBAL OPERATOR +* ( A : REAL; VAR B : COMPLEX ) COHURCR : CINTERVAL;

BEGIN
  COHURCR.RE:=  A  +* B.RE;
  COHURCR.IM:= 0.0 +* B.IM
END;




{---------------------------------------------------------------------------}
{        4.2.3 Operatoren fuer COMPLEX mit REAL                             }
{---------------------------------------------------------------------------}




{         ... sind bereits in die Run-time-Library integriert.              }




GLOBAL OPERATOR +* ( A : COMPLEX; VAR B : REAL ) COHUCRR : CINTERVAL;

BEGIN
  COHUCRR.RE:= A.RE +*  B;
  COHUCRR.IM:= A.IM +* 0.0
END;




{---------------------------------------------------------------------------}
{        4.2.4 Operatoren fuer COMPLEX mit COMPLEX                          }
{---------------------------------------------------------------------------}




{         ... sind bereits in die Run-time-Library integriert.              }




GLOBAL OPERATOR +* ( VAR A, B : COMPLEX ) COHUCRCR : CINTERVAL;

BEGIN
  COHUCRCR.RE:= A.RE +* B.RE;
  COHUCRCR.IM:= A.IM +* B.IM
END;




{---------------------------------------------------------------------------}
{    4.3 Operatoren fuer REAL,COMPLEX mit INTERVAL,CINTERVAL                }
{---------------------------------------------------------------------------}
{SEKTOR A12                                                                 }
{---------------------------------------------------------------------------}




{ Die nachfolgende Funktion CIDIVISION gehoert laut Numerierung nach        }
{   4.5.4 Operatoren fuer CINTERVAL mit CINTERVAL                           }
{ Aufgrund des langen komplizierten Algorithmus wird fuer alle Divisionen,  }
{ die im Nenner den Typ CINTERVAL aufweisen, der Zaehler ebenfalls          }
{ auf den Typ CINTERVAL angehoben und die Division CINTERVAL / CINTERVAL    }
{ gemaess der Funktion CIDIVISION ausgefuehrt.                              }


FUNCTION CIDIVISION ( A, B : CINTERVAL ) : CINTERVAL;

{ optimale komplexe Intervalldvision }

TYPE ecken = 1 .. 4;
       
VAR realteil,imagteil  : INTERVAL;
    a0,b0              : REAL;
    a_repeat,b_repeat  : BOOLEAN;
    p                  : ARRAY[ ecken ] OF BOOLEAN;
    i                  : ecken;
    rep,j              : INTEGER;



  FUNCTION f( a,b,c,d : REAL; round : INTEGER ) : REAL;

  VAR zoverfl,noverfl : INTEGER;
      z1,n1           : REAL;
      z2,n2           : INTERVAL;
  BEGIN
    {  f:=(a*c+b*d)/(SQR(c)+SQR(d))        }

    produkt( a, c, b, d, zoverfl, z1,z2 );
    produkt( c, c, d, d, noverfl, n1,n2 );

    f:= quotient( z1,z2, n1,n2, round, zoverfl, noverfl );

  END;   {  f  }



  FUNCTION max( a,b : REAL ) : REAL;
  BEGIN
    IF a >= b THEN max:= a ELSE max:= b
  END;


  FUNCTION min( a,b : REAL ) : REAL;
  BEGIN
    IF a <= b THEN min:= a ELSE min:= b
  END;




  FUNCTION minmax( minimum : BOOLEAN;  a,b,y0 : REAL;
                         x : INTERVAL;    i,j : ecken ) : REAL;
  { berechnet inneres Minimum bzw. Maximum von f = (ac+bd)/(cc+dd) }
  { auf dem Interval x = [c.inf,c.sup] ( a,b,d=y0 fest ).          }
  { Falls minimum = TRUE wird das Minimum berechnet,               }
  { sonst das Maximum.                                             }

  VAR q1,q2,w1,w2,t1,t2,x1,x2,ay0: REAL;
      akku                       : DOTPRECISION;

  BEGIN { minmax }
    IF minimum THEN  minmax:=  maxreal
               ELSE  minmax:= -maxreal;

    IF x.INF = x.SUP THEN
    BEGIN
       IF p[i] AND p[j] THEN minmax:= f( a, b, x.INF, y0, 1-2*ord(minimum) );
       p[i]:= FALSE;
       p[j]:= FALSE;
    END
    ELSE
    IF a = 0.0 THEN
      IF ( b = 0.0 ) OR ( y0 = 0.0 ) THEN
      BEGIN
        minmax:= 0.0;
        p[i]  := FALSE;
        p[j]  := FALSE;
      END ELSE
      BEGIN
        IF 0.0 IN x THEN
           IF   minimum  AND ( sign(b) <> sign(y0) ) THEN
           BEGIN
             minmax:= b /< y0;
             p[i]  := FALSE;
             p[j]  := FALSE;
           END ELSE
           IF not minimum AND ( sign(b) = sign(y0) ) THEN
           BEGIN
             minmax:= b /> y0;
             p[i]  := FALSE;
             p[j]  := FALSE;
           END;
      END
    ELSE  { a <> 0.0 }
      IF y0 = 0.0 THEN
      BEGIN
        IF minimum THEN IF a > 0.0 THEN minmax:= a /< x.SUP
                                   ELSE minmax:= a /< x.INF
                   ELSE IF a > 0.0 THEN minmax:= a /> x.INF
                                   ELSE minmax:= a /> x.SUP;
        p[i]:= FALSE;
        p[j]:= FALSE;
      END
      ELSE  { y0 <> 0.0,  Ber. von Extremstelle und Minimum,Maximum }
      BEGIN
        { IF NOTBEKANNT THEN }
        { Berechnung von t = sign(a) * ( |b/a| + sqrt( 1+|b/a|^2 ) )  }
        { mit staggered Darstellung  t ~ t1 + t2                      }


     {  Exponentenueber/unterlauf bei |b/a| noch nicht beruecksichtigt !!! }


        IF a>0.0 THEN q2:= ABS(b) ELSE q2:= -ABS(b); { Hilfsgroesse }

        q1  := q2/a;
        q2  := #*( q2 - q1*a ) / a;      {  q1 + q2  ~  | b/a |  }

        akku:= #( 1.0 + q1*q1 + q1*q2 + q1*q2 + q2*q2 );
        w1  := SQRT( #*(akku) );
        w2  := #*( akku - w1*w1 ) / (2.0*w1);
                                         {  w1 + w2  ~  sqrt( 1+|b/a|^2) }
        akku:= #( q1 + q2 + w1 + w2 );
        t1  := #*(  akku   );
        t2  := #*( akku-t1 );

        IF a<0.0 THEN BEGIN
                         t1:= -t1;
                         t2:= -t2;
                      END;

        { Fallunterscheidung zur Min-,Max- Best:}
        ay0:= abs(y0);
        IF ( sign(b) = sign(y0) ) = minimum THEN
        BEGIN
           { Berechne  x1 + x2  =  |y0| * ( t1 + t2 )  }
           akku:= #( ay0*t1 + ay0*t2 );
           x1  := #*(  akku   );
           x2  := #*( akku-x1 );
        END ELSE
        BEGIN
           { Berechne  x1 + x2  =  |y0| / ( t1 + t2 )  }
           x1:= ay0 / t1;
           x2:= #*( ay0 - t1*x1 - t2*x1 ) / t1;
        END;
        IF minimum THEN BEGIN
                           x1:= -x1;
                           x2:= -x2;
                        END;

        IF x1 IN x THEN
        BEGIN
          { Berechne  a / ( 2*(x1+x2) ) }
          q1  := 0.5*a/x1;
          akku:= #( x1*q1 - x2*q1 );
          IF minimum THEN  minmax:= q1 +< #*( a - akku - akku ) / (2.0*x1)
                     ELSE  minmax:= q1 +> #*( a - akku - akku ) / (2.0*x1);
          p[i]:= FALSE;
          p[j]:= FALSE;
        END;

      END  { y0 <> 0.0 }
  END;   {*** minmax ***}


BEGIN  { CIDIVISION }

  IF ( 0.0 IN B.RE ) AND ( 0.0 IN B.IM ) THEN 
    CIDIVISION:= COMPL( 1.0 / INTVAL(-1.0,1.0), INTVAL(0.0) );
    { Fehlerabbruch erzwingen: Intervall enthaelt 0 }

  { *** Berechnung des Realteils *** }

  a_repeat:= ( B.RE.INF < 0.0 ) AND ( 0.0 < B.RE.SUP );
  b_repeat:= ( B.IM.INF < 0.0 ) AND ( 0.0 < B.IM.SUP );

  IF a_repeat OR b_repeat THEN rep:= 2 ELSE rep:= 1;

  IF B.RE.INF >= 0.0 THEN a0:= A.RE.SUP ELSE a0:= A.RE.INF;
  IF B.IM.INF >= 0.0 THEN b0:= A.IM.SUP ELSE b0:= A.IM.INF;

  realteil.SUP:= -maxreal;

  FOR j:= 1 TO rep DO
  BEGIN
    FOR i:= 1 TO 4 DO p[i]:= TRUE;
    realteil.SUP:=
              max( realteil.SUP,
                   max( max( minmax( FALSE, a0, b0, B.IM.INF, B.RE, 1,2 ),
                             minmax( FALSE, a0, b0, B.IM.SUP, B.RE, 3,4 ) ), 
                        max( minmax( FALSE, b0, a0, B.RE.INF, B.IM, 1,3 ),
                             minmax( FALSE, b0, a0, B.RE.SUP, B.IM, 2,4 ) ) )

                  );
    IF p[1] THEN
      realteil.SUP:= max( realteil.SUP, f( a0, b0, B.RE.INF, B.IM.INF, +1 ) );
    IF p[2] THEN
      realteil.SUP:= max( realteil.SUP, f( a0, b0, B.RE.SUP, B.IM.INF, +1 ) );
    IF p[3] THEN
      realteil.SUP:= max( realteil.SUP, f( a0, b0, B.RE.INF, B.IM.SUP, +1 ) );
    IF p[4] THEN
      realteil.SUP:= max( realteil.SUP, f( a0, b0, B.RE.SUP, B.IM.SUP, +1 ) );

    IF a_repeat THEN a0:= A.RE.SUP ELSE
    IF b_repeat THEN b0:= A.IM.SUP  ;
  END;

  IF B.RE.INF >= 0.0 THEN a0:= A.RE.INF ELSE a0:= A.RE.SUP;
  IF B.IM.INF >= 0.0 THEN b0:= A.IM.INF ELSE b0:= A.IM.SUP;

  realteil.INF:= maxreal;

  FOR j:= 1 TO rep DO
  BEGIN
    FOR i:= 1 TO 4 DO p[i]:= TRUE;
    realteil.INF:= 
              min( realteil.INF,
                   min( min( minmax( TRUE, a0, b0, B.IM.INF, B.RE, 1,2 ),
                             minmax( TRUE, a0, b0, B.IM.SUP, B.RE, 3,4 ) ),
                        min( minmax( TRUE, b0, a0, B.RE.INF, B.IM, 1,3 ),
                             minmax( TRUE, b0, a0, B.RE.SUP, B.IM, 2,4 ) ) )
                  );
    IF p[1] THEN
      realteil.INF:= min( realteil.INF, f( a0, b0, B.RE.INF, B.IM.INF, -1 ) );
    IF p[2] THEN
      realteil.INF:= min( realteil.INF, f( a0, b0, B.RE.SUP, B.IM.INF, -1 ) );
    IF p[3] THEN
      realteil.INF:= min( realteil.INF, f( a0, b0, B.RE.INF, B.IM.SUP, -1 ) );
    IF p[4] THEN
      realteil.INF:= min( realteil.INF, f( a0, b0, B.RE.SUP, B.IM.SUP, -1 ) );

    IF a_repeat THEN a0:= A.RE.INF ELSE
    IF b_repeat THEN b0:= A.IM.INF  ;
  END;


  { *** Berechnung des Imaginaerteils: g(a, b, c, d) = f(b, -a, c, d) *** }

  a_repeat:= ( B.IM.INF < 0.0 ) AND ( 0.0 < B.IM.SUP );
  b_repeat:= ( B.RE.INF < 0.0 ) AND ( 0.0 < B.RE.SUP );

  { IF a_repeat OR b_repeat THEN rep:= 2 ELSE rep:= 1;  STIMMT NOCH }

  IF B.RE.INF >= 0.0 THEN b0:= A.IM.SUP ELSE b0:= A.IM.INF;
  IF B.IM.INF >= 0.0 THEN a0:= A.RE.INF ELSE a0:= A.RE.SUP;

  imagteil.SUP:= -maxreal;

  FOR j:= 1 TO rep DO
  BEGIN
    FOR i:= 1 TO 4 DO p[i]:= TRUE;
    imagteil.SUP:=
              max( imagteil.SUP,
                   max( max( minmax( FALSE,  b0, -a0, B.IM.INF, B.RE, 1,2 ),
                             minmax( FALSE,  b0, -a0, B.IM.SUP, B.RE, 3,4 ) ),
                        max( minmax( FALSE, -a0,  b0, B.RE.INF, B.IM, 1,3 ),
                             minmax( FALSE, -a0,  b0, B.RE.SUP, B.IM, 2,4 ) ) )
                  );
    IF p[1] THEN
     imagteil.SUP:= max( imagteil.SUP, f( b0, -a0, B.RE.INF, B.IM.INF, +1 ) );
    IF p[2] THEN
     imagteil.SUP:= max( imagteil.SUP, f( b0, -a0, B.RE.SUP, B.IM.INF, +1 ) );
    IF p[3] THEN
     imagteil.SUP:= max( imagteil.SUP, f( b0, -a0, B.RE.INF, B.IM.SUP, +1 ) );
    IF p[4] THEN
     imagteil.SUP:= max( imagteil.SUP, f( b0, -a0, B.RE.SUP, B.IM.SUP, +1 ) );

    IF b_repeat THEN b0:= A.IM.SUP ELSE
    IF a_repeat THEN a0:= A.RE.INF  ;
  END;

  IF B.RE.INF >= 0.0 THEN b0:= A.IM.INF ELSE b0:= A.IM.SUP;
  IF B.IM.INF >= 0.0 THEN a0:= A.RE.SUP ELSE a0:= A.RE.INF; 

  imagteil.INF:= maxreal;

  FOR j:= 1 TO rep DO
  BEGIN
    FOR i:= 1 TO 4 DO p[i]:= TRUE;
    imagteil.INF:=
              min( imagteil.INF,
                   min( min( minmax( TRUE,  b0, -a0, B.IM.INF, B.RE, 1,2 ),
                             minmax( TRUE,  b0, -a0, B.IM.SUP, B.RE, 3,4 ) ),
                        min( minmax( TRUE, -a0,  b0, B.RE.INF, B.IM, 1,3 ),
                             minmax( TRUE, -a0,  b0, B.RE.SUP, B.IM, 2,4 ) ) )
                  );
    IF p[1] THEN
     imagteil.INF:= min( imagteil.INF, f( b0, -a0, B.RE.INF, B.IM.INF, -1 ) );
    IF p[2] THEN
     imagteil.INF:= min( imagteil.INF, f( b0, -a0, B.RE.SUP, B.IM.INF, -1 ) );
    IF p[3] THEN
     imagteil.INF:= min( imagteil.INF, f( b0, -a0, B.RE.INF, B.IM.SUP, -1 ) );
    IF p[4] THEN
     imagteil.INF:= min( imagteil.INF, f( b0, -a0, B.RE.SUP, B.IM.SUP, -1 ) );

    IF b_repeat THEN b0:= A.IM.INF ELSE
    IF a_repeat THEN a0:= A.RE.SUP  ;
  END;
  
  CIDIVISION:= COMPL( realteil, imagteil )

END;   { CIDIVISION }




{---------------------------------------------------------------------------}
{        4.3.1 Operatoren fuer REAL mit INTERVAL                            }
{---------------------------------------------------------------------------}




{         ... sind bereits im Modul I_ARI definiert.                        }




{---------------------------------------------------------------------------}
{        4.3.2 Operatoren fuer REAL mit CINTERVAL                           }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( R : REAL; VAR B : CINTERVAL ) ADDRCIR : CINTERVAL;
 
BEGIN
  ADDRCIR.RE:= R + B.RE;
  ADDRCIR.IM:= B.IM
END;




GLOBAL OPERATOR - ( R : REAL; VAR B : CINTERVAL ) SUBRCIR : CINTERVAL;
 
BEGIN
  SUBRCIR.RE:= R - B.RE;
  SUBRCIR.IM:= - B.IM
END;




GLOBAL OPERATOR * ( R : REAL; VAR B : CINTERVAL ) MULRCIR : CINTERVAL;
 
BEGIN
  MULRCIR.RE:= R * B.RE;
  MULRCIR.IM:= R * B.IM
END;




GLOBAL OPERATOR / ( R : REAL; VAR B : CINTERVAL ) DIVRCIR : CINTERVAL;
 
BEGIN
  DIVRCIR:= CIDIVISION( COMPL( INTVAL(R), INTVAL(0.0) ) , B )
END;




GLOBAL OPERATOR +* ( A : REAL; VAR B : CINTERVAL ) COHURCIR : CINTERVAL;

BEGIN
  COHURCIR.RE:=  A  +* B.RE;
  COHURCIR.IM:= 0.0 +* B.IM
END;




{---------------------------------------------------------------------------}
{        4.3.3 Operatoren fuer COMPLEX mit INTERVAL                         }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : COMPLEX; VAR B : INTERVAL ) ADDCRIR : CINTERVAL;

BEGIN
  ADDCRIR.RE:= A.RE + B;
  ADDCRIR.IM:= A.IM
END;



 
GLOBAL OPERATOR - ( VAR A : COMPLEX; VAR B : INTERVAL ) SUBCRIR : CINTERVAL;

BEGIN
  SUBCRIR.RE:= A.RE - B;
  SUBCRIR.IM:= A.IM
END;



 
GLOBAL OPERATOR * ( VAR A : COMPLEX; VAR B : INTERVAL ) MULCRIR : CINTERVAL;

BEGIN
  MULCRIR.RE:= A.RE * B;
  MULCRIR.IM:= A.IM * B
END;



 
GLOBAL OPERATOR / ( VAR A : COMPLEX; VAR B : INTERVAL ) DIVCRIR : CINTERVAL;

BEGIN
  DIVCRIR:= COMPL( A.RE/B, A.IM/B )
END;




GLOBAL OPERATOR +* ( VAR A : COMPLEX; VAR B : INTERVAL ) COHUCRIR : CINTERVAL;

BEGIN
  COHUCRIR.RE:= A.RE +* B;
  COHUCRIR.IM:= A.IM +* 0.0
END;




{---------------------------------------------------------------------------}
{        4.3.4 Operatoren fuer COMPLEX mit CINTERVAL                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : COMPLEX; VAR B : CINTERVAL ) ADDCRCIR : CINTERVAL;

BEGIN
  ADDCRCIR.RE:= A.RE + B.RE;
  ADDCRCIR.IM:= A.IM + B.IM
END;




GLOBAL OPERATOR - ( VAR A : COMPLEX; VAR B : CINTERVAL ) SUBCRCIR : CINTERVAL;

BEGIN
  SUBCRCIR.RE:= A.RE - B.RE;
  SUBCRCIR.IM:= A.IM - B.IM
END;




GLOBAL OPERATOR * ( VAR A : COMPLEX; VAR B : CINTERVAL ) MULCRCIR : CINTERVAL;

BEGIN
  MULCRCIR.RE:= ##( A.RE * B.RE - A.IM * B.IM );
  MULCRCIR.IM:= ##( A.RE * B.IM + A.IM * B.RE )
END;




GLOBAL OPERATOR / ( VAR A : COMPLEX; VAR B : CINTERVAL ) DIVCRCIR : CINTERVAL;

BEGIN
  DIVCRCIR:= CIDIVISION( INTVAL(A) , B )
END;




GLOBAL OPERATOR +* ( VAR A : COMPLEX; VAR B : CINTERVAL ) COHUCRCIR : CINTERVAL;

BEGIN
  COHUCRCIR.RE:= A.RE +* B.RE;
  COHUCRCIR.IM:= A.IM +* B.IM
END;




{---------------------------------------------------------------------------}
{    4.4 Operatoren fuer INTERVAL,CINTERVAL mit REAL, COMPLEX               }
{---------------------------------------------------------------------------}
{SEKTOR A21                                                                 }
{---------------------------------------------------------------------------}
{        4.4.1 Operatoren fuer INTERVAL mit REAL                            }
{---------------------------------------------------------------------------}




{         ... sind bereits im Modul I_ARI definiert.                        }




{---------------------------------------------------------------------------}
{        4.4.2 Operatoren fuer INTERVAL mit COMPLEX                         }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : INTERVAL; VAR B : COMPLEX ) ADDIRCR : CINTERVAL;

BEGIN
  ADDIRCR.RE:= A + B.RE;
  ADDIRCR.IM:= B.IM
END;




GLOBAL OPERATOR - ( VAR A : INTERVAL; VAR B : COMPLEX ) SUBIRCR : CINTERVAL;

BEGIN
  SUBIRCR.RE:= A - B.RE;
  SUBIRCR.IM:= - B.IM
END;




GLOBAL OPERATOR * ( VAR A : INTERVAL; VAR B : COMPLEX ) MULIRCR : CINTERVAL;

BEGIN
  MULIRCR.RE:= A * B.RE;
  MULIRCR.IM:= A * B.IM
END;




GLOBAL OPERATOR / ( VAR A : INTERVAL; VAR B : COMPLEX ) DIVIRCR : CINTERVAL;
{ Abhaengig von den Vorzeichen von B.RE und B.IM, kann die Division   }
{ auf gerichtete Punktdivisionen mit passenden Grenzen von A zurueck- }
{ gefuehrt werden.                                                    }
{ Der Aufwand einer echten CINTERVAL-Division ist nicht notwendig.    }

VAR H : COMPLEX;
BEGIN
 { wegen                                                               }
 {                                                                     }
 {  A / B = ( A * B.RE  -  i * A * B.IM ) / ( B.RE*B.RE + B.IM*B.IM )  }
 {                                                                     }
 { muessen die passenden Grenzen von A nach folgender Fallunter-       }
 { scheidung gewaehlt werden :                                         }

  IF B.RE >= 0.0 THEN
    IF B.IM >= 0.0 THEN BEGIN
                          DIVIRCR.RE.INF:= RE( COMPL(A.INF,0.0) /< B );
                          DIVIRCR.RE.SUP:= RE( COMPL(A.SUP,0.0) /> B );
                          DIVIRCR.IM.INF:= IM( COMPL(A.SUP,0.0) /< B );
                          DIVIRCR.IM.SUP:= IM( COMPL(A.INF,0.0) /> B );
                        END
                   ELSE BEGIN
                                       H:= COMPL(A.INF,0.0) /< B;
                          DIVIRCR.RE.INF:= RE( H );
                          DIVIRCR.IM.INF:= IM( H );
                                       H:= COMPL(A.SUP,0.0) /> B;
                          DIVIRCR.RE.SUP:= RE( H );
                          DIVIRCR.IM.SUP:= IM( H );
                        END
  ELSE  { B.RE < 0.0 }
    IF B.IM >= 0.0 THEN BEGIN
                                       H:= COMPL(A.SUP,0.0) /< B;
                          DIVIRCR.RE.INF:= RE( H );
                          DIVIRCR.IM.INF:= IM( H );
                                       H:= COMPL(A.INF,0.0) /> B;
                          DIVIRCR.RE.SUP:= RE( H );
                          DIVIRCR.IM.SUP:= IM( H );
                        END
                   ELSE BEGIN
                          DIVIRCR.RE.INF:= RE( COMPL(A.SUP,0.0) /< B );
                          DIVIRCR.RE.SUP:= RE( COMPL(A.INF,0.0) /> B );
                          DIVIRCR.IM.INF:= IM( COMPL(A.INF,0.0) /< B );
                          DIVIRCR.IM.SUP:= IM( COMPL(A.SUP,0.0) /> B );
                        END;
END;




GLOBAL OPERATOR +* ( VAR A : INTERVAL; VAR B : COMPLEX ) COHUIRCR : CINTERVAL;

BEGIN
  COHUIRCR.RE:=  A  +* B.RE;
  COHUIRCR.IM:= 0.0 +* B.IM
END;




{---------------------------------------------------------------------------}
{        4.4.3 Operatoren fuer CINTERVAL mit REAL                           }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CINTERVAL; B : REAL ) ADDCIRR : CINTERVAL;

BEGIN
  ADDCIRR.RE:= A.RE + B;
  ADDCIRR.IM:= A.IM
END;




GLOBAL OPERATOR - ( VAR A : CINTERVAL; B : REAL ) SUBCIRR : CINTERVAL;
 
BEGIN
  SUBCIRR.RE:= A.RE - B;
  SUBCIRR.IM:= A.IM
END;




GLOBAL OPERATOR * ( VAR A : CINTERVAL; B : REAL ) MULCIRR : CINTERVAL;
 
BEGIN
  MULCIRR.RE:= A.RE * B;
  MULCIRR.IM:= A.IM * B
END;



 
GLOBAL OPERATOR / ( VAR A : CINTERVAL; B : REAL ) DIVCIRR : CINTERVAL;
 
BEGIN
  DIVCIRR.RE:= A.RE / B;
  DIVCIRR.IM:= A.IM / B
END;




GLOBAL OPERATOR +* ( VAR A : CINTERVAL; B : REAL ) COHUCIRR : CINTERVAL;

BEGIN
  COHUCIRR.RE:= A.RE +*  B;
  COHUCIRR.IM:= A.IM +* 0.0
END;




{---------------------------------------------------------------------------}
{        4.4.4 Operatoren fuer CINTERVAL mit COMPLEX                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CINTERVAL; VAR B : COMPLEX ) ADDCIRCR : CINTERVAL;

BEGIN
  ADDCIRCR.RE:= A.RE + B.RE;
  ADDCIRCR.IM:= A.IM + B.IM
END;



GLOBAL OPERATOR - ( VAR A : CINTERVAL; VAR B : COMPLEX ) SUBCIRCR : CINTERVAL;

BEGIN
  SUBCIRCR.RE:= A.RE - B.RE;
  SUBCIRCR.IM:= A.IM - B.IM
END;




GLOBAL OPERATOR * ( VAR A : CINTERVAL; VAR B : COMPLEX ) MULCIRCR : CINTERVAL;

BEGIN
  MULCIRCR.RE:= ##( A.RE * B.RE - A.IM * B.IM );
  MULCIRCR.IM:= ##( A.RE * B.IM + A.IM * B.RE )
END;
  
 


GLOBAL OPERATOR / ( VAR A : CINTERVAL; VAR B : COMPLEX ) DIVCIRCR : CINTERVAL;
{ Abhaengig von den Vorzeichen von B.RE und B.IM, kann die Division   }
{ auf gerichtete Punktdivisionen mit passenden Grenzen von A zurueck- }
{ gefuehrt werden.                                                    }
{ Der Aufwand einer echten CINTERVAL-Division ist nicht notwendig.    }

BEGIN
 { wegen                                                               }
 {                                                                     }
 {  A/B = ( ( A.RE*B.RE + A.IM*B.IM ) + i*( A.IM*B.RE - A.RE*B.IM ) )  }
 {              / ( B.RE*B.RE + B.IM*B.IM )                            }
 {                                                                     }
 { muessen die passenden Grenzen von A.RE und A.IM nach folgender      }
 { Fallunterscheidung gewaehlt werden :                                }

  IF B.RE>=0.0 THEN
   IF B.IM>=0.0 THEN BEGIN
                       DIVCIRCR.RE.INF:= RE( COMPL(A.RE.INF,A.IM.INF) /< B );
                       DIVCIRCR.RE.SUP:= RE( COMPL(A.RE.SUP,A.IM.SUP) /> B );
                       DIVCIRCR.IM.INF:= IM( COMPL(A.RE.SUP,A.IM.INF) /< B );
                       DIVCIRCR.IM.SUP:= IM( COMPL(A.RE.INF,A.IM.SUP) /> B );
                     END
                ELSE BEGIN
                       DIVCIRCR.RE.INF:= RE( COMPL(A.RE.INF,A.IM.SUP) /< B );
                       DIVCIRCR.RE.SUP:= RE( COMPL(A.RE.SUP,A.IM.INF) /> B );
                       DIVCIRCR.IM.INF:= IM( COMPL(A.RE.INF,A.IM.INF) /< B );
                       DIVCIRCR.IM.SUP:= IM( COMPL(A.RE.SUP,A.IM.SUP) /> B );
                    END
  ELSE { B.RE<0.0 }
   IF B.IM>=0.0 THEN BEGIN
                       DIVCIRCR.RE.INF:= RE( COMPL(A.RE.SUP,A.IM.INF) /< B );
                       DIVCIRCR.RE.SUP:= RE( COMPL(A.RE.INF,A.IM.SUP) /> B );
                       DIVCIRCR.IM.INF:= IM( COMPL(A.RE.SUP,A.IM.SUP) /< B );
                       DIVCIRCR.IM.SUP:= IM( COMPL(A.RE.INF,A.IM.INF) /> B );
                     END
                ELSE BEGIN
                       DIVCIRCR.RE.INF:= RE( COMPL(A.RE.SUP,A.IM.SUP) /< B );
                       DIVCIRCR.RE.SUP:= RE( COMPL(A.RE.INF,A.IM.INF) /> B );
                       DIVCIRCR.IM.INF:= IM( COMPL(A.RE.INF,A.IM.SUP) /< B );
                       DIVCIRCR.IM.SUP:= IM( COMPL(A.RE.SUP,A.IM.INF) /> B );
                     END;
END;




GLOBAL OPERATOR +* ( VAR A : CINTERVAL; VAR B : COMPLEX ) COHUCIRCR : CINTERVAL;

BEGIN
  COHUCIRCR.RE:= A.RE +* B.RE;
  COHUCIRCR.IM:= A.IM +* B.IM
END;




{---------------------------------------------------------------------------}
{    4.5 Operatoren fuer INTERVAL,CINTERVAL mit INTERVAL,CINTERVAL          }
{---------------------------------------------------------------------------}
{SEKTOR A22                                                                 }
{---------------------------------------------------------------------------}
{        4.5.1 Operatoren fuer INTERVAL mit INTERVAL                        }
{---------------------------------------------------------------------------}




{         ... sind bereits im Modul I_ARI definiert.                        }




{---------------------------------------------------------------------------}
{        4.5.2 Operatoren fuer INTERVAL mit CINTERVAL                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : INTERVAL; VAR B : CINTERVAL ) ADDIRCIR : CINTERVAL;

BEGIN
  ADDIRCIR.RE:= A + B.RE;
  ADDIRCIR.IM:= B.IM
END;




GLOBAL OPERATOR - ( VAR A : INTERVAL; VAR B : CINTERVAL ) SUBIRCIR : CINTERVAL;

BEGIN
  SUBIRCIR.RE:= A - B.RE;
  SUBIRCIR.IM:= - B.IM
END;




GLOBAL OPERATOR * ( VAR A : INTERVAL; VAR B : CINTERVAL ) MULIRCIR : CINTERVAL;

BEGIN
  MULIRCIR.RE:= A * B.RE;
  MULIRCIR.IM:= A * B.IM
END;




GLOBAL OPERATOR / ( VAR A : INTERVAL; VAR B : CINTERVAL ) DIVIRCIR : CINTERVAL;

BEGIN
  DIVIRCIR:= CIDIVISION( COMPL( A, INTVAL(0.0) ) , B )
END;




GLOBAL OPERATOR +* ( VAR A : INTERVAL; VAR B : CINTERVAL ) COHUIRCIR : CINTERVAL;

BEGIN
  COHUIRCIR.RE:=  A  +* B.RE;
  COHUIRCIR.IM:= 0.0 +* B.IM
END;




GLOBAL OPERATOR ** ( VAR A : INTERVAL; VAR B : CINTERVAL ) INTSCTIRCIR : CINTERVAL;

BEGIN
  { Falls  A >< B  :  Fehler tritt in Intervallroutine auf }
  INTSCTIRCIR.RE:=         A   ** B.RE;
  INTSCTIRCIR.IM:= INTVAL(0.0) ** B.IM
END;




{---------------------------------------------------------------------------}
{        4.5.3 Operatoren fuer CINTERVAL mit INTERVAL                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CINTERVAL; VAR B : INTERVAL ) ADDCIRIR : CINTERVAL;

BEGIN
  ADDCIRIR.RE:= A.RE + B;
  ADDCIRIR.IM:= A.IM
END;




GLOBAL OPERATOR - ( VAR A : CINTERVAL; VAR B : INTERVAL ) SUBCIRIR : CINTERVAL;

BEGIN
  SUBCIRIR.RE:= A.RE - B;
  SUBCIRIR.IM:= A.IM
END;




GLOBAL OPERATOR * ( VAR A : CINTERVAL; VAR B : INTERVAL ) MULCIRIR : CINTERVAL;

BEGIN
  MULCIRIR.RE:= A.RE * B;
  MULCIRIR.IM:= A.IM * B
END;




GLOBAL OPERATOR / ( VAR A : CINTERVAL; VAR B : INTERVAL ) DIVCIRIR : CINTERVAL;

BEGIN
  DIVCIRIR.RE:= A.RE / B;
  DIVCIRIR.IM:= A.IM / B
END;




GLOBAL OPERATOR +* ( VAR A : CINTERVAL; VAR B : INTERVAL ) COHUCIRIR : CINTERVAL;

BEGIN
  COHUCIRIR.RE:= A.RE +* B;
  COHUCIRIR.IM:= 0.0  +* A.IM
END;




GLOBAL OPERATOR ** ( VAR A : CINTERVAL; VAR B : INTERVAL ) INTSCTCIRIR : CINTERVAL;

BEGIN
  { Falls  A >< B  :  Fehler tritt in Intervallroutine auf }
  INTSCTCIRIR.RE:= A.RE ** B;
  INTSCTCIRIR.IM:= A.IM ** INTVAL(0.0)
END;




{---------------------------------------------------------------------------}
{        4.5.4 Operatoren fuer CINTERVAL mit CINTERVAL                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A, B : CINTERVAL ) ADDCIRCIR : CINTERVAL;

BEGIN
  ADDCIRCIR.RE:= A.RE + B.RE;
  ADDCIRCIR.IM:= A.IM + B.IM
END;




GLOBAL OPERATOR - ( VAR A, B : CINTERVAL ) SUBCIRCIR : CINTERVAL;

BEGIN
  SUBCIRCIR.RE:= A.RE - B.RE;
  SUBCIRCIR.IM:= A.IM - B.IM
END;




GLOBAL OPERATOR * ( VAR A, B : CINTERVAL ) MULCIRCIR : CINTERVAL;

BEGIN
  MULCIRCIR.RE:= ##( A.RE * B.RE - A.IM * B.IM );
  MULCIRCIR.IM:= ##( A.RE * B.IM + A.IM * B.RE )
END;




GLOBAL OPERATOR / ( VAR A, B : CINTERVAL ) DIVCIRCIR : CINTERVAL;

BEGIN
  DIVCIRCIR:= CIDIVISION( A , B )
END;




GLOBAL OPERATOR +* ( VAR A, B : CINTERVAL ) COHUCIRCIR : CINTERVAL;

BEGIN
  COHUCIRCIR.RE:= A.RE +* B.RE;
  COHUCIRCIR.IM:= A.IM +* B.IM
END;




GLOBAL OPERATOR ** ( VAR A, B : CINTERVAL ) INTSCTCIRCIR : CINTERVAL;

BEGIN
  { Falls  A >< B  :  Fehler tritt in Intervallroutine auf }
  INTSCTCIRCIR.RE:= A.RE ** B.RE;
  INTSCTCIRCIR.IM:= A.IM ** B.IM
END;


$off

{---------------------------------------------------------------------------}
{ 5. Komplexe Intervallstandardfunktionen                                   }
{    Quelltext fuer komplexe Intervallstandardfunktionen fuer PASCAL-SC 2   }
{    Version vom  5.Februar 1988 auf kws SAM 68k                            }
{---------------------------------------------------------------------------}



{---------------------------------------------------------------------------}
{    5.1 Argument                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARG ( z: CINTERVAL ) : INTERVAL;

{ BERECHNET DAS INTERVALL ALLER MOEGLICHEN ARGUMENTE VON z }
 
CONST pi05   = 1.570796326795;
      pi05d  = 1.570796326794;
      pi     = 3.141592653590;
      pid    = 3.141592653589;
      relerr = 1.00008E-12;

VAR neg, pimin : BOOLEAN;
    w          : INTERVAL;

BEGIN
  neg  := FALSE;
  pimin:= FALSE;
  w    := 5.555;   { NUR FUER DEN FEHLERFALL }

  WITH z DO
  BEGIN
    IF IM.SUP <= 0.0 THEN  BEGIN
                             IM := -IM;
                             neg:= TRUE
                           END;
    IF RE.SUP <= 0.0 THEN  BEGIN
                             RE   := -RE;
                             pimin:= TRUE
                           END;

    IF RE.INF > 0.0 THEN w:= ARCTAN( IM / RE )
    ELSE   { 0.0 IN RE ,ALSO DIE NORMALE FORMEL NICHT ANWENBAR }
      IF RE.INF = 0.0 THEN
      BEGIN
        IF IM.INF < 0.0 THEN w:= INTVAL( -pi05, pi05 )
        ELSE
          IF RE.SUP >= 0.0 THEN
            IF IM.SUP > 0.0 THEN   { ERROR 61, WENN RE,IM=0 }
              w:= INTVAL( ARCTAN2(IM.INF,RE.SUP) *< ( 1.0 -< relerr ), pi05 )
            ELSE
              w:= 0.0
      END
      ELSE  { ALSO 0 ECHT IN RE }
        IF IM.INF < 0.0 THEN  w:= INTVAL( -pi, pi )  { 0 ECHT IN z, EIN VOLLER KREIS}
        ELSE
          IF IM.INF = 0.0 THEN w:= INTVAL( 0.0, pi )
          ELSE
            w:= INTVAL( ARCTAN2(IM.INF,RE.SUP) *< ( 1.0 -< relerr ),
                        ARCTAN2(IM.INF,RE.INF) *> ( 1.0 +> relerr ) +> pi );
  END { WITH };

  IF pimin THEN w:= INTVAL( pid, pi ) - w;
  IF neg THEN ARG:= -w ELSE ARG:= w

END {ARG};


$on

{---------------------------------------------------------------------------}
{    5.2 Betrag                                                             }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ABS( y : CINTERVAL ) : INTERVAL;

BEGIN
  ABS:= SQRT( SQR(y.RE) + SQR(y.IM) )
END;




{---------------------------------------------------------------------------}
{    5.3 Quadrat                                                            }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION SQR( y : CINTERVAL ) : CINTERVAL;

BEGIN
  SQR:= COMPL( SQR(y.RE) - SQR(y.IM), 2.0 * y.RE * y.IM )
END;


$off
 
{---------------------------------------------------------------------------}
{    5.4 Quadratwurzel                                                      }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION SQRT( z : CINTERVAL ) : CINTERVAL;

{ benutzt COMPL, CONJ, ABS }
{ berechnet Schranken durch Intervallrechnung, jedoch Aufspaltung aller
   Intervalle so dass exakte Menge knapp eingeschlossen wird. }

VAR quer, tau    : BOOLEAN;
    fall         : 0..3;
    r            : CINTERVAL;
    w, v, wq, vq : INTERVAL;    {Teile bei Aufspaltung }
 

  FUNCTION tausch( t : CINTERVAL ) : CINTERVAL;

  { Tauscht REAL und IMAGINAERTEIL eines kompl.Intervalls  }
  { benutzt COMPL }
  BEGIN
    tausch:= COMPL( t.IM, t.RE )
  END;


  FUNCTION csp (ire,iim: INTERVAL) : CINTERVAL;

  { CICOMPL,CIABS }
  { BERECHNET WURZEL DES KOMPL INTERVALLS ( ire, iim )
     FUER ire >= 0 UND iim >= 0                         }

  VAR re, im, r, s : INTERVAL;

  BEGIN
    re:= SQRT( ( ire + ABS( COMPL( ire, iim ) ) ) * 0.5 );

    r:= ABS( COMPL( INTVAL( ire.SUP ), INTVAL( iim.INF ) ) );
    s:= SQRT( INTVAL( r.SUP *> 0.5  +>  ire.SUP *> 0.5 ) );

    IF s.SUP=0.0 THEN  im.INF:= 0.0
                 ELSE  im.INF:= iim.INF *< 0.5 /< s.SUP;

    r:= ABS( COMPL( INTVAL( ire.INF ), INTVAL( iim.SUP ) ) );
    s:= SQRT( INTVAL( r.INF *< 0.5  +<  ire.INF *< 0.5 ) );

    IF s.INF=0.0 THEN  im.SUP:= 0.0
                 ELSE  im.SUP:= iim.SUP *> 0.5 /> s.INF;

    csp:= COMPL( re, im )
  END{ csp } ;
 

BEGIN  { SQRT }
  quer:= FALSE;
  tau:= FALSE;
  fall:= 0;
  WITH z DO
  BEGIN
    IF IM.SUP <= 0.0 THEN BEGIN 
                            IM  := -IM;
                            quer:= TRUE
                          END;
    IF RE.SUP <= 0.0 THEN BEGIN
                            RE := -RE;
                            tau:= TRUE
                          END;

    IF IM.INF < 0.0 THEN  BEGIN   { 0 IN IM }
                            { AUFSPALTUNG IN 2 POSITIVE INTERVALLE }
                            wq:= INTVAL( 0.0, -IM.INF );
                            w := INTVAL( 0.0, IM.SUP );
                            fall:= 2
                          END;
    IF RE.INF < 0.0 THEN  BEGIN   { 0 IN RE }
                            vq:= INTVAL( 0.0, -RE.INF );
                            v := INTVAL( 0.0, RE.SUP );
                            fall:= fall + 1
                          END;

    CASE fall OF
      0 : r:= csp( RE, IM );                            { z >= 0 }
      1 : r:= csp( v, IM ) +* tausch( csp( vq, IM ) );  { 0 IN RE, IM >= 0 }
      2 : IF tau THEN
          BEGIN
            tau:= FALSE;
            { TAUSCHEN VOR DER VEREINIGUNG, DAMIT REALTEIL POSITIV }
            r:= tausch( csp( RE, w ) ) 
                   +* ( -tausch( CONJ( csp( RE, wq ) ) ) )
          END
          ELSE
            r:= csp( RE, w ) +* CONJ( csp( RE, wq ) );
                                     { 0 IN IM RE >= 0 }
      3 : r:= csp( v, w ) +* CONJ( csp( v, wq ) )
               +* tausch( csp( vq, w ) ) +* CONJ( tausch( csp( vq, wq ) ) )
                                    { 0 IN z }
    END; { CASE }
  END{ WITH};

  IF tau  THEN r:= tausch( r );
  IF quer THEN SQRT:= CONJ( r ) ELSE SQRT:= r

END;  { SQRT }


 
 
{---------------------------------------------------------------------------}
{    5.5 Exponentialfunktion                                                }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION EXP( z : CINTERVAL ) : CINTERVAL;

VAR w : INTERVAL;

BEGIN
  w:= EXP( z.RE );
  EXP:= COMPL( w * COS(z.IM), w * SIN(z.IM) )
END;

 


{---------------------------------------------------------------------------}
{    5.6 Logarithmus                                                        }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION LN( z : CINTERVAL ) : CINTERVAL;

{ BENUTZT COMPL, ARG }

CONST ueberlaufgrenze = 1E49;
      unterlaufgrenze = 1E-50;
      unterlaufbremse = 1E50;

VAR c              : INTERVAL;
    re_abs, im_abs : REAL;

{ Da die Funktion ABS mit einem Eingabeargument vom Typ INTERVAL            }
{ nun ein Intervall liefert, wurde die alte Funktion ABS, die einen         } 
{ REAL-Wert lieferte in RIABS umbenannt und hier eingefuegt.          -sg-  }

  FUNCTION RIABS( I : INTERVAL ) : REAL;
  BEGIN
    IF ABS(I.INF) > ABS(I.SUP) THEN RIABS:= ABS( I.INF )
                               ELSE RIABS:= ABS( I.SUP )
  END;


BEGIN { LN }
  LN.IM:= ARG(z);
  re_abs:= RIABS(z.RE);
  im_abs:= RIABS(z.IM);
  IF ( re_abs > ueberlaufgrenze ) OR ( im_abs > ueberlaufgrenze ) THEN
  BEGIN            {UEBERLAUFBEHANDLUNG}
    z:= z * unterlaufgrenze;
    c:= 50.0 * LN( INTVAL(10.0) )
  END
  ELSE
    IF ( re_abs < unterlaufgrenze ) AND ( im_abs < unterlaufgrenze ) THEN
    BEGIN       { Unterlaufbehandlung }
      z:= z * unterlaufbremse;
      c:= -50.0 * LN( INTVAL(10.0) )
    END
    ELSE
      c:= 0.0;
  LN.RE:= LN( SQR(z.RE) + SQR(z.IM) ) * 0.5 + c
END;
 


 
{---------------------------------------------------------------------------}
{    5.7 Sinus                                                              }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION SIN( z : CINTERVAL ) : CINTERVAL;

VAR isinh, icosh     : INTERVAL;
    sup, inf, ib, sb : REAL ;

BEGIN 
  isinh.INF:= PRED( SINH(z.IM.INF) );
  isinh.SUP:= SUCC( SINH(z.IM.SUP) );

  ib:= ABS( z.IM.INF );
  sb:= ABS( z.IM.SUP );

  IF ib <= sb THEN BEGIN
                     inf:= ib;
                     sup:= sb
                   END
              ELSE BEGIN
                     inf:= sb;
                     sup:= ib
                   END;

  IF 0.0 IN z.IM THEN inf:=0.0; 

  icosh.INF:= PRED( COSH(inf) );
  icosh.SUP:= SUCC( COSH(sup) );

  SIN:= COMPL( SIN(z.RE) * icosh, COS(z.RE) * isinh )
END;
 


 
{---------------------------------------------------------------------------}
{    5.8 Cosinus                                                            }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION COS( z : CINTERVAL ) : CINTERVAL;

VAR isinh, icosh     : INTERVAL ;
    sup, inf, ib, sb : REAL ;

BEGIN 
  isinh.INF:= PRED( SINH(z.IM.INF) );
  isinh.SUP:= SUCC( SINH(z.IM.SUP) );

  ib:= ABS( z.IM.INF );
  sb:= ABS( z.IM.SUP );

  IF ib <= sb THEN BEGIN
                     inf:= ib;
                     sup:= sb
                   END
              ELSE BEGIN
                     inf:= sb;
                     sup:= ib
                   END;

  IF 0.0 IN z.IM THEN inf:=0.0; 

  icosh.INF:= PRED( COSH(inf) );
  icosh.SUP:= SUCC( COSH(sup) );

  COS:= COMPL( COS(z.RE) * icosh, -SIN(z.RE) * isinh )
END;
 


 
{---------------------------------------------------------------------------}
{    5.9 Arkustangens                                                       }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCTAN( z : CINTERVAL ) : CINTERVAL;

{ Fehler nicht begrenzbar , falls ABS( z ) nahe 1 , Fehlermeldung Division
     durch 0 , falls z = +- i , vorzeitiger Ueberlauf moeglich }

VAR z1     : CINTERVAL;
    s1, s2 : INTERVAL;

BEGIN
  { Keine Sonderbehandlung fuer z.IM = [0,0] }
  z1.IM:= z.RE + z.RE;
  z1.RE:= ##( INTVAL(1.0) - z.RE * z.RE - z.IM * z.IM );

  ARCTAN.RE:= ARG(z1) * 0.5;     { Realteil }

  s1:= ##( INTVAL(1.0) + z.RE*z.RE + z.IM*z.IM + INTVAL(2.0)*z.IM );
  s2:= ##( INTVAL(1.0) + z.RE*z.RE + z.IM*z.IM - INTVAL(2.0)*z.IM );

  ARCTAN.IM:= LN( s1 / s2 ) * 0.25
END;
 




{---------------------------------------------------------------------------}
{    5.10 Zusaetzliche Standardfunktionen                                   }
{---------------------------------------------------------------------------}


{---------------------------------------------------------------------------}
{    5.10.1 EXP2                                                            }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION EXP2  ( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   EXP2:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.2 EXP10                                                           }
{---------------------------------------------------------------------------}



GLOBAL FUNCTION EXP10 ( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   EXP10:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.3 LOG2                                                            }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION LOG2  ( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   LOG2:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.4 LOG10                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION LOG10 ( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   LOG10:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.5 TAN                                                             }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION TAN   ( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   TAN:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.6 COT                                                             }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION COT   ( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   COT:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.7 ARCSIN                                                          }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCSIN( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCSIN:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.8 ARCCOS                                                          }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCCOS( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCCOS:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.9 ARCTAN2                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCTAN2( VAR x,y : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCTAN2:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.10 ARCCOT                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCCOT( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCCOT:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.11 SINH                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION SINH  ( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   SINH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.12 COSH                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION COSH  ( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   COSH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.13 TANH                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION TANH  ( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   TANH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.14 COTH                                                           }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION COTH  ( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   COTH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.15 ARSINH                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARSINH( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   ARSINH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.16 ARCOSH                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCOSH( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCOSH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.17 ARTANH                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARTANH( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   ARTANH:= X;
END;


{---------------------------------------------------------------------------}
{    5.10.18 ARCOTH                                                         }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION ARCOTH( VAR x : CINTERVAL ) : CINTERVAL;
BEGIN
   _ci_MATH_ERROR( 250 );  { Function not yet implemented }
   ARCOTH:= X;
END;


$on


 
{---------------------------------------------------------------------------}
{ 6. Ein- / Ausgabe                                                         }
{---------------------------------------------------------------------------}
            



GLOBAL PROCEDURE READ  ( VAR F : TEXT; VAR A : CINTERVAL );
VAR zeichen : CHAR;

  PROCEDURE skipblanks;
  BEGIN
    WHILE F^ = ' ' DO READ( F, zeichen )
  END;

BEGIN  { READ }
  skipblanks;
  IF F^ <> '('  THEN
  BEGIN
    READ ( F, A.RE );
    A.IM:= 0.0;
  END
  ELSE BEGIN
    READ( F, zeichen );                  { '(' ueberlesen }
    READ( F, A.RE );
    skipblanks;
    IF F^ <> ',' THEN _ci_MATH_ERROR (92);
    READ( F, zeichen );                  { ',' ueberlesen }
    READ( F, A.IM );
    skipblanks;
    IF F^ <> ')' THEN _ci_MATH_ERROR (92);
    READ( F, zeichen )                   { ')' ueberlesen }
  END
END;




GLOBAL PROCEDURE WRITE ( VAR F : TEXT; A : CINTERVAL );

BEGIN
  WRITELN( F, '( ', A.RE, ','  );
  WRITE  ( F, '  ', A.IM, ' )' );
END;





{---------------------------------------------------------------------------}
{
{  Zusatz zu :
{
{---------------------------------------------------------------------------}
{    3.3.4 Vergleiche CINTERVAL mit CINTERVAL                               }
{---------------------------------------------------------------------------}



GLOBAL OPERATOR IN ( VAR A, B : CINTERVAL ) INCIRCIR : BOOLEAN;
 
BEGIN
  INCIRCIR:=      ( A.RE.INF > B.RE.INF ) AND ( A.RE.SUP < B.RE.SUP )
             AND  ( A.IM.INF > B.IM.INF ) AND ( A.IM.SUP < B.IM.SUP ) ;
END;


{---------------------------------------------------------------------------}
{
{  Zusatz zu :
{
{---------------------------------------------------------------------------}
{ 2. Spezielle Funktionen                                                   }
{---------------------------------------------------------------------------}
{    2.4 Epsilon - Aufblaehung                                              }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION BLOW ( VAR A : CINTERVAL; EPS : REAL ) : CINTERVAL;

VAR B : CINTERVAL;

BEGIN
   B:= (1.0+EPS)*A - EPS*A;
   BLOW.RE.INF:= PRED( B.RE.INF );
   BLOW.RE.SUP:= SUCC( B.RE.SUP );
   BLOW.IM.INF:= PRED( B.IM.INF );
   BLOW.IM.SUP:= SUCC( B.IM.SUP );
END;



END.   { of module CI_ARI }
