{
VOLLSTAENDIG: JA
SYNTAKTISCH: NEIN
AUSGETESTET: NEIN
BEMERKUNGEN:
}




MODULE mvci_ari; {Komplexe Intervallmatrizen und -vektoren, Stand : 10.12.91}


USE i_ari, ci_ari, mv_ari, mvc_ari, mvi_ari;


$off

PROCEDURE _MATH_ERROR ( errnum : INTEGER );
  EXTERNAL;

$on



{---------------------------------------------------------------------------}
{ 0. Vereinbarungen                                                         }
{---------------------------------------------------------------------------}



$off

GLOBAL TYPE CIVECTOR = GLOBAL DYNAMIC ARRAY [*] OF CINTERVAL;
            CIMATRIX = GLOBAL DYNAMIC ARRAY [*] OF CIVECTOR;

$on


{---------------------------------------------------------------------------}
{ 1. Transferfunktionen                                                     }
{---------------------------------------------------------------------------}
{    1.0 Zuweisungen                                                        }
{---------------------------------------------------------------------------}



GLOBAL OPERATOR := ( VAR A : CIVECTOR; B : REAL );

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  A[i]:= B
END;



GLOBAL OPERATOR := ( VAR A : CIVECTOR; VAR B : COMPLEX );

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  A[i]:= B
END;



GLOBAL OPERATOR := ( VAR A : CIVECTOR; VAR B : INTERVAL );

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  A[i]:= B
END;



GLOBAL OPERATOR := ( VAR A : CIVECTOR; VAR B : CINTERVAL );

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  A[i]:= B
END;




GLOBAL OPERATOR := ( VAR A : CIMATRIX; B : REAL );

VAR i : INTEGER;
    h : CIVECTOR[LB(A,2)..UB(A,2)];

BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO  h[i]:= B;
  FOR i:= LB(A,1) TO UB(A,1) DO  A[i]:= h
END;



GLOBAL OPERATOR := ( VAR A : CIMATRIX; VAR B : COMPLEX );

VAR i : INTEGER;
    h : CIVECTOR[LB(A,2)..UB(A,2)];

BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO  h[i]:= B;
  FOR i:= LB(A,1) TO UB(A,1) DO  A[i]:= h
END;



GLOBAL OPERATOR := ( VAR A : CIMATRIX; VAR B : INTERVAL );

VAR i : INTEGER;
    h : CIVECTOR[LB(A,2)..UB(A,2)];

BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO  h[i]:= B;
  FOR i:= LB(A,1) TO UB(A,1) DO  A[i]:= h
END;



GLOBAL OPERATOR := ( VAR A : CIMATRIX; VAR B : CINTERVAL );

VAR i : INTEGER;
    h : CIVECTOR[LB(A,2)..UB(A,2)];

BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO  h[i]:= B;
  FOR i:= LB(A,1) TO UB(A,1) DO  A[i]:= h
END;




GLOBAL OPERATOR := ( VAR A : CIVECTOR; VAR B : RVECTOR );

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A); 
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  A[i]:= B[i+d]
END;



GLOBAL OPERATOR := ( VAR A : CIVECTOR; VAR B : CVECTOR );

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A); 
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  A[i]:= B[i+d]
END;



GLOBAL OPERATOR := ( VAR A : CIVECTOR; VAR B : IVECTOR );

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A); 
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  A[i]:= B[i+d]
END;



GLOBAL OPERATOR := ( VAR A : CIMATRIX; VAR B : RMATRIX );

VAR i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
     FOR i:= al1 TO au1 DO  A[i]:= B[i+d]
END;



GLOBAL OPERATOR := ( VAR A : CIMATRIX; VAR B : CMATRIX );

VAR i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
     FOR i:= al1 TO au1 DO  A[i]:= B[i+d]
END;



GLOBAL OPERATOR := ( VAR A : CIMATRIX; VAR B : IMATRIX );

VAR i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
     FOR i:= al1 TO au1 DO  A[i]:= B[i+d]
END;



{---------------------------------------------------------------------------}
{    1.1  Komplexe - Transferfunktionen                                     }
{---------------------------------------------------------------------------}
{         1.1.1 Komplexe - Transferfunktionen fuer Vektoren                 }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION COMPL( VAR A : IVECTOR ) : CIVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  COMPL[i]:= A[i]
END;




GLOBAL FUNCTION COMPL( VAR A : RVECTOR; VAR B : IVECTOR ) : CIVECTOR [LB(A)..UB(A)];

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO  COMPL[i]:= COMPL( A[i], B[i+d] )
END;




GLOBAL FUNCTION COMPL( VAR A : IVECTOR; VAR B : RVECTOR ) : CIVECTOR [LB(A)..UB(A)];

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO  COMPL[i]:= COMPL( A[i], B[i+d] )
END;





GLOBAL FUNCTION COMPL( VAR A, B : IVECTOR ) : CIVECTOR [LB(A)..UB(A)];

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO  COMPL[i]:= COMPL( A[i], B[i+d] )
END;



GLOBAL FUNCTION RE ( VAR A : CIVECTOR ) : IVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  RE[i]:= A[i].RE
END;



   
GLOBAL FUNCTION IM ( VAR A : CIVECTOR ) : IVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  IM[i]:= A[i].IM
END;



   
{---------------------------------------------------------------------------}
{         1.1.2 Komplexe - Transferfunktionen fuer Matrizen                 }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION COMPL( VAR A : IMATRIX ) : CIMATRIX [LB(A,1)..UB(A,1),
                                                     LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO   COMPL[z,s]:= A[z,s]
END;

 
 
GLOBAL FUNCTION COMPL( VAR A : RMATRIX; VAR  B : IMATRIX ) : CIMATRIX [LB(A,1)..UB(A,1),
                                                                       LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

  d1:= bl1 - al1;
  d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COMPL[z,s]:= COMPL( A[z,s], B[z+d1,s+d2] )
END;



 
GLOBAL FUNCTION COMPL( VAR A : IMATRIX; VAR  B : RMATRIX ) : CIMATRIX [LB(A,1)..UB(A,1),
                                                                       LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

  d1:= bl1 - al1;
  d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COMPL[z,s]:= COMPL( A[z,s], B[z+d1,s+d2] )
END;


 
 
GLOBAL FUNCTION COMPL( VAR A, B : IMATRIX ) : CIMATRIX [LB(A,1)..UB(A,1),
                                                        LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

  d1:= bl1 - al1;
  d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COMPL[z,s]:= COMPL( A[z,s], B[z+d1,s+d2] )
END;


 
GLOBAL FUNCTION RE ( VAR A : CIMATRIX ) : IMATRIX [LB(A,1)..UB(A,1),
                                                   LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO   RE[z,s]:= A[z,s].RE
END;



   
GLOBAL FUNCTION IM ( VAR A : CIMATRIX ) : IMATRIX [LB(A,1)..UB(A,1),
                                                   LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO   IM[z,s]:= A[z,s].IM
END;



   
{---------------------------------------------------------------------------}
{    1.2  Intervall - Transferfunktionen                                    }
{---------------------------------------------------------------------------}
{         1.2.1 Intervall - Transferfunktionen fuer Vektoren                }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION INTVAL( VAR A : CVECTOR ) : CIVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  INTVAL[i]:= A[i]
END;



GLOBAL FUNCTION INTVAL( VAR A : RVECTOR; VAR B : CVECTOR ) : CIVECTOR [LB(A) ..UB(A)];

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO  INTVAL[i]:= INTVAL( A[i], B[i+d] )
END;




GLOBAL FUNCTION INTVAL( VAR A : CVECTOR; VAR B : RVECTOR ) : CIVECTOR [LB(A) ..UB(A)];

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO  INTVAL[i]:= INTVAL( A[i], B[i+d] )
END;




GLOBAL FUNCTION INTVAL( VAR A, B : CVECTOR ) : CIVECTOR [LB(A) ..UB(A)];

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO  INTVAL[i]:= INTVAL( A[i], B[i+d] )
END;



GLOBAL FUNCTION INF ( VAR A : CIVECTOR  ) : CVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO INF[i]:= INF( A[i] )
END;



 
GLOBAL FUNCTION SUP ( VAR A : CIVECTOR  ) : CVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO SUP[i]:= SUP( A[i] )
END;



   
{---------------------------------------------------------------------------}
{         1.2.2 Intervall - Transferfunktionen fuer Matrizen                }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION INTVAL( VAR A : CMATRIX ) : CIMATRIX [LB(A,1)..UB(A,1),
                                                      LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO   INTVAL[z,s]:= A[z,s]
END;




GLOBAL FUNCTION INTVAL( VAR A, B : CMATRIX ) : CIMATRIX [LB(A,1)..UB(A,1),
                                                         LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

  d1:= bl1 - al1;
  d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  INTVAL[z,s]:= INTVAL( A[z,s], B[z+d1,s+d2] )
END;



GLOBAL FUNCTION INF ( VAR A : CIMATRIX  ) : CMATRIX [LB(A,1)..UB(A,1),
                                                     LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO   INF[z,s]:= INF( A[z,s] )
END;




GLOBAL FUNCTION SUP ( VAR A : CIMATRIX  ) : CMATRIX [LB(A,1)..UB(A,1),
                                                     LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO   SUP[z,s]:= SUP( A[z,s] )
END;




{---------------------------------------------------------------------------}
{ 2. Spezielle Funktionen                                                   }
{---------------------------------------------------------------------------}
{    2.1  Skalarprodukt                                                     }
{---------------------------------------------------------------------------}


         {    ------------>    entfaellt    >--------------- }       


{---------------------------------------------------------------------------}
{    2.2  Spezielle Intervallfunktionen                                     }
{---------------------------------------------------------------------------}
{         2.2.1 Mittelpunkt                                                 }
{---------------------------------------------------------------------------}
 


GLOBAL FUNCTION MID( VAR A : CIVECTOR ) : CVECTOR[LB(A)..UB(A)];
 
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO   MID[i]:= MID( A[i] )
END;
 

 
GLOBAL FUNCTION MID( VAR A : CIMATRIX ) : CMATRIX[LB(A,1)..UB(A,1),
                                                  LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MID[z,s]:= MID( A[z,s] )
END;  




{---------------------------------------------------------------------------}
{         2.2.2 Durchmesser                                                 }
{---------------------------------------------------------------------------}
 



GLOBAL FUNCTION DIAM( VAR A : CIVECTOR ) : RVECTOR[LB(A)..UB(A)];
 
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO   DIAM[i]:= DIAM( A[i] )
END;
 


 
GLOBAL FUNCTION DIAM( VAR A : CIMATRIX ): RMATRIX[LB(A,1)..UB(A,1),
                                                  LB(A,2)..UB(A,2)];
                                  
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIAM[z,s]:= DIAM( A[z,s] )
END; 

 


{---------------------------------------------------------------------------}
{    2.3  Spezielle Komplexe Funktionen                                     }
{---------------------------------------------------------------------------}
{         2.3.1 Konjugation                                                 }
{---------------------------------------------------------------------------}



 
GLOBAL FUNCTION CONJ( VAR A : CIVECTOR ) : CIVECTOR[LB(A)..UB(A)];
 
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO   CONJ[i]:= CONJ( A[i] )
END;
 


 
GLOBAL FUNCTION CONJ( VAR A : CIMATRIX ) : CIMATRIX[LB(A,1)..UB(A,1),
                                                    LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO   CONJ[z,s]:= CONJ( A[z,s] )
END;  



{---------------------------------------------------------------------------}
{         2.3.2 Transponierte                                               }
{---------------------------------------------------------------------------}



 
GLOBAL FUNCTION TRANSP ( VAR A : CIMATRIX ) : CIMATRIX [LB(A,2)..UB(A,2),
                                                        LB(A,1)..UB(A,1)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,2) TO UB(A,2) DO
  FOR s:= LB(A,1) TO UB(A,1) DO   TRANSP[z,s]:= A[s,z]
END;




{---------------------------------------------------------------------------}
{         2.3.3 Hermitesche Matrix                                          }
{---------------------------------------------------------------------------}



 
GLOBAL FUNCTION HERM ( VAR A: CIMATRIX ) : CIMATRIX [LB(A,2)..UB(A,2),
                                                     LB(A,1)..UB(A,1)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,2) TO UB(A,2) DO
  FOR s:= LB(A,1) TO UB(A,1) DO  HERM[z,s]:= CONJ( A[s,z] )
END;




{---------------------------------------------------------------------------}
{    2.4  Null - Arrays                                                     }
{---------------------------------------------------------------------------}
{         2.4.1 Null - Vektoren                                             }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION NULL ( VAR A : CIVECTOR ) : RVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO NULL[i]:= 0.0
END;




{---------------------------------------------------------------------------}
{         2.4.2 Null - Matrizen                                             }
{---------------------------------------------------------------------------}





GLOBAL FUNCTION NULL ( VAR A : CIMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                     LB(A,2)..UB(A,2)];
VAR i : INTEGER;
    h : RVECTOR[LB(A,2)..UB(A,2)];

BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO     h[i]:= 0.0;
  FOR i:= LB(A,1) TO UB(A,1) DO  NULL[i]:= h;
END;




GLOBAL FUNCTION NULL ( VAR A,B : CIMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                       LB(B,2)..UB(B,2)];
VAR i : INTEGER;
    h : RVECTOR[LB(B,2)..UB(B,2)];

BEGIN
  FOR i:= LB(B,2) TO UB(B,2) DO     h[i]:= 0.0;
  FOR i:= LB(A,1) TO UB(A,1) DO  NULL[i]:= h;
END;






{---------------------------------------------------------------------------}
{    2.5  Einheitsmatrizen                                                  }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION ID ( VAR A : CIMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                   LB(A,2)..UB(A,2)];
VAR i,bl1,bl2,bu1,bu2,d : INTEGER;
    h : RVECTOR[LB(A,2)..UB(A,2)];

BEGIN
  bl1:= LB(A,1);  bu1:= UB(A,1);
  bl2:= LB(A,2);  bu2:= UB(A,2);

  d:= bl2 - bl1;

  FOR i:= bl2 TO bu2 DO   h[i]:= 0.0;
  FOR i:= bl1 TO bu1 DO  ID[i]:= h;   { Ganze Matrix mit 0 fuellen. }

  IF ( bu2-bl2 ) < ( bu1-bl1 ) THEN  FOR i:= bl2 TO bu2 DO  ID[i-d,i]:= 1.0
                               ELSE  FOR i:= bl1 TO bu1 DO  ID[i,i+d]:= 1.0;
END;



GLOBAL FUNCTION ID ( VAR A,B : CIMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                     LB(B,2)..UB(B,2)];
VAR i,bl1,bl2,bu1,bu2,d : INTEGER;
    h : RVECTOR[LB(B,2)..UB(B,2)];

BEGIN
  bl1:= LB(A,1);  bu1:= UB(A,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

  d:= bl2 - bl1;

  FOR i:= bl2 TO bu2 DO   h[i]:= 0.0;
  FOR i:= bl1 TO bu1 DO  ID[i]:= h;   { Ganze Matrix mit 0 fuellen. }

  IF ( bu2-bl2 ) < ( bu1-bl1 ) THEN  FOR i:= bl2 TO bu2 DO  ID[i-d,i]:= 1.0
                               ELSE  FOR i:= bl1 TO bu1 DO  ID[i,i+d]:= 1.0;
END;
   

 

{---------------------------------------------------------------------------}
{ 3. Vergleiche                                                             }
{---------------------------------------------------------------------------}
{    3.1  Vergleiche RVECTOR, CVECTOR mit IVECTOR, CIVECTOR                 }
{---------------------------------------------------------------------------}
{SEKTOR V34                                                                 }
{---------------------------------------------------------------------------}
{         3.1.1 Vergleiche RVECTOR mit IVECTOR                              }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         3.1.2 Vergleiche RVECTOR mit CIVECTOR                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A: RVECTOR; VAR B: CIVECTOR) INVRVCIR: BOOLEAN;

VAR drin        : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
      i := al;
    drin:= TRUE;
    WHILE  drin  AND ( i <= au ) DO
      IF A[i] IN B[i+d] THEN    i:= SUCC(i)
                        ELSE drin:= FALSE;
    INVRVCIR:= drin
  END
END;




GLOBAL OPERATOR =  ( VAR A : RVECTOR; VAR B : CIVECTOR ) EQVRVCIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVRVCIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : RVECTOR; VAR B : CIVECTOR ) NEVRVCIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVRVCIR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{         3.1.3 Vergleiche CVECTOR mit IVECTOR                              }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A : CVECTOR; VAR B : IVECTOR) INVCRVIR: BOOLEAN;

VAR drin        : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
      i := al;
    drin:= TRUE;
    WHILE  drin  AND ( i <= au ) DO
      IF A[i] IN B[i+d] THEN    i:= SUCC(i)
                        ELSE drin:= FALSE;
    INVCRVIR:= drin
  END
END;




GLOBAL OPERATOR =  ( VAR A : CVECTOR; VAR B : IVECTOR ) EQVCRVIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVCRVIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : CVECTOR; VAR B : IVECTOR ) NEVCRVIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVCRVIR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{         3.1.4 Vergleiche CVECTOR mit CIVECTOR                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A : CVECTOR; VAR B : CIVECTOR) INVCRVCIR: BOOLEAN;

VAR drin        : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
      i := al;
    drin:= TRUE;
    WHILE  drin  AND ( i <= au ) DO
      IF A[i] IN B[i+d] THEN    i:= SUCC(i)
                        ELSE drin:= FALSE;
    INVCRVCIR:= drin
  END
END;




GLOBAL OPERATOR =  ( VAR A : CVECTOR; VAR B : CIVECTOR ) EQVCRVCIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVCRVCIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : CVECTOR; VAR B : CIVECTOR ) NEVCRVCIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVCRVCIR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{    3.2  Vergleiche IVECTOR, CIVECTOR mit RVECTOR, CVECTOR                 }
{---------------------------------------------------------------------------}
{SEKTOR V43                                                                 }
{---------------------------------------------------------------------------}
{         3.2.1 Vergleiche IVECTOR mit RVECTOR                              }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }



          
{---------------------------------------------------------------------------}
{         3.2.2 Vergleiche IVECTOR mit CVECTOR                              }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR =  ( VAR A : IVECTOR; VAR B : CVECTOR ) EQVIRVCR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVIRVCR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : IVECTOR; VAR B : CVECTOR ) NEVIRVCR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVIRVCR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{         3.2.3 Vergleiche CIVECTOR mit RVECTOR                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR =  ( VAR A : CIVECTOR; VAR B : RVECTOR ) EQVCIRVR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVCIRVR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : CIVECTOR; VAR B : RVECTOR ) NEVCIRVR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVCIRVR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{         3.2.4 Vergleiche CIVECTOR mit CVECTOR                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR =  ( VAR A : CIVECTOR; VAR B : CVECTOR ) EQVCIRVCR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVCIRVCR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : CIVECTOR; VAR B : CVECTOR ) NEVCIRVCR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVCIRVCR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{    3.3  Vergleiche IVECTOR, CIVECTOR mit IVECTOR, CIVECTOR                }
{---------------------------------------------------------------------------}
{SEKTOR V44                                                                 }
{---------------------------------------------------------------------------}
{         3.3.1 Vergleiche IVECTOR mit IVECTOR                              }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         3.3.2 Vergleiche IVECTOR mit CIVECTOR                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR >< ( VAR A : IVECTOR; VAR B : CIVECTOR) DISJVIRVCIR: BOOLEAN;

VAR disjunkt    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    disjunkt:= FALSE;
    REPEAT
      IF A[i] >< B[i+d] THEN disjunkt:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  disjunkt  OR ( i > au );
    DISJVIRVCIR:= disjunkt
  END
END;




GLOBAL OPERATOR =  ( VAR A : IVECTOR; VAR B : CIVECTOR ) EQVIRVCIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVIRVCIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : IVECTOR; VAR B : CIVECTOR ) NEVIRVCIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVIRVCIR:= ungleich
  END
END;




GLOBAL OPERATOR <= ( VAR A : IVECTOR ; VAR B : CIVECTOR ) LEVIRVCIR : BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au ) DO
      IF A[i] <= B[i+d] THEN         i:= SUCC(i)
                        ELSE teilmenge:= FALSE;
    LEVIRVCIR:= teilmenge
  END
END;




GLOBAL OPERATOR < ( VAR A : IVECTOR; VAR B : CIVECTOR ) LTVIRVCIR : BOOLEAN;
 
BEGIN
  LTVIRVCIR:= ( A <= B ) AND ( A <> B ) 
END;




GLOBAL OPERATOR >= ( VAR A : IVECTOR ; VAR B : CIVECTOR ) GEVIRVCIR : BOOLEAN;

VAR obermenge   : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    obermenge:= TRUE;
    WHILE  obermenge  AND ( i <= au ) DO
      IF A[i] >= B[i+d] THEN         i:= SUCC(i)
                        ELSE obermenge:= FALSE; 
    GEVIRVCIR:= obermenge
  END
END;




GLOBAL OPERATOR > ( VAR A : IVECTOR; VAR B : CIVECTOR ) GTVIRVCIR : BOOLEAN;
 
BEGIN
  GTVIRVCIR:= ( A >= B ) AND ( A <> B ) 
END;




{---------------------------------------------------------------------------}
{         3.3.3 Vergleiche CIVECTOR mit IVECTOR                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR >< ( VAR A : CIVECTOR; VAR B : IVECTOR ) DISJVCIRVIR: BOOLEAN;

VAR disjunkt    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    disjunkt:= FALSE;
    REPEAT
      IF A[i] >< B[i+d] THEN disjunkt:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  disjunkt  OR ( i > au );
    DISJVCIRVIR:= disjunkt
  END
END;




GLOBAL OPERATOR =  ( VAR A : CIVECTOR; VAR B : IVECTOR ) EQVCIRVIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVCIRVIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : CIVECTOR; VAR B : IVECTOR ) NEVCIRVIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVCIRVIR:= ungleich
  END
END;




GLOBAL OPERATOR <= ( VAR A : CIVECTOR; VAR B : IVECTOR ) LEVCIRVIR : BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au ) DO
      IF A[i] <= B[i+d] THEN         i:= SUCC(i)
                        ELSE teilmenge:= FALSE; 
    LEVCIRVIR:= teilmenge
  END
END;




GLOBAL OPERATOR < ( VAR A : CIVECTOR; VAR B : IVECTOR ) LTVCIRVIR : BOOLEAN;
 
BEGIN
  LTVCIRVIR:= ( A <= B ) AND ( A <> B ) 
END;




GLOBAL OPERATOR >= ( VAR A : CIVECTOR; VAR B : IVECTOR ) GEVCIRVIR : BOOLEAN;

VAR obermenge   : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    obermenge:= TRUE;
    WHILE  obermenge  AND ( i <= au ) DO
      IF A[i] >= B[i+d] THEN         i:= SUCC(i)
                        ELSE obermenge:= FALSE;
    GEVCIRVIR:= obermenge
  END
END;




GLOBAL OPERATOR > ( VAR A : CIVECTOR; VAR B : IVECTOR ) GTVCIRVIR : BOOLEAN;

BEGIN
  GTVCIRVIR:= ( A >= B ) AND ( A <> B ) 
END;




{---------------------------------------------------------------------------}
{         3.3.4 Vergleiche CIVECTOR mit CIVECTOR                            }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR >< ( VAR A,B : CIVECTOR) DISJVCIRVCIR: BOOLEAN;

VAR disjunkt    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    disjunkt:= FALSE;
    REPEAT
      IF A[i] >< B[i+d] THEN disjunkt:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  disjunkt  OR ( i > au );
    DISJVCIRVCIR:= disjunkt
  END
END;




GLOBAL OPERATOR =  ( VAR A, B : CIVECTOR ) EQVCIRVCIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVCIRVCIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A, B : CIVECTOR ) NEVCIRVCIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVCIRVCIR:= ungleich
  END
END;




GLOBAL OPERATOR <= ( VAR A,B : CIVECTOR ) LEVCIRVCIR : BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au ) DO
      IF A[i] <= B[i+d] THEN         i:= SUCC(i)
                        ELSE teilmenge:= FALSE; 
    LEVCIRVCIR:= teilmenge
  END
END;




GLOBAL OPERATOR < ( VAR A,B : CIVECTOR ) LTVCIRVCIR : BOOLEAN;
 
BEGIN
  LTVCIRVCIR:= ( A <= B ) AND ( A <> B ) 
END;




GLOBAL OPERATOR >= ( VAR A,B: CIVECTOR ) GEVCIRVCIR : BOOLEAN;

VAR obermenge   : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    obermenge:= TRUE;
    WHILE  obermenge  AND ( i <= au ) DO
      IF A[i] >= B[i+d] THEN         i:= SUCC(i)
                        ELSE obermenge:= FALSE; 
    GEVCIRVCIR:= obermenge
  END
END;




GLOBAL OPERATOR > ( VAR A,B : CIVECTOR ) GTVCIRVCIR : BOOLEAN;
BEGIN
  GTVCIRVCIR:= ( A >= B ) AND ( A <> B ) 
END;




{---------------------------------------------------------------------------}
{    3.4  Vergleiche RMATRIX, CMATRIX mit IMATRIX, CIMATRIX                 }
{---------------------------------------------------------------------------}
{SEKTOR V56                                                                 }
{---------------------------------------------------------------------------}
{         3.4.1 Vergleiche RMATRIX mit IMATRIX                              }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         3.4.2 Vergleiche RMATRIX mit CIMATRIX                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A : RMATRIX; VAR B : CIMATRIX) INMRMCIR : BOOLEAN;

VAR drin        : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
      i := al1;
    drin:= TRUE;
    WHILE  drin  AND ( i <= au1 ) DO
      IF A[i] IN B[i+d] THEN     i:= SUCC(i)
                        ELSE  drin:= FALSE;
    INMRMCIR:= drin
  END
END;




GLOBAL OPERATOR =  ( VAR A : RMATRIX; VAR B : CIMATRIX ) EQMRMCIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMRMCIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : RMATRIX; VAR B : CIMATRIX ) NEMRMCIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 ); 
    NEMRMCIR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{         3.4.3 Vergleiche CMATRIX mit IMATRIX                              }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A : CMATRIX; VAR B : IMATRIX) INMCRMIR : BOOLEAN;

VAR drin        : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
      i := al1;
    drin:= TRUE;
    WHILE  drin  AND ( i <= au1 ) DO
      IF A[i] IN B[i+d] THEN     i:= SUCC(i)
                        ELSE  drin:= FALSE; 
    INMCRMIR:= drin
  END
END;




GLOBAL OPERATOR =  ( VAR A : CMATRIX; VAR B : IMATRIX ) EQMCRMIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMCRMIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : CMATRIX; VAR B : IMATRIX ) NEMCRMIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 ); 
    NEMCRMIR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{         3.4.4 Vergleiche CMATRIX mit CIMATRIX                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A : CMATRIX; VAR B : CIMATRIX) INMCRMCIR : BOOLEAN;

VAR drin        : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
      i := al1;
    drin:= TRUE;
    WHILE  drin  AND ( i <= au1 ) DO
      IF A[i] IN B[i+d] THEN     i:= SUCC(i)
                        ELSE  drin:= FALSE; 
    INMCRMCIR:= drin
  END
END;




GLOBAL OPERATOR =  ( VAR A : CMATRIX; VAR B : CIMATRIX ) EQMCRMCIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMCRMCIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : CMATRIX; VAR B : CIMATRIX ) NEMCRMCIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 ); 
    NEMCRMCIR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{    3.5  Vergleiche IMATRIX, CIMATRIX mit RMATRIX, CMATRIX                 }
{---------------------------------------------------------------------------}
{SEKTOR V65                                                                 }
{---------------------------------------------------------------------------}
{         3.5.1 Vergleiche IMATRIX mit RMATRIX                              }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         3.5.2 Vergleiche IMATRIX mit CMATRIX                              }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR =  ( VAR A : IMATRIX; VAR B : CMATRIX ) EQMIRMCR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMIRMCR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : IMATRIX; VAR B : CMATRIX ) NEMIRMCR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 );
    NEMIRMCR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{         3.5.3 Vergleiche CIMATRIX mit RMATRIX                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR =  ( VAR A : CIMATRIX; VAR B : RMATRIX ) EQMCIRMR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMCIRMR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : CIMATRIX; VAR B : RMATRIX ) NEMCIRMR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 );
    NEMCIRMR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{         3.5.4 Vergleiche CIMATRIX mit CMATRIX                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR =  ( VAR A : CIMATRIX; VAR B : CMATRIX ) EQMCIRMCR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMCIRMCR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : CIMATRIX; VAR B : CMATRIX ) NEMCIRMCR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 );
    NEMCIRMCR:= ungleich
  END
END;




{---------------------------------------------------------------------------}
{    3.6  Vergleiche IMATRIX, CIMATRIX mit IMATRIX, CIMATRIX                }
{---------------------------------------------------------------------------}
{SEKTOR V66                                                                 }
{---------------------------------------------------------------------------}
{         3.6.1 Vergleiche IMATRIX mit IMATRIX                              }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         3.6.2 Vergleiche IMATRIX mit CIMATRIX                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR >< ( VAR A : IMATRIX; VAR B : CIMATRIX ) DISJMIRMCIR: BOOLEAN;

VAR disjunkt    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    disjunkt:= FALSE;
    REPEAT
      IF A[i] >< B[i+d] THEN disjunkt:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  disjunkt OR ( i > au1 ); 
    DISJMIRMCIR:= disjunkt
  END
END;




GLOBAL OPERATOR =  ( VAR A : IMATRIX; VAR B : CIMATRIX ) EQMIRMCIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMIRMCIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : IMATRIX; VAR B : CIMATRIX ) NEMIRMCIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 ); 
    NEMIRMCIR:= ungleich
  END
END;




GLOBAL OPERATOR <= ( VAR A : IMATRIX; VAR B : CIMATRIX ) LEMIRMCIR: BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i := al1;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au1 ) DO
      IF A[i] <= B[i+d] THEN          i:= SUCC(i)
                        ELSE  teilmenge:= FALSE;
    LEMIRMCIR:= teilmenge
  END
END;




GLOBAL OPERATOR < ( VAR A : IMATRIX; VAR B : CIMATRIX ) LTMIRMCIR: BOOLEAN;
 
BEGIN
  LTMIRMCIR:= ( A <= B ) AND ( A <> B )
END; 




GLOBAL OPERATOR >= ( VAR A : IMATRIX; VAR B : CIMATRIX ) GEMIRMCIR: BOOLEAN;

VAR obermenge   : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i := al1;
    obermenge:= TRUE;
    WHILE  obermenge  AND ( i <= au1 ) DO
      IF A[i] >= B[i+d] THEN          i:= SUCC(i)
                        ELSE  obermenge:= FALSE; 
    GEMIRMCIR:= obermenge
  END
END;




GLOBAL OPERATOR > ( VAR A : IMATRIX; VAR B : CIMATRIX ) GTMIRMCIR: BOOLEAN;
 
BEGIN
  GTMIRMCIR:= ( A >= B ) AND ( A <> B )
END;




{---------------------------------------------------------------------------}
{         3.6.3 Vergleiche CIMATRIX mit IMATRIX                             }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR >< ( VAR A : CIMATRIX; VAR B : IMATRIX ) DISJMCIRMIR: BOOLEAN;

VAR disjunkt    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    disjunkt:= FALSE;
    REPEAT
      IF A[i] >< B[i+d] THEN disjunkt:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  disjunkt OR ( i > au1 );
    DISJMCIRMIR:= disjunkt
  END
END;




GLOBAL OPERATOR =  ( VAR A : CIMATRIX; VAR B : IMATRIX ) EQMCIRMIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMCIRMIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A : CIMATRIX; VAR B : IMATRIX ) NEMCIRMIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 ); 
    NEMCIRMIR:= ungleich
  END
END;




GLOBAL OPERATOR <= ( VAR A : CIMATRIX; VAR B : IMATRIX ) LEMCIRMIR: BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i := al1;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au1 ) DO
      IF A[i] <= B[i+d] THEN          i:= SUCC(i)
                        ELSE  teilmenge:= FALSE;
    LEMCIRMIR:= teilmenge
  END
END;




GLOBAL OPERATOR < ( VAR A : CIMATRIX; VAR B : IMATRIX ) LTMCIRMIR: BOOLEAN;
 
BEGIN
  LTMCIRMIR:= ( A <= B ) AND ( A <> B )
END;




GLOBAL OPERATOR >= ( VAR A : CIMATRIX; VAR B : IMATRIX ) GEMCIRMIR: BOOLEAN;

VAR obermenge   : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i := al1;
    obermenge:= TRUE;
    WHILE  obermenge  AND ( i <= au1 ) DO
      IF A[i] >= B[i+d] THEN          i:= SUCC(i)
                        ELSE  obermenge:= FALSE;
    GEMCIRMIR:= obermenge
  END
END;




GLOBAL OPERATOR > ( VAR A : CIMATRIX; VAR B : IMATRIX ) GTMCIRMIR: BOOLEAN;
BEGIN
  GTMCIRMIR:= ( A >= B ) AND ( A <> B )
END;




{---------------------------------------------------------------------------}
{         3.6.4 Vergleiche CIMATRIX mit CIMATRIX                            }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR >< ( VAR A,B: CIMATRIX ) DISJMCIRMCIR: BOOLEAN;

VAR disjunkt    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    disjunkt:= FALSE;
    REPEAT
      IF A[i] >< B[i+d] THEN disjunkt:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  disjunkt OR ( i > au1 );
    DISJMCIRMCIR:= disjunkt
  END
END;




GLOBAL OPERATOR =  ( VAR A, B : CIMATRIX ) EQMCIRMCIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMCIRMCIR:= gleich
  END
END;




GLOBAL OPERATOR <> ( VAR A, B : CIMATRIX ) NEMCIRMCIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 ); 
    NEMCIRMCIR:= ungleich
  END
END;




GLOBAL OPERATOR <= ( VAR A,B : CIMATRIX ) LEMCIRMCIR: BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i := al1;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au1 ) DO
      IF A[i] <= B[i+d] THEN          i:= SUCC(i)
                        ELSE  teilmenge:= FALSE; 
    LEMCIRMCIR:= teilmenge
  END
END;




GLOBAL OPERATOR < ( VAR A,B: CIMATRIX ) LTMCIRMCIR: BOOLEAN;
 
BEGIN
  LTMCIRMCIR:= ( A <= B ) AND ( A <> B )
END;



GLOBAL OPERATOR >= ( VAR A,B: CIMATRIX ) GEMCIRMCIR: BOOLEAN;

VAR obermenge   : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i := al1;
    obermenge:= TRUE;
    WHILE  obermenge  AND ( i <= au1 ) DO
      IF A[i] >= B[i+d] THEN          i:= SUCC(i)
                        ELSE  obermenge:= FALSE; 
    GEMCIRMCIR:= obermenge
  END
END;




GLOBAL OPERATOR > ( VAR A,B: CIMATRIX ) GTMCIRMCIR: BOOLEAN;
BEGIN
  GTMCIRMCIR:= ( A >= B ) AND ( A <> B )
END;




{---------------------------------------------------------------------------}
{ 4. Arithmetische Operatoren ( + - * / ) und Verbandsoperatoren            }   
{---------------------------------------------------------------------------}
{    4.1  Monadische Operatoren                                             }
{---------------------------------------------------------------------------}
{         4.1.1 Monadische Operatoren fuer Vektoren                         }
{---------------------------------------------------------------------------}
{SEKTOR A04                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CIVECTOR ) PLUSVCIR : CIVECTOR [LB(A)..UB(A)];

BEGIN
  PLUSVCIR:= A
END;



   
GLOBAL OPERATOR - ( VAR A : CIVECTOR ) MINUSVCIR : CIVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO MINUSVCIR[i]:= -A[i]
END;




{---------------------------------------------------------------------------}
{         4.1.2 Monadische Operatoren fuer Matrizen                         }
{---------------------------------------------------------------------------}
{SEKTOR A06                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CIMATRIX ) PLUSMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                            LB(A,2)..UB(A,2)];
BEGIN
  PLUSMCIR:= A
END;

   


GLOBAL OPERATOR - ( VAR A : CIMATRIX ) MINUSMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO   MINUSMCIR[z,s]:= -A[z,s]
END;



   
{---------------------------------------------------------------------------}
{    4.2  Operatoren fuer REAL, COMPLEX mit IVECTOR, CIVECTOR               }
{---------------------------------------------------------------------------}
{SEKTOR A14                                                                 }
{---------------------------------------------------------------------------}
{         4.2.1  Operatoren fuer REAL mit IVECTOR                           }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.2.2  Operatoren fuer REAL mit CIVECTOR                          }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( A : REAL; VAR B : CIVECTOR )
                                       MULRVCIR : CIVECTOR [LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULRVCIR[i]:= A * B[i]
END;   




{---------------------------------------------------------------------------}
{         4.2.3  Operatoren fuer COMPLEX mit IVECTOR                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : COMPLEX; VAR B : IVECTOR ) 
                                            MULCRVIR : CIVECTOR[LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULCRVIR[i]:= A * B[i]
END;   




{---------------------------------------------------------------------------}
{         4.2.4  Operatoren fuer COMPLEX mit CIVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : COMPLEX; VAR B : CIVECTOR ) 
                                            MULCRVCIR : CIVECTOR[LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULCRVCIR[i]:= A * B[i]
END;   





{---------------------------------------------------------------------------}
{    4.3  Operatoren fuer REAL, COMPLEX mit IMATRIX, CIMATRIX               }
{---------------------------------------------------------------------------}
{SEKTOR A16                                                                 }
{---------------------------------------------------------------------------}
{         4.3.1  Operatoren fuer REAL mit IMATRIX                           }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.3.2  Operatoren fuer REAL mit CIMATRIX                          }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( A : REAL; VAR B : CIMATRIX ) 
                                       MULRMCIR : CIMATRIX [LB(B,1)..UB(B,1),
                                                            LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULRMCIR[z,s]:= A * B[z,s]
END;




{---------------------------------------------------------------------------}
{         4.3.3  Operatoren fuer  COMPLEX mit IMATRIX                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : COMPLEX; VAR B : IMATRIX ) 
                                        MULCRMIR : CIMATRIX [LB(B,1)..UB(B,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULCRMIR[z,s]:= A * B[z,s]
END;




{---------------------------------------------------------------------------}
{         4.3.4  Operatoren fuer  COMPLEX mit CIMATRIX                      }
{---------------------------------------------------------------------------}
   


   
GLOBAL OPERATOR * ( VAR A : COMPLEX; VAR B : CIMATRIX ) 
                                       MULCRMCIR : CIMATRIX [LB(B,1)..UB(B,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULCRMCIR[z,s]:= A * B[z,s]
END;




{---------------------------------------------------------------------------}
{    4.4  Operatoren fuer INTERVAL, CINTERVAL mit RVECTOR, CVECTOR          }
{---------------------------------------------------------------------------}
{SEKTOR A23                                                                 }
{---------------------------------------------------------------------------}
{         4.4.1  Operatoren fuer INTERVAL mit RVECTOR                       }
{---------------------------------------------------------------------------}



   
{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.4.2  Operatoren fuer INTERVAL mit CVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : INTERVAL; VAR B : CVECTOR ) 
                                             MULIRVCR : CIVECTOR[LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULIRVCR[i]:= A * B[i]
END;




{---------------------------------------------------------------------------}
{         4.4.3  Operatoren fuer CINTERVAL mit RVECTOR                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CINTERVAL; VAR B : RVECTOR ) 
                                             MULCIRVR : CIVECTOR[LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULCIRVR[i]:= A * B[i]
END;




{---------------------------------------------------------------------------}
{         4.4.4  Operatoren fuer CINTERVAL mit CVECTOR                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CINTERVAL; VAR B : CVECTOR ) 
                                            MULCIRVCR : CIVECTOR[LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULCIRVCR[i]:= A * B[i]
END;



   
{---------------------------------------------------------------------------}
{    4.5  Operatoren fuer INTERVAL, CINTERVAL mit IVECTOR, CIVECTOR         }
{---------------------------------------------------------------------------}
{SEKTOR A24                                                                 }
{---------------------------------------------------------------------------}
{         4.5.1  Operatoren fuer INTERVAL mit IVECTOR                       }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.5.2  Operatoren fuer INTERVAL mit CIVECTOR                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : INTERVAL; VAR B : CIVECTOR ) 
                                          MULIRVCIR : CIVECTOR [LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULIRVCIR[i]:= A * B[i]
END;   




{---------------------------------------------------------------------------}
{         4.5.3  Operatoren fuer CINTERVAL mit IVECTOR                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CINTERVAL; VAR B : IVECTOR )
                                            MULCIRVIR : CIVECTOR [LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULCIRVIR[i]:= A * B[i]
END;




{---------------------------------------------------------------------------}
{         4.5.4  Operatoren fuer CINTERVAL mit CIVECTOR                     }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CINTERVAL; VAR B : CIVECTOR ) 
                                         MULCIRVCIR : CIVECTOR [LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULCIRVCIR[i]:= A * B[i]
END;




{---------------------------------------------------------------------------}
{    4.6  Operatoren fuer INTERVAL, CINTERVAL mit RMATRIX, CMATRIX          }
{---------------------------------------------------------------------------}
{SEKTOR A25                                                                 }
{---------------------------------------------------------------------------}
{         4.6.1  Operatoren fuer INTERVAL mit RMATRIX                       }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.6.2  Operatoren fuer INTERVAL mit CMATRIX                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : INTERVAL; VAR B : CMATRIX ) 
                                        MULIRMCR : CIMATRIX [LB(B,1)..UB(B,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULIRMCR[z,s]:= A * B[z,s]
END;




{---------------------------------------------------------------------------}
{         4.6.3  Operatoren fuer CINTERVAL mit RMATRIX                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CINTERVAL; VAR B : RMATRIX ) 
                                        MULCIRMR : CIMATRIX [LB(B,1)..UB(B,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULCIRMR[z,s]:= A * B[z,s]
END;




{---------------------------------------------------------------------------}
{         4.6.4  Operatoren fuer CINTERVAL mit CMATRIX                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CINTERVAL; VAR B : CMATRIX ) 
                                       MULCIRMCR : CIMATRIX [LB(B,1)..UB(B,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULCIRMCR[z,s]:= A * B[z,s]
END;





{---------------------------------------------------------------------------}
{    4.7  Operatoren fuer INTERVAL, CINTERVAL mit IMATRIX, CIMATRIX         }
{---------------------------------------------------------------------------}
{SEKTOR A26                                                                 }
{---------------------------------------------------------------------------}
{         4.7.1  Operatoren fuer INTERVAL mit IMATRIX                       }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }
   



{---------------------------------------------------------------------------}
{         4.7.2  Operatoren fuer INTERVAL mit CIMATRIX                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : INTERVAL; VAR B : CIMATRIX ) 
                                       MULIRMCIR : CIMATRIX [LB(B,1)..UB(B,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULIRMCIR[z,s]:= A * B[z,s]
END;




{---------------------------------------------------------------------------}
{         4.7.3  Operatoren fuer CINTERVAL mit IMATRIX                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CINTERVAL; VAR B : IMATRIX ) 
                                       MULCIRMIR : CIMATRIX [LB(B,1)..UB(B,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULCIRMIR[z,s]:= A * B[z,s]
END;




{---------------------------------------------------------------------------}
{         4.7.4  Operatoren fuer CINTERVAL mit CIMATRIX                     }
{---------------------------------------------------------------------------}


   
   
GLOBAL OPERATOR * ( VAR A : CINTERVAL; VAR B : CIMATRIX ) 
                                      MULCIRMCIR : CIMATRIX [LB(B,1)..UB(B,1),
                                                             LB(B,2)..UB(B,2)];

VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULCIRMCIR[z,s]:= A * B[z,s]
END;




{---------------------------------------------------------------------------}
{    4.8  Operatoren fuer RVECTOR, CVECTOR mit INTERVAL, CINTERVAL          }
{---------------------------------------------------------------------------}
{SEKTOR A32                                                                 }
{---------------------------------------------------------------------------}
{         4.8.1  Operatoren fuer RVECTOR mit INTERVAL                       }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }
 



{---------------------------------------------------------------------------}
{         4.8.2  Operatoren fuer RVECTOR mit CINTERVAL                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : RVECTOR; VAR B : CINTERVAL ) 
                                            MULVRCIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVRCIR[i]:= A[i] * B
END;




GLOBAL OPERATOR / ( VAR A : RVECTOR; VAR B : CINTERVAL ) 
                                           DIVVRCIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVRCIR[i]:= A[i] / B
END;




{---------------------------------------------------------------------------}
{         4.8.3  Operatoren fuer CVECTOR mit INTERVAL                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CVECTOR; VAR B : INTERVAL ) 
                                           MULVCRIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVCRIR[i]:= A[i] * B
END;




GLOBAL OPERATOR / ( VAR A : CVECTOR; VAR B : INTERVAL ) 
                                            DIVVCRIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVCRIR[i]:= A[i] / B
END;




{---------------------------------------------------------------------------}
{         4.8.4  Operatoren fuer CVECTOR mit CINTERVAL                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CVECTOR; VAR B : CINTERVAL ) 
                                          MULVCRCIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVCRCIR[i]:= A[i] * B
END;
   
   
   
GLOBAL OPERATOR / ( VAR A : CVECTOR; VAR B : CINTERVAL ) 
                                          DIVVCRCIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVCRCIR[i]:= A[i] / B
END;
   



{---------------------------------------------------------------------------}
{    4.9  Operatoren fuer RVECTOR, CVECTOR mit RVECTOR, CVECTOR             }
{---------------------------------------------------------------------------}
{SEKTOR A33                                                                 }
{---------------------------------------------------------------------------}
{         4.9.1  Operatoren fuer RVECTOR mit RVECTOR                        }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MV_ARI definiert.                }




{---------------------------------------------------------------------------}
{         4.9.2  Operatoren fuer RVECTOR mit CVECTOR                        }
{---------------------------------------------------------------------------}



GLOBAL OPERATOR +* ( VAR A : RVECTOR; VAR B : CVECTOR ) 
                                          COHUVRVCR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVRVCR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{         4.9.3  Operatoren fuer CVECTOR mit RVECTOR                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR +* ( VAR A : CVECTOR; VAR B : RVECTOR ) 
                                          COHUVCRVR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVCRVR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{         4.9.4  Operatoren fuer CVECTOR mit CVECTOR                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR +* ( VAR A,B : CVECTOR ) 
                              COHUVCRVCR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVCRVCR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{    4.10 Operatoren fuer RVECTOR, CVECTOR mit IVECTOR, CIVECTOR            }
{---------------------------------------------------------------------------}
{SEKTOR A34                                                                 }
{---------------------------------------------------------------------------}
{         4.10.1 Operatoren fuer RVECTOR mit IVECTOR                        }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.10.2 Operatoren fuer RVECTOR mit CIVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : RVECTOR; VAR B : CIVECTOR ) 
                                          ADDVRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVRVCIR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - ( VAR A : RVECTOR; VAR B : CIVECTOR ) 
                                          SUBVRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVRVCIR[i]:= A[i] - B[i+d]
END;




GLOBAL OPERATOR * ( VAR A : RVECTOR; VAR B : CIVECTOR ) MULVRVCIR : CINTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVRVCIR:= ##( FOR i:= al TO au SUM ( COMPL(INTVAL(A[i])) * B[i+d] ) )
END;




GLOBAL OPERATOR +* ( VAR A : RVECTOR; VAR B : CIVECTOR ) 
                                         COHUVRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVRVCIR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{         4.10.3 Operatoren fuer CVECTOR mit IVECTOR                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CVECTOR; VAR B : IVECTOR ) 
                                          ADDVCRVIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVCRVIR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - ( VAR A : CVECTOR; VAR B : IVECTOR ) 
                                          SUBVCRVIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVCRVIR[i]:= A[i] - B[i+d]
END;




GLOBAL OPERATOR * ( VAR A : CVECTOR; VAR B : IVECTOR ) MULVCRVIR : CINTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVCRVIR:= ##( FOR i:= al TO au SUM ( INTVAL(A[i]) * COMPL(B[i+d]) ) )
END;




GLOBAL OPERATOR +* ( VAR A : CVECTOR; VAR B : IVECTOR ) 
                                         COHUVCRVIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVCRVIR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{         4.10.4 Operatoren fuer CVECTOR mit CIVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CVECTOR; VAR B : CIVECTOR ) 
                                         ADDVCRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVCRVCIR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - ( VAR A : CVECTOR; VAR B : CIVECTOR ) 
                                         SUBVCRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVCRVCIR[i]:= A[i] - B[i+d]
END;



                   
GLOBAL OPERATOR * ( VAR A : CVECTOR; VAR B : CIVECTOR ) MULVCRVCIR : CINTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVCRVCIR:= ##( FOR i:= al TO au SUM ( INTVAL(A[i]) * B[i+d] ) )
END;



GLOBAL OPERATOR +* ( VAR A : CVECTOR; VAR B : CIVECTOR ) 
                                        COHUVCRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVCRVCIR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{    4.11 Operatoren fuer IVECTOR, CIVECTOR mit REAL, COMPLEX               }
{---------------------------------------------------------------------------}
{SEKTOR A41                                                                 }
{---------------------------------------------------------------------------}
{         4.11.1 Operatoren fuer IVECTOR mit REAL                           }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.11.2 Operatoren fuer IVECTOR mit COMPLEX                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IVECTOR; VAR B : COMPLEX ) 
                                           MULVIRCR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVIRCR[i]:= A[i] * B
END;   




GLOBAL OPERATOR / ( VAR A : IVECTOR; VAR B : COMPLEX ) 
                                           DIVVIRCR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVIRCR[i]:= A[i] / B
END;   




{---------------------------------------------------------------------------}
{         4.11.3 Operatoren fuer CIVECTOR mit REAL                          }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIVECTOR; B : REAL )
                                           MULVCIRR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVCIRR[i]:= A[i] * B
END;




GLOBAL OPERATOR / ( VAR A : CIVECTOR; B : REAL ) 
                                           DIVVCIRR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVCIRR[i]:= A[i] / B
END;   




{---------------------------------------------------------------------------}
{         4.11.4 Operatoren fuer CIVECTOR mit COMPLEX                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIVECTOR; VAR B : COMPLEX ) 
                                          MULVCIRCR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO MULVCIRCR[i]:= A[i] * B
END;




GLOBAL OPERATOR / ( VAR A : CIVECTOR; VAR B : COMPLEX ) 
                                          DIVVCIRCR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVCIRCR[i]:= A[i] / B
END;   





{---------------------------------------------------------------------------}
{    4.12 Operatoren fuer IVECTOR, CIVECTOR mit INTERVAL, CINTERVAL         }
{---------------------------------------------------------------------------}
{SEKTOR A42                                                                 }
{---------------------------------------------------------------------------}
{         4.12.1 Operatoren fuer IVECTOR mit INTERVAL                       }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.12.2 Operatoren fuer IVECTOR mit CINTERVAL                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IVECTOR; VAR B : CINTERVAL ) 
                                          MULVIRCIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVIRCIR[i]:= A[i] * B
END;




GLOBAL OPERATOR / ( VAR A : IVECTOR; VAR B : CINTERVAL ) 
                                          DIVVIRCIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVIRCIR[i]:= A[i] / B
END;




{---------------------------------------------------------------------------}
{         4.12.3 Operatoren fuer CIVECTOR mit INTERVAL                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIVECTOR; VAR B : INTERVAL ) 
                                          MULVCIRIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVCIRIR[i]:= A[i] * B
END;




GLOBAL OPERATOR / ( VAR A : CIVECTOR; VAR B : INTERVAL ) 
                                          DIVVCIRIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVCIRIR[i]:= A[i] / B
END;




{---------------------------------------------------------------------------}
{         4.12.4 Operatoren fuer CIVECTOR mit CINTERVAL                     }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIVECTOR; VAR B : CINTERVAL ) 
                                         MULVCIRCIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVCIRCIR[i]:= A[i] * B
END;   




GLOBAL OPERATOR / ( VAR A : CIVECTOR; VAR B : CINTERVAL ) 
                                         DIVVCIRCIR : CIVECTOR [LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVCIRCIR[i]:= A[i] / B
END;   




{---------------------------------------------------------------------------}
{    4.13 Operatoren fuer IVECTOR, CIVECTOR mit RVECTOR, CVECTOR            }
{---------------------------------------------------------------------------}
{SEKTOR A43                                                                 }
{---------------------------------------------------------------------------}
{         4.13.1 Operatoren fuer IVECTOR mit RVECTOR                        }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.13.2 Operatoren fuer IVECTOR mit CVECTOR                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : IVECTOR; VAR B : CVECTOR ) 
                                          ADDVIRVCR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVIRVCR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - ( VAR A : IVECTOR; VAR B : CVECTOR ) 
                                          SUBVIRVCR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVIRVCR[i]:= A[i] - B[i+d]
END;




GLOBAL OPERATOR * ( VAR A : IVECTOR; VAR B : CVECTOR ) MULVIRVCR : CINTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVIRVCR:= ##( FOR i:= al TO au SUM ( COMPL(A[i]) * INTVAL(B[i+d]) ) )
END;



GLOBAL OPERATOR +* ( VAR A : IVECTOR; VAR B : CVECTOR ) 
                                         COHUVIRVCR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVIRVCR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{         4.13.3 Operatoren fuer CIVECTOR mit RVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CIVECTOR; VAR B : RVECTOR ) 
                                          ADDVCIRVR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVCIRVR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - ( VAR A : CIVECTOR; VAR B : RVECTOR ) 
                                          SUBVCIRVR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVCIRVR[i]:= A[i] - B[i+d]
END;




GLOBAL OPERATOR * ( VAR A : CIVECTOR; VAR B : RVECTOR ) MULVCIRVR : CINTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVCIRVR:= ##( FOR i:= al TO au SUM ( A[i] * COMPL(INTVAL(B[i+d])) ) )
END;




GLOBAL OPERATOR +* ( VAR A : CIVECTOR; VAR B : RVECTOR ) 
                                         COHUVCIRVR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVCIRVR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{         4.13.4 Operatoren fuer CIVECTOR mit CVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CIVECTOR; VAR B : CVECTOR ) 
                                         ADDVCIRVCR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVCIRVCR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - ( VAR A : CIVECTOR; VAR B : CVECTOR ) 
                                         SUBVCIRVCR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVCIRVCR[i]:= A[i] - B[i+d]
END;



                   
GLOBAL OPERATOR * ( VAR A : CIVECTOR; VAR B : CVECTOR ) MULVCIRVCR : CINTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVCIRVCR:= ##( FOR i:= al TO au SUM ( A[i] * INTVAL(B[i+d]) ) )
END;




GLOBAL OPERATOR +* ( VAR A : CIVECTOR; VAR B : CVECTOR ) 
                                        COHUVCIRVCR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVCIRVCR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{    4.14 Operatoren fuer IVECTOR, CIVECTOR mit IVECTOR, CIVECTOR           }
{---------------------------------------------------------------------------}
{SEKTOR A44                                                                 }
{---------------------------------------------------------------------------}
{         4.14.1 Operatoren fuer IVECTOR mit IVECTOR                        }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.14.2 Operatoren fuer IVECTOR mit CIVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : IVECTOR; VAR B : CIVECTOR ) 
                                         ADDVIRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVIRVCIR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - ( VAR A : IVECTOR; VAR B : CIVECTOR ) 
                                         SUBVIRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVIRVCIR[i]:= A[i] - B[i+d]
END;




GLOBAL OPERATOR * ( VAR A : IVECTOR; VAR B : CIVECTOR ) MULVIRVCIR : CINTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVIRVCIR:= ##( FOR i:= al TO au SUM ( COMPL(A[i]) * B[i+d] ) )
END;




GLOBAL OPERATOR +* ( VAR A : IVECTOR; VAR B : CIVECTOR ) 
                                        COHUVIRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVIRVCIR[i]:= A[i] +* B[i+d]
END;




GLOBAL OPERATOR ** ( VAR A : IVECTOR; VAR B : CIVECTOR ) 
                                      INTSCTVIRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  INTSCTVIRVCIR[i]:= A[i] ** B[i+d]
END;




{---------------------------------------------------------------------------}
{         4.14.3 Operatoren fuer CIVECTOR mit IVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CIVECTOR; VAR B : IVECTOR ) 
                                         ADDVCIRVIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVCIRVIR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - ( VAR A : CIVECTOR; VAR B : IVECTOR ) 
                                         SUBVCIRVIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVCIRVIR[i]:= A[i] - B[i+d]
END;




GLOBAL OPERATOR * ( VAR A : CIVECTOR; VAR B : IVECTOR ) MULVCIRVIR : CINTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVCIRVIR:= ##( FOR i:= al TO au SUM ( A[i] * COMPL(B[i+d]) ) )
END;




GLOBAL OPERATOR +* ( VAR A : CIVECTOR; VAR B : IVECTOR ) 
                                        COHUVCIRVIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVCIRVIR[i]:= A[i] +* B[i+d]
END;




GLOBAL OPERATOR ** ( VAR A : CIVECTOR; VAR B : IVECTOR ) 
                                      INTSCTVCIRVIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  INTSCTVCIRVIR[i]:= A[i] ** B[i+d]
END;




{---------------------------------------------------------------------------}
{         4.14.4 Operatoren fuer CIVECTOR mit CIVECTOR                      }
{---------------------------------------------------------------------------}



 
GLOBAL OPERATOR + ( VAR A, B : CIVECTOR ) 
                             ADDVCIRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVCIRVCIR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - ( VAR A, B : CIVECTOR ) 
                             SUBVCIRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVCIRVCIR[i]:= A[i] - B[i+d]
END;



                   
GLOBAL OPERATOR * ( VAR A, B : CIVECTOR ) MULVCIRVCIR : CINTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVCIRVCIR:= ##( FOR i:= al TO au SUM ( A[i] * B[i+d] ) )
END;



GLOBAL OPERATOR +* ( VAR A,B : CIVECTOR ) 
                            COHUVCIRVCIR : CIVECTOR [LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVCIRVCIR[i]:= A[i] +* B[i+d]
END;




GLOBAL OPERATOR ** ( VAR A,B : CIVECTOR ) 
                          INTSCTVCIRVCIR : CIVECTOR [LB(A)..UB(A)];

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  INTSCTVCIRVCIR[i]:= A[i] ** B[i+d]
END;




{---------------------------------------------------------------------------}
{    4.15 Operatoren fuer RMATRIX, CMATRIX mit INTERVAL, CINTERVAL          }
{---------------------------------------------------------------------------}
{SEKTOR A52                                                                 }
{---------------------------------------------------------------------------}
{         4.15.1 Operatoren fuer RMATRIX mit INTERVAL                       }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.15.2 Operatoren fuer RMATRIX mit CINTERVAL                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : RMATRIX; VAR B : CINTERVAL ) 
                                        MULMRCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO   MULMRCIR[z,s]:= A[z,s] * B
END;




GLOBAL OPERATOR / ( VAR A : RMATRIX; VAR B : CINTERVAL ) 
                                        DIVMRCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMRCIR[z,s]:= A[z,s] / B
END;




{---------------------------------------------------------------------------}
{         4.15.3 Operatoren fuer CMATRIX mit INTERVAL                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CMATRIX; VAR B : INTERVAL ) 
                                        MULMCRIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMCRIR[z,s]:= A[z,s] * B
END;




GLOBAL OPERATOR / ( VAR A : CMATRIX; VAR B : INTERVAL ) 
                                        DIVMCRIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMCRIR[z,s]:= A[z,s] / B
END;




{---------------------------------------------------------------------------}
{         4.15.4 Operatoren fuer CMATRIX mit CINTERVAL                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CMATRIX; VAR B : CINTERVAL ) 
                                       MULMCRCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMCRCIR[z,s]:= A[z,s] * B
END;



   
GLOBAL OPERATOR / ( VAR A : CMATRIX; VAR B : CINTERVAL ) 
                                       DIVMCRCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMCRCIR[z,s]:= A[z,s] / B
END;




{---------------------------------------------------------------------------}
{    4.16 Operatoren fuer RMATRIX, CMATRIX mit IVECTOR, CIVECTOR            }
{---------------------------------------------------------------------------}
{SEKTOR A54                                                                 }
{---------------------------------------------------------------------------}
{         4.16.1 Operatoren fuer RMATRIX mit IVECTOR                        }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.16.2 Operatoren fuer RMATRIX mit CIVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : RMATRIX;  VAR B : CIVECTOR ) 
                                      MULMRVCIR : CIVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF UB(A,2) - LB(A,2) <> UB(B) - LB(B) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMRVCIR[i]:=  A[i] * B
END;




{---------------------------------------------------------------------------}
{         4.16.3 Operatoren fuer CMATRIX mit IVECTOR                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CMATRIX;  VAR B : IVECTOR ) 
                                       MULMCRVIR : CIVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF UB(A,2) - LB(A,2) <> UB(B) - LB(B) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMCRVIR[i]:=  A[i] * B
END;




{---------------------------------------------------------------------------}
{         4.16.4 Operatoren fuer CMATRIX mit CIVECTOR                       }
{---------------------------------------------------------------------------}



 
GLOBAL OPERATOR * ( VAR A : CMATRIX;  VAR B : CIVECTOR ) 
                                      MULMCRVCIR : CIVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF UB(A,2) - LB(A,2) <> UB(B) - LB(B) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMCRVCIR[i]:=  A[i] * B
END;



{---------------------------------------------------------------------------}
{    4.17 Operatoren fuer RMATRIX, CMATRIX mit RMATRIX, CMATRIX             }
{---------------------------------------------------------------------------}
{SEKTOR A55                                                                 }
{---------------------------------------------------------------------------}
{         4.17.1 Operatoren fuer RMATRIX mit RMATRIX                        }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.17.2 Operatoren fuer RMATRIX mit CMATRIX                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR +* ( VAR A : RMATRIX; VAR B : CMATRIX ) 
                                        COHUMRMCR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMRMCR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{         4.17.3 Operatoren fuer CMATRIX mit RMATRIX                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR +* ( VAR A : CMATRIX; VAR B : RMATRIX ) 
                                        COHUMCRMR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMCRMR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{         4.17.4 Operatoren fuer CMATRIX mit CMATRIX                        }
{---------------------------------------------------------------------------}
 
 

 
GLOBAL OPERATOR +* ( VAR A,B : CMATRIX ) 
                              COHUMCRMCR : CIMATRIX [LB(A,1)..UB(A,1),
                                                     LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMCRMCR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;



 
{---------------------------------------------------------------------------}
{    4.18 Operatoren fuer RMATRIX, CMATRIX mit IMATRIX, CIMATRIX            }
{---------------------------------------------------------------------------}
{SEKTOR A56                                                                 }
{---------------------------------------------------------------------------}
{         4.18.1 Operatoren fuer RMATRIX mit IMATRIX                        }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.18.2 Operatoren fuer RMATRIX mit CIMATRIX                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : RMATRIX; VAR B : CIMATRIX ) 
                                       ADDMRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMRMCIR[z,s]:= A[z,s] + B[z+d1,s+d2] 
END;




GLOBAL OPERATOR - ( VAR A : RMATRIX; VAR B : CIMATRIX ) 
                                       SUBMRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMRMCIR[z,s]:= A[z,s] - B[z+d1,s+d2] 
END;




GLOBAL OPERATOR * ( VAR A : RMATRIX; VAR B : CIMATRIX ) 
                                       MULMRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMRMCIR[z,s]:= A[z] * CIVECTOR(B[*,s])
END;




GLOBAL OPERATOR +* ( VAR A : RMATRIX; VAR B : CIMATRIX ) 
                                       COHUMRMCIR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMRMCIR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{         4.18.3 Operatoren fuer CMATRIX mit IMATRIX                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CMATRIX; VAR B : IMATRIX ) 
                                       ADDMCRMIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMCRMIR[z,s]:=  A[z,s] + B[z+d1,s+d2]
END;




GLOBAL OPERATOR - ( VAR A : CMATRIX; VAR B : IMATRIX ) 
                                       SUBMCRMIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMCRMIR[z,s]:=  A[z,s] - B[z+d1,s+d2]
END;




GLOBAL OPERATOR * ( VAR A : CMATRIX; VAR B : IMATRIX ) 
                                       MULMCRMIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMCRMIR[z,s]:= A[z] * IVECTOR(B[*,s])
END;



 
GLOBAL OPERATOR +* ( VAR A : CMATRIX; VAR B : IMATRIX ) 
                                       COHUMCRMIR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMCRMIR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{         4.18.4 Operatoren fuer CMATRIX mit CIMATRIX                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CMATRIX; VAR B : CIMATRIX ) 
                                      ADDMCRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMCRMCIR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;




GLOBAL OPERATOR - ( VAR A : CMATRIX; VAR B : CIMATRIX ) 
                                      SUBMCRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMCRMCIR[z,s]:= A[z,s] - B[z+d1,s+d2]
END;

 
 

GLOBAL OPERATOR * ( VAR A : CMATRIX; VAR B : CIMATRIX ) 
                                      MULMCRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMCRMCIR[z,s]:= A[z] * CIVECTOR(B[*,s])
END;
 
 
 
 
GLOBAL OPERATOR +* ( VAR A : CMATRIX; VAR B : CIMATRIX ) 
                                      COHUMCRMCIR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMCRMCIR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;



 
{---------------------------------------------------------------------------}
{    4.19 Operatoren fuer IMATRIX, CIMATRIX mit REAL, COMPLEX               }
{---------------------------------------------------------------------------}
{SEKTOR A61                                                                 }
{---------------------------------------------------------------------------}
{         4.19.1 Operatoren fuer IMATRIX mit REAL                           }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.19.2 Operatoren fuer IMATRIX mit COMPLEX                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IMATRIX; VAR B : COMPLEX ) 
                                        MULMIRCR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMIRCR[z,s]:= A[z,s] * B
END;




GLOBAL OPERATOR / ( VAR A : IMATRIX; VAR B : COMPLEX ) 
                                        DIVMIRCR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMIRCR[z,s]:= A[z,s] / B
END;




{---------------------------------------------------------------------------}
{         4.19.3 Operatoren fuer CIMATRIX mit REAL                          }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIMATRIX; B : REAL ) 
                                       MULMCIRR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMCIRR[z,s]:= A[z,s] * B
END;




GLOBAL OPERATOR / ( VAR A : CIMATRIX; B : REAL ) 
                                       DIVMCIRR : CIMATRIX [LB(A,1)..UB(A,1),
                                                            LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMCIRR[z,s]:= A[z,s] / B
END;




{---------------------------------------------------------------------------}
{         4.19.4 Operatoren fuer CIMATRIX mit COMPLEX                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIMATRIX; VAR B : COMPLEX ) 
                                       MULMCIRCR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMCIRCR[z,s]:= A[z,s] * B
END;



   
GLOBAL OPERATOR / ( VAR A : CIMATRIX; VAR B : COMPLEX ) 
                                       DIVMCIRCR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMCIRCR[z,s]:= A[z,s] / B
END;




{---------------------------------------------------------------------------}
{    4.20 Operatoren fuer IMATRIX, CIMATRIX mit INTERVAL, CINTERVAL         }
{---------------------------------------------------------------------------}
{SEKTOR A62                                                                 }
{---------------------------------------------------------------------------}
{         4.20.1 Operatoren fuer IMATRIX mit INTERVAL                       }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.20.2 Operatoren fuer IMATRIX mit CINTERVAL                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IMATRIX; VAR B : CINTERVAL ) 
                                       MULMIRCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMIRCIR[z,s]:= A[z,s] * B
END;




GLOBAL OPERATOR / ( VAR A : IMATRIX; VAR B : CINTERVAL ) 
                                       DIVMIRCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMIRCIR[z,s]:= A[z,s] / B
END;




{---------------------------------------------------------------------------}
{         4.20.3 Operatoren fuer CIMATRIX mit INTERVAL                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIMATRIX; VAR B : INTERVAL ) 
                                       MULMCIRIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMCIRIR[z,s]:= A[z,s] * B
END;




GLOBAL OPERATOR / ( VAR A : CIMATRIX; VAR B : INTERVAL ) 
                                       DIVMCIRIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMCIRIR[z,s]:= A[z,s] / B
END;




{---------------------------------------------------------------------------}
{         4.20.4 Operatoren fuer CIMATRIX mit CINTERVAL                     }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIMATRIX; VAR B : CINTERVAL )
                                      MULMCIRCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMCIRCIR[z,s]:= A[z,s] * B
END;



   
GLOBAL OPERATOR / ( VAR A : CIMATRIX; VAR B : CINTERVAL ) 
                                      DIVMCIRCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMCIRCIR[z,s]:= A[z,s] / B
END;



   
{---------------------------------------------------------------------------}
{    4.21 Operatoren fuer IMATRIX, CIMATRIX mit RVECTOR, CVECTOR            }
{---------------------------------------------------------------------------}
{SEKTOR A63                                                                 }
{---------------------------------------------------------------------------}
{         4.21.1 Operatoren fuer IMATRIX mit RVECTOR                        }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.21.2 Operatoren fuer IMATRIX mit CVECTOR                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IMATRIX;  VAR B : CVECTOR ) 
                                       MULMIRVCR : CIVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B) - LB(B) ) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMIRVCR[i]:= A[i] * B
END;




{---------------------------------------------------------------------------}
{         4.21.3 Operatoren fuer CIMATRIX mit RVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIMATRIX;  VAR B : RVECTOR ) 
                                       MULMCIRVR : CIVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF UB(A,2) - LB(A,2) <> UB(B) - LB(B) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMCIRVR[i]:= A[i] * B
END;




{---------------------------------------------------------------------------}
{         4.21.4 Operatoren fuer CIMATRIX mit CVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIMATRIX;  VAR B : CVECTOR ) 
                                      MULMCIRVCR : CIVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF UB(A,2) - LB(A,2) <> UB(B) - LB(B) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMCIRVCR[i]:= A[i] * B
END;




{---------------------------------------------------------------------------}
{    4.22 Operatoren fuer IMATRIX, CIMATRIX mit IVECTOR, CIVECTOR           }
{---------------------------------------------------------------------------}
{SEKTOR A64                                                                 }
{---------------------------------------------------------------------------}
{         4.22.1 Operatoren fuer IMATRIX mit IVECTOR                        }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.22.2 Operatoren fuer IMATRIX mit CIVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IMATRIX;  VAR B : CIVECTOR ) 
                                      MULMIRVCIR : CIVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF UB(A,2) - LB(A,2) <> UB(B) - LB(B) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO   MULMIRVCIR[i]:= A[i] * B
END;




{---------------------------------------------------------------------------}
{         4.22.3 Operatoren fuer CIMATRIX mit IVECTOR                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIMATRIX;  VAR B : IVECTOR ) 
                                      MULMCIRVIR : CIVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF UB(A,2) - LB(A,2) <> UB(B) - LB(B) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMCIRVIR[i]:= A[i] * B
END;




{---------------------------------------------------------------------------}
{         4.22.4 Operatoren fuer CIMATRIX mit CIVECTOR                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : CIMATRIX;  VAR B : CIVECTOR ) 
                                     MULMCIRVCIR : CIVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF UB(A,2) - LB(A,2) <> UB(B) - LB(B) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMCIRVCIR[i]:= A[i] * B
END;




{---------------------------------------------------------------------------}
{    4.23 Operatoren fuer IMATRIX, CIMATRIX mit RMATRIX, CMATRIX            }
{---------------------------------------------------------------------------}
{SEKTOR A65                                                                 }
{---------------------------------------------------------------------------}
{         4.23.1 Operatoren fuer IMATRIX mit RMATRIX                        }
{---------------------------------------------------------------------------}



{                    Sind bereits im Modul MVI_ARI definiert.               }




{---------------------------------------------------------------------------}
{         4.23.2 Operatoren fuer IMATRIX mit CMATRIX                        }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : IMATRIX; VAR B : CMATRIX ) 
                                       ADDMIRMCR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMIRMCR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;



GLOBAL OPERATOR - ( VAR A : IMATRIX; VAR B : CMATRIX ) 
                                       SUBMIRMCR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMIRMCR[z,s]:= A[z,s] - B[z+d1,s+d2] 
END;




GLOBAL OPERATOR * ( VAR A : IMATRIX; VAR B : CMATRIX ) 
                                       MULMIRMCR : CIMATRIX [LB(A,1)..UB(A,1) ,
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMIRMCR[z,s]:= A[z] * CVECTOR(B[*,s])
END;




GLOBAL OPERATOR +* ( VAR A : IMATRIX; VAR B : CMATRIX )
                                       COHUMIRMCR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMIRMCR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{         4.23.3 Operatoren fuer CIMATRIX mit RMATRIX                       }
{---------------------------------------------------------------------------}



GLOBAL OPERATOR + ( VAR A : CIMATRIX; VAR B : RMATRIX ) 
                                       ADDMCIRMR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMCIRMR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;




GLOBAL OPERATOR - ( VAR A : CIMATRIX; VAR B : RMATRIX ) 
                                       SUBMCIRMR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMCIRMR[z,s]:= A[z,s] - B[z+d1,s+d2]
END;




GLOBAL OPERATOR * ( VAR A : CIMATRIX; VAR B : RMATRIX ) 
                                       MULMCIRMR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMCIRMR[z,s]:= A[z] * RVECTOR(B[*,s])
END;




GLOBAL OPERATOR +* ( VAR A : CIMATRIX; VAR B : RMATRIX ) 
                                       COHUMCIRMR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMCIRMR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{         4.23.4 Operatoren fuer CIMATRIX mit CMATRIX                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CIMATRIX; VAR B : CMATRIX ) 
                                      ADDMCIRMCR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMCIRMCR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;




GLOBAL OPERATOR - ( VAR A : CIMATRIX; VAR B : CMATRIX ) 
                                      SUBMCIRMCR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMCIRMCR[z,s]:= A[z,s] - B[z+d1,s+d2]
END;

 
 

GLOBAL OPERATOR * ( VAR A : CIMATRIX; VAR B : CMATRIX ) 
                                      MULMCIRMCR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMCIRMCR[z,s]:= A[z] * CVECTOR(B[*,s])
END;
 
 
 
 
GLOBAL OPERATOR +* ( VAR A : CIMATRIX; VAR B : CMATRIX ) 
                                      COHUMCIRMCR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMCIRMCR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;



 
{---------------------------------------------------------------------------}
{    4.24 Operatoren fuer IMATRIX, CIMATRIX mit IMATRIX, CIMATRIX           }
{---------------------------------------------------------------------------}
{SEKTOR A66                                                                 }
{---------------------------------------------------------------------------}
{         4.24.1 Operatoren fuer IMATRIX mit IMATRIX                        }
{---------------------------------------------------------------------------}




{                    Sind bereits im Modul MVI_ARI definiert.               }



{---------------------------------------------------------------------------}
{         4.24.2 Operatoren fuer IMATRIX mit CIMATRIX                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : IMATRIX; VAR B : CIMATRIX ) 
                                      ADDMIRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMIRMCIR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;




GLOBAL OPERATOR - ( VAR A : IMATRIX; VAR B : CIMATRIX ) 
                                      SUBMIRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMIRMCIR[z,s]:= A[z,s] - B[z+d1,s+d2] 
END;




GLOBAL OPERATOR * ( VAR A : IMATRIX; VAR B : CIMATRIX ) 
                                      MULMIRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMIRMCIR[z,s]:= A[z] * CIVECTOR(B[*,s])
END;




GLOBAL OPERATOR +* ( VAR A : IMATRIX; VAR B : CIMATRIX ) 
                                      COHUMIRMCIR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMIRMCIR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;



GLOBAL OPERATOR ** ( VAR A : IMATRIX; VAR B : CIMATRIX ) 
                                    INTSCTMIRMCIR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  INTSCTMIRMCIR[z,s]:= A[z,s] ** B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{         4.24.3 Operatoren fuer CIMATRIX mit IMATRIX                       }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : CIMATRIX; VAR B : IMATRIX ) 
                                      ADDMCIRMIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMCIRMIR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;




GLOBAL OPERATOR - ( VAR A : CIMATRIX; VAR B : IMATRIX ) 
                                      SUBMCIRMIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMCIRMIR[z,s]:= A[z,s] - B[z+d1,s+d2]
END;




GLOBAL OPERATOR * ( VAR A : CIMATRIX; VAR B : IMATRIX ) 
                                      MULMCIRMIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMCIRMIR[z,s]:= A[z] * IVECTOR(B[*,s])
END;




GLOBAL OPERATOR +* ( VAR A : CIMATRIX; VAR B : IMATRIX ) 
                                      COHUMCIRMIR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMCIRMIR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;



GLOBAL OPERATOR ** ( VAR A : CIMATRIX; VAR B : IMATRIX ) 
                                    INTSCTMCIRMIR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  INTSCTMCIRMIR[z,s]:= A[z,s] ** B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{         4.24.4 Operatoren fuer CIMATRIX mit CIMATRIX                      }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A, B : CIMATRIX ) 
                                     ADDMCIRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMCIRMCIR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;




GLOBAL OPERATOR - ( VAR A, B : CIMATRIX ) 
                                     SUBMCIRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMCIRMCIR[z,s]:=  A[z,s] - B[z+d1,s+d2]
END;

 
 

GLOBAL OPERATOR * ( VAR A, B : CIMATRIX )
                                     MULMCIRMCIR : CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMCIRMCIR[z,s]:= A[z] * CIVECTOR(B[*,s])
END;
 
 
 
 
GLOBAL OPERATOR +* ( VAR A,B : CIMATRIX ) 
                                     COHUMCIRMCIR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMCIRMCIR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;




GLOBAL OPERATOR ** ( VAR A,B : CIMATRIX  ) 
                                   INTSCTMCIRMCIR: CIMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  INTSCTMCIRMCIR[z,s]:= A[z,s] ** B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{ 5. Ein- / Ausgabe                                                         }
{---------------------------------------------------------------------------}



 
GLOBAL PROCEDURE READ  ( VAR F : TEXT; VAR A : CIVECTOR);

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO READ( F, A[i] )
END;




GLOBAL PROCEDURE WRITE ( VAR F : TEXT; VAR A : CIVECTOR);

VAR i : INTEGER;

BEGIN
  WRITELN( F );
  FOR i:= LB(A) TO UB(A) DO  WRITELN( F, A[i] );
END;




GLOBAL PROCEDURE READ  ( VAR F : TEXT; VAR A : CIMATRIX);

VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  READ( F, A[z,s] );
END;




GLOBAL PROCEDURE WRITE ( VAR F : TEXT; VAR A : CIMATRIX);
 
VAR z,s : INTEGER;

BEGIN
  WRITELN( F );
  FOR z:= LB(A,1) TO UB(A,1) DO
  BEGIN
    FOR s:= LB(A,2) TO UB(A,2) DO  WRITELN( F, A[z,s] );
    WRITELN( F )
  END
END;





{---------------------------------------------------------------------------}
{
{  Zusatz zu :
{
{---------------------------------------------------------------------------}
{    3.3.4 Vergleiche CIVECTOR mit CIVECTOR                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A,B : CIVECTOR ) INVCIRVCIR : BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au ) DO
      IF A[i] IN B[i+d] THEN         i:= SUCC(i)
                        ELSE teilmenge:= FALSE;
    INVCIRVCIR:= teilmenge
  END
END;




{---------------------------------------------------------------------------}
{
{  Zusatz zu :
{
{---------------------------------------------------------------------------}
{    3.6.4 Vergleiche CIMATRIX mit CIMATRIX                                 }
{---------------------------------------------------------------------------}



GLOBAL OPERATOR IN ( VAR A,B : CIMATRIX ) INMCIRMCIR : BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i := al1;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au1 ) DO
      IF A[i] IN B[i+d] THEN          i:= SUCC(i)
                        ELSE  teilmenge:= FALSE;
    INMCIRMCIR:= teilmenge
  END
END;



{---------------------------------------------------------------------------}
{
{  Zusatz zu :
{
{---------------------------------------------------------------------------}
{ 2.2 Spezielle Intervallfunktionen                                         }
{---------------------------------------------------------------------------}
{    2.2.3 Epsilon - Aufblaehung                                            }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION BLOW( VAR A : CIVECTOR; EPS : REAL ) : CIVECTOR[LB(A)..UB(A)];
 
VAR i : INTEGER;
    E : REAL;
    B : CINTERVAL;

BEGIN
  E:= 1.0 + EPS;
  FOR i:= LB(A) TO UB(A) DO  BEGIN
                                B:= E*A[i] - EPS*A[i];
                                BLOW[i].RE.INF:= PRED( B.RE.INF );
                                BLOW[i].RE.SUP:= SUCC( B.RE.SUP );
                                BLOW[i].IM.INF:= PRED( B.IM.INF );
                                BLOW[i].IM.SUP:= SUCC( B.IM.SUP );
                             END;
END;
 


 
GLOBAL FUNCTION BLOW ( VAR A : CIMATRIX; EPS : REAL ) : CIMATRIX[LB(A,1)..UB(A,1),
                                                                 LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;           
    E   : REAL;
    B   : CINTERVAL;

BEGIN
  E:= 1.0 + EPS;
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  BEGIN
                                    B:= E*A[z,s] - EPS*A[z,s];
                                    BLOW[z,s].RE.INF:= PRED( B.RE.INF );
                                    BLOW[z,s].RE.SUP:= SUCC( B.RE.SUP );
                                    BLOW[z,s].IM.INF:= PRED( B.IM.INF );
                                    BLOW[z,s].IM.SUP:= SUCC( B.IM.SUP );
                                 END;
END;  





END. { of module MVCI_ARI }
