(*                       }
{*  MODULE:  stdmod.p   }
{*  module with PASCAL-XSC standard procedures functions and operators }
{*   for software arithmetic and 10byte standard functions }
{*  last modification:  18.02.92  12:34   }

{* uli 11.06.91 : r_cnsd, r_cnsu          }
{* dietrich 25.07.91 : tenbyte mathematical functions }
{* uli 01.08.91 : string  in  string      }
{* dietrich 01.08.91 : maxreal,minreal constants      }
{* uli 17.09.91 : maxreal and minreal moved to x_real.p  }
{* uli 31.01.92 : tenbyte mathematical functions for exp2 .. ln10 }
{* uli 11.02.92 : constantconversion has string_of_c parameter now }
{* uli 18.02.92 : t_ep10 changed to t_ex10 }
{*)

module stdmod ;

{ __r__conv__  should be global to force a declaration into stdmod.h  }
function __r__conv__n (s:string_of_c) : real ; external r_cnst ;
function __r__conv__d (s:string_of_c) : real ; external r_cnsd ;
function __r__conv__u (s:string_of_c) : real ; external r_cnsu ;
realconstantconversion    __r__conv__n ;
realconstantconversion (< __r__conv__d ;
realconstantconversion (> __r__conv__u ;

global function real (i : integer)           : real ; external r_flot ;
  { coersion! }

{ global operator := (var x: real; y : real) ; external r_ass  ; }
global operator := (var x: real; y : integer) ; begin x := real (y) end ;
global operator := (var x: dotprecision; y : dotprecision) ; external d_ass ;

global function mant (m : real)              : real ; external r_mant ;
global function comp (m : real; e : integer) : real ; external r_comp ;
global function expo (x : real)           : integer ; external r_expo ;
global function succ (x : real)           : real ;    external r_succ ;
global function pred (x : real)           : real ;    external r_pred ;
global function sign (x : real)           : integer ; external r_sign ;
global function sign (x : dotprecision)   : integer ; external d_sign ;

global function abs (  i : integer) : integer ; external a_abs_ ;
global function sqr (  i : integer) : integer ; external a_sqr_ ;
global operator div (i,j : integer)r: integer ; external a_div_ ;
global operator mod (i,j : integer)r: integer ; external a_mod_ ;
global function trunc  (r : real )  : integer ; external r_trun ;
global function round  (r : real )  : integer ; external r_rond ;
global function abs    (r : real )  : real    ; external r_abs ;
global function sqrt   (r : real )  : real    ; external sqrt ;

global function exp    (x : real)   : real ; external q_exp  ;
global function loga (x,y : real)   : real ; external r_loga ;
global function ln     (x : real)   : real ; external q_log  ;
global function log2   (x : real)   : real ; external q_log2 ;
global function log10  (x : real)   : real ; external q_lg10 ;
global function power(x,y : real)   : real ; external t_pow  ;
global function exp2   (x : real)   : real ; external q_exp2 ;
global function exp10  (x : real)   : real ; external q_ex10 ;
global function sin    (x : real)   : real ; external q_sin  ;
global function cos    (x : real)   : real ; external q_cos  ;
global function tan    (x : real)   : real ; external q_tan  ;
global function cot    (x : real)   : real ; external q_cot  ;
global function arcsin (x : real)   : real ; external q_asin ;
global function arccos (x : real)   : real ; external q_acos ;
global function arctan (x : real)   : real ; external q_atan ;
global function arccot (x : real)   : real ; external q_acot ;
global function arctan2(x,y : real) : real ; external t_atn2 ;
global function sinh   (x : real)   : real ; external q_sinh ;
global function cosh   (x : real)   : real ; external q_cosh ;
global function tanh   (x : real)   : real ; external q_tanh ;
global function coth   (x : real)   : real ; external q_coth ;
global function arsinh (x : real)   : real ; external q_asnh ;
global function arcosh (x : real)   : real ; external q_acsh ;
global function artanh (x : real)   : real ; external q_atnh ;
global function arcoth (x : real)   : real ; external q_acth ;

global function scalp (var x,y : rvector; r : integer) : real    ; external r_scpy ;
global function scalp (var x,y : cvector; r : integer) : complex ; external c_scpy ;
global function scalp (var x,y : ivector; r : integer) : interval; external i_scpy ;
global function scalp (var x,y :civector; r : integer) :cinterval; external z_scpy ;

global operator -  (  y : real) res : real ; external r_umin ;
global operator +  (x,y : real) res : real ; external r_addn ;
global operator +< (x,y : real) res : real ; external r_addd ;
global operator +> (x,y : real) res : real ; external r_addu ;
global operator -  (x,y : real) res : real ; external r_subn ;
global operator -< (x,y : real) res : real ; external r_subd ;
global operator -> (x,y : real) res : real ; external r_subu ;
global operator *  (x,y : real) res : real ; external r_muln ;
global operator *< (x,y : real) res : real ; external r_muld ;
global operator *> (x,y : real) res : real ; external r_mulu ;
global operator /  (x,y : real) res : real ; external r_divn ;
global operator /< (x,y : real) res : real ; external r_divd ;
global operator /> (x,y : real) res : real ; external r_divu ;

global operator =  (x,y : real) res : boolean ; external r_eq   ;
global operator >= (x,y : real) res : boolean ; external r_ge   ;
global operator >  (x,y : real) res : boolean ; external r_gt   ;
global operator <= (x,y : real) res : boolean ; external r_le   ;
global operator <  (x,y : real) res : boolean ; external r_lt   ;
global operator <> (x,y : real) res : boolean ; external r_ne   ;

global function sqr     (r : real ) : real    ; begin sqr := r*r end ;

global operator +  (x:integer; y : real   ) nradd : real ;
  begin nradd := real (x) + y end ;
global operator +  (x:real   ; y : integer) rnadd : real ;
  begin rnadd := x + real (y) end ;
global operator -  (x:integer; y : real   ) nrsub : real ;
  begin nrsub := real (x) - y end ;
global operator -  (x:real   ; y : integer) rnsub : real ;
  begin rnsub := x - real (y) end ;
global operator *  (x:integer; y : real   ) nrmul : real ;
  begin nrmul := real (x) * y end ;
global operator *  (x:real   ; y : integer) rnmul : real ;
  begin rnmul := x * real (y) end ;
global operator /  (x:integer; y : real   ) nrdiv : real ;
  begin nrdiv := real (x) / y end ;
global operator /  (x:real   ; y : integer) rndiv : real ;
  begin rndiv := x / real (y) end ;
global operator /   (i,j : integer) r: real ;
  begin r:= real(i) / real(j) end ;


global operator =  (x:integer; y : real   ) nreq : boolean ;
  begin nreq := real (x) = y end ;
global operator =  (x:real   ; y : integer) rneq : boolean ;
  begin rneq := x = real (y) end ;
global operator >= (x:integer; y : real   ) nrge : boolean ;
  begin nrge := real (x) >= y end ;
global operator >= (x:real   ; y : integer) rnge : boolean ;
  begin rnge := x >= real (y) end ;
global operator >  (x:integer; y : real   ) nrgt : boolean ;
  begin nrgt := real (x) > y end ;
global operator >  (x:real   ; y : integer) rngt : boolean ;
  begin rngt := x > real (y) end ;
global operator <= (x:integer; y : real   ) nrle : boolean ;
  begin nrle := real (x) <= y end ;
global operator <= (x:real   ; y : integer) rnle : boolean ;
  begin rnle := x <= real (y) end ;
global operator <  (x:integer; y : real   ) nrlt : boolean ;
  begin nrlt := real (x) < y end ;
global operator <  (x:real   ; y : integer) rnlt : boolean ;
  begin rnlt := x < real (y) end ;
global operator <> (x:integer; y : real   ) nrne : boolean ;
  begin nrne := real (x) <> y end ;
global operator <> (x:real   ; y : integer) rnne : boolean ;
  begin rnne := x <> real (y) end ;

{   string subroutines   }

global function string (c:char)       : string ;  external s_char ;
global operator +    (x,y : string) r : string ;  external s_conc ;
global operator := (var x : string; y : string) ; external s_asgn ;

global operator =  ( s,t : string )         sseq : boolean;  external s_sseq;
global operator >= ( s,t : string )         ssge : boolean;  external s_ssge;
global operator >  ( s,t : string )         ssgt : boolean;  external s_ssgt;
global operator <= ( s,t : string )         ssle : boolean;  external s_ssle;
global operator <  ( s,t : string )         sslt : boolean;  external s_sslt;
global operator <> ( s,t : string )         ssne : boolean;  external s_ssne;
global operator =  ( s : string; t : char ) sceq : boolean;  external s_sceq;
global operator >= ( s : string; t : char ) scge : boolean;  external s_scge;
global operator >  ( s : string; t : char ) scgt : boolean;  external s_scgt;
global operator <= ( s : string; t : char ) scle : boolean;  external s_scle;
global operator <  ( s : string; t : char ) sclt : boolean;  external s_sclt;
global operator <> ( s : string; t : char ) scne : boolean;  external s_scne;
global operator =  ( s : char; t : string ) cseq : boolean;  external s_cceq;
global operator >= ( s : char; t : string ) csge : boolean;  external s_csge;
global operator >  ( s : char; t : string ) csgt : boolean;  external s_csgt;
global operator <= ( s : char; t : string ) csle : boolean;  external s_csle;
global operator <  ( s : char; t : string ) cslt : boolean;  external s_cslt;
global operator <> ( s : char; t : string ) csne : boolean;  external s_csne;

global function     length( s : string )           :integer ; external s_len_;
global function  maxlength( s : string )           :integer ; external s_alen;
global procedure setlength( var s : string; n:integer)      ; external s_slen;
global function     pos   (s,      t: string )     :integer ; external s_spos;
global function     pos   (c:char; s: string )     :integer ; external s_cpos;
global function substring (s: string; i,n: integer): string ; external s_subs;

global operator in ( s : string; t : string ) ssin : boolean;
      begin   ssin := pos (s,t) <> 0   end ;

global function ival ( s : string; var rest: string  ) : integer ;
      external a_sval;
global function ival ( s : string                    ) : integer ;
      external a_ival;
global function rval ( s : string; rnd : integer; var rest: string) : real ;
      external r_sval;
global function rval ( s : string; rnd : integer) : real ;
      external r_rval;
global function rval ( s : string; var rest: string) : real ;
                      begin rval := rval (s,0,rest) end ;
global function rval ( s : string) : real ;
  var dummy:string;   begin rval := rval (s,0,dummy) end ;
global function image (i:integer; w : integer ) : string;
      external s_int_;
global function image (i:integer) : string;
                      begin image := image (i,0) end ;
global function image ( r : real; w,f,rnd : integer ) : string;
      external s_real;
global function image ( r : real; w,f     : integer ) : string;
                      begin image := image (r,w,f,0) end ;
global function image ( r : real; w       : integer ) : string;
                      begin image := image (r,w,0,0) end ;
global function image ( r : real                    ) : string;
                      begin image := image (r,0,0,0) end ;

{  PASCAL-XSC standard input/output }

global procedure readln  (var t : text) ; external f_rdln ;
global procedure writeln (var t : text) ; external f_wrln ;
global procedure read  (var t : text; var c : char              ) ; external f_rdh1 ;
global procedure read ( var t : text; var s : string            ) ; external f_rds1;
global procedure read  (var t : text; var i : integer           ) ; external f_rdi1 ;
global procedure read  (var t : text; var r : real              ) ; external f_rdr1 ;
global procedure read  (var t : text; var r : real; i : integer ) ; external f_rdr2 ;

global procedure write (var t : text; c : char                ) ; external f_wrh1 ;
global procedure write (var t : text; c : char   ; i : integer) ; external f_wrh2 ;
global procedure write( var t : text; s : string              ) ; external f_wrs1 ;
global procedure write( var t : text; s : string ; i : integer) ; external f_wrs2 ;
global procedure write (var t : text; i : integer             ) ; external f_wri1 ;
global procedure write (var t : text; i ,          j : integer) ; external f_wri2 ;
global procedure write (var t : text; b : boolean             ) ; external f_wrb1 ;
global procedure write (var t : text; b : boolean; i : integer) ; external f_wrb2 ;
global procedure write (var t : text; r : real                ) ; external f_wrr1 ;
global procedure write (var t : text; r : real; i    : integer) ; external f_wrr2 ;
global procedure write (var t : text; r : real; i, j : integer) ; external f_wrr3 ;
global procedure write (var t : text; r : real; i,j,k: integer) ; external f_wrr4 ;

global procedure page  (var t : text) ; begin write (t, chr(12)) end ;
global procedure page ; begin write (chr(12)) end ;

global procedure reset   (var t : text ;  s : string ) ; external f_srse ;
global procedure rewrite (var t : text ;  s : string ) ; external f_srwi ;

end.
