/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: a_bclr.c,v 1.2 1997/09/25 16:49:11 ae59 Exp $ */
/*
$Log: a_bclr.c,v $
 * Revision 1.2  1997/09/25  16:49:11  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:20:38  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : a_bclr.c                              */
/*                                                              */
/*      Entries         : a_intg a_bclr(a,m)                    */
/*                        a_intg a;                             */
/*                        a_intg m;                             */
/*                                                              */
/*      Arguments       : a = integer bit operand               */
/*                        m = bit number                        */
/*                                                              */
/*      Description     : CLEAR bit of an integer a             */
/*                        m position of bit with m=0 is         */
/*                        right-most bit in integer.            */
/*                        0<=m<=31.                             */
/*                                                              */
/*      Function value  : integer a with bit m cleared.         */
/*                                                              */
/*      Date            : 1991-02-25                            */
/*      1991-02-25 : new routine                                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_intg a_bclr(a_intg a,a_intg m)
#else
local a_intg a_bclr(a,m)

a_intg a;
a_intg m;
#endif
        {
        E_TPUSH("a_bclr")

        if (m<0 || m>B_LENGTH-1)
           e_trap(INDEX_RANGE,2,E_TINT+E_TEXT(13),&m);
        else
           a &= ~(((a_btyp)1)<<m);

        E_TPOPP("a_bclr")
        return(a);
        }

