/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: a_bmsb.c,v 1.2 1997/09/25 16:49:29 ae59 Exp $ */
/*
$Log: a_bmsb.c,v $
 * Revision 1.2  1997/09/25  16:49:29  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:20:39  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : a_bmsb.c                              */
/*                                                              */
/*      Entries         : a_intg a_bmsb(a)                      */
/*                        a_intg a;                             */
/*                                                              */
/*      Arguments       : a = integer bit operand               */
/*                                                              */
/*      Description     : Bit position of MSB of an integer     */
/*                                                              */
/*      Function value  : position of most significant bit      */
/*                        of an integer with position 0 is      */
/*                        right-most bit of integer.            */
/*                        -1 is returned if no bits are set.    */
/*                                                              */
/*      Date            : 1991-02-25                            */
/*      1991-02-25 : new routine                                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_intg a_bmsb(a_intg a)
#else
local a_intg a_bmsb(a)

a_intg a;
#endif
        {
        a_intg res;

        E_TPUSH("a_bmsb")

        if (a<0) res = 31;
        else
           {
           res = -1;
           while (a)
              {
              a >>= 1;
              res++;
              }
           }

        E_TPOPP("a_bmsb")
        return(res);
        }

