/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: a_brtt.c,v 1.2 1997/09/25 16:50:09 ae59 Exp $ */
/*
$Log: a_brtt.c,v $
 * Revision 1.2  1997/09/25  16:50:09  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:20:40  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : a_brtt.c                              */
/*                                                              */
/*      Entries         : a_intg a_brtt(a,m)                    */
/*                        a_intg a;                             */
/*                        a_intg m;                             */
/*                                                              */
/*      Arguments       : a = integer bit operand               */
/*                        m = shift value                       */
/*                                                              */
/*      Description     : Bit ROTATE of an integer a            */
/*                        m positions to the left if m>0, or    */
/*                        m positions to the right if m<0       */
/*                                                              */
/*      Function value  : logically ROTATed integer a           */
/*                        represented as integer                */
/*                                                              */
/*      Date            : 1991-02-25                            */
/*      1991-02-25 : new routine                                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_intg a_brtt(a_intg a,a_intg m)
#else
local a_intg a_brtt(a,m)

a_intg a;
a_intg m;
#endif
        {
        E_TPUSH("a_brtt")

        if (m<0 && m>MININT)
           {
           if ((m = (-m) % B_LENGTH)!=0)
              a = (((a_btyp)a)>>m) | (a<<(B_LENGTH-m));
           }
        else if (m>0)
           {
           if ((m %= B_LENGTH)!=0)
              a = (a<<m) | (((a_btyp)a)>>(B_LENGTH-m));
           }

        E_TPOPP("a_brtt")
        return(a);
        }

