/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: a_btst.c,v 1.2 1997/09/25 16:50:38 ae59 Exp $ */
/*
$Log: a_btst.c,v $
 * Revision 1.2  1997/09/25  16:50:38  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:20:41  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : a_btst.c                              */
/*                                                              */
/*      Entries         : a_bool a_btst(a,m)                    */
/*                        a_intg a;                             */
/*                        a_intg m;                             */
/*                                                              */
/*      Arguments       : a = integer bit operand               */
/*                        m = bit number                        */
/*                                                              */
/*      Description     : TEST bit  of an integer a             */
/*                        m position of bit with m=0 is         */
/*                        right-most bit in integer.            */
/*                        0<=m<=31.                             */
/*                                                              */
/*      Function value  : TRUE if bit is set.                   */
/*                        FALSE if bit is not set.              */
/*                                                              */
/*      Date            : 1991-09-10                            */
/*      1991-09-10 : (a_btyp) cast added                        */
/*      1991-02-25 : new routine                                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_bool a_btst(a_intg a,a_intg m)
#else
local a_bool a_btst(a,m)

a_intg a;
a_intg m;
#endif
        {
        a_bool res;

        E_TPUSH("a_btst")

        if (m<0 || m>B_LENGTH-1)
           {
           e_trap(INDEX_RANGE,2,E_TINT+E_TEXT(13),&m);
           res = FALSE;
           }
        else if (m==B_LENGTH-1)
           res = (a<0) ? TRUE : FALSE;
        else
           res = (a & (((a_btyp)1)<<m)) ? TRUE : FALSE;

        E_TPOPP("a_btst")
        return(res);
        }

