/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: a_free.c,v 1.2 1997/09/25 16:51:29 ae59 Exp $ */
/*
$Log: a_free.c,v $
 * Revision 1.2  1997/09/25  16:51:29  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:20:44  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : a_free.c                              */
/*                                                              */
/*      Entries         : void a_free(p)                        */
/*                        a_VOID *p;                            */
/*                                                              */
/*      Arguments       : p = pointer to object to be freed     */
/*                                                              */
/*      Description     : Free object.                          */
/*                                                              */
/*      Date            : 1990-11-15                            */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/*      1990-10-11 : argument changed to char **                */
/*      1990-09-18 : argument changed to a_VOID *               */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void a_free(char **p)
#else
local void a_free(p)

char **p;
#endif
        {
        E_TPUSH("a_free")

        if (a_nilc(*p)!=NULL)
           {
#ifdef HEAP_CHECK
b_freh((a_char *)p,(a_char *)(*p),(a_char *)"a_free");
#endif
           free(*p);
           *p = NULL;
           }

        E_TPOPP("a_free")
        return;
        }
