/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: a_ival.c,v 1.2 1997/09/25 16:51:48 ae59 Exp $ */
/*
$Log: a_ival.c,v $
 * Revision 1.2  1997/09/25  16:51:48  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:20:45  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : a_ival.c                              */
/*                                                              */
/*      Entries         : a_intg a_ival(s)                      */
/*                        s_trng s;                             */
/*                                                              */
/*      Arguments       : s = input string                      */
/*                                                              */
/*      Description     : Convert integer literal to integer    */
/*                                                              */
/*      Note            : 0 returned in case of error           */
/*                                                              */
/*      Date            : 1991-02-13                            */
/*      1991-02-13 : E_TSTG used in e_trap() call               */
/*      1991-01-22 : BUFFERSIZE removed                         */
/*      1990-12-05 : break supplied in while loop               */
/*      1990-11-20 : code changed for const-opt. compilers      */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_intg a_ival(s_trng s)
#else
local a_intg a_ival(s)

s_trng s;
#endif
        {
        a_intg dig,res,len;
        a_bool sign;
        a_char ch;

        E_TPUSH("a_ival")

        len = res = 0;
        sign = FALSE;

        /* ignore leading blanks                             */
        while (len<s.clen)
           if (s.ptr[len]==' ') len++;
           else break;

        if (len==s.clen)
           {
           e_trap(I_O_ERROR,2,E_TMSG,62);
           }
        else
           {

           /* check for sign                                 */
           if (s.ptr[len]=='+') len++;
           else if (s.ptr[len]=='-')
              {
              len++;
              sign = TRUE;
              }

           if (len==s.clen)
              {
              e_trap(I_O_ERROR,4,E_TMSG,63,E_TSTG+E_TEXT(10),&s);
              }

           /* handle first decimal digit                     */
           else if (!isdigit(s.ptr[len]))
              {
              ch = s.ptr[len];
              e_trap(I_O_ERROR,4,E_TMSG,21,E_TCHR,&ch);
              }

           /* convert decimal string to integer              */
           else
              {
              res = s.ptr[len]-'0';

              while (++len<s.clen)
              if (isdigit(s.ptr[len]))
                 {
                 dig = s.ptr[len]-'0';

                 /* check for integer overflow               */
                 if ((MAXINT-dig)/10<res)
                    {
                    if (sign && (MININT+dig)/10==-res)
                       res = MININT;
                    else
                       {
                       if (sign) res = MININT;
                       else res = MAXINT;
                       while (++len<s.clen)
                          if (!isdigit(s.ptr[len])) break;
                       e_trap(OVERFLOW,4,E_TMSG,15,E_TSTG+E_TEXT(10),&s);
                       break;
                       }
                    }

                 /* add digit                                */
                 else
                    res = res*10+dig;
                 }
              else
                 break;

              if (sign && res!=MININT) res = -res;
              }
           }

        if (len>BUFFERSIZE && isdigit(s.ptr[len]))
           e_trap(I_O_BUFFER,2,E_TMSG,56);

        if (s.tmp) s_free(&s);

        E_TPOPP("a_ival")
        return(res);
        }

