/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: a_pptr.c,v 1.2 1997/09/25 16:52:59 ae59 Exp $ */
/*
$Log: a_pptr.c,v $
 * Revision 1.2  1997/09/25  16:52:59  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:20:48  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : a_pptr.c                              */
/*                                                              */
/*      Entries         : void a_2pop()                         */
/*                      : void a_2psh(a_VOID new_d,a_VOID old)  */
/*                      : void a_cpsh(a_VOID new_d,a_VOID old)  */
/*                                                              */
/*      Description     : manage stack entries on stack         */
/*                        referenced by a_ptop                  */
/*                                                              */
/*      Date            : 1991-07-21                            */
/*      1992-07-21 : changed new to new_d ,cast to char in =b=  */ 
/*                   free()                                     */
/*      1991-08-08 : new routine                                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern struct a_pptr *a_ptop;
#endif

#ifdef LINT_ARGS
local void a_2pop(void)
#else
local void a_2pop()
#endif
        {
        a_VOID p;

        /* Neues Display schon installiert? */
        if ( a_ptop->new_d!=NULL )
           {  /* Nein ! */
           p = a_ptop->new_d;
           a_ptop->new_d = NULL;
           }
        else
           {
           /* Ja. Altes Display reinstallieren */
           a_pptr *temp = a_ptop;

           p = a_ptop->old;
           a_ptop = a_ptop->prev;

           /* Stack ruecksetzen                */
#ifdef HEAP_CHECK
b_freh((a_char *)&temp,(a_char *)temp,(a_char *)"a_pptr");
#endif
           free((char*) temp);
           }

        for (; p!=NULL;  p = *(a_VOID*)p)
           **((a_VOID**)p+1) = p;

        return;
        }

#ifdef LINT_ARGS
void a_2psh(a_VOID new_d, a_VOID old)
#else
void a_2psh(new_d, old)
a_VOID new_d, old;
#endif
        {
        a_pptr *temp;

        temp = (a_pptr *) malloc (sizeof(*temp));
#ifdef HEAP_CHECK
b_freh((a_char *)&temp,(a_char *)temp,(a_char *)"a_pptr");
#endif
        temp->new_d = new_d;
        temp->old = old;
        temp->prev = a_ptop;
        a_ptop = temp;

        return;
        }

#ifdef LINT_ARGS
void a_cpsh(a_VOID new_d, a_VOID old)
#else
void a_cpsh(new_d, old)
a_VOID new_d, old;
#endif
        {
        if (new_d!=NULL) a_2psh (new_d, old);

        return;
        }


