/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: a_sets.c,v 1.2 1997/09/25 16:53:08 ae59 Exp $ */
/*
$Log: a_sets.c,v $
 * Revision 1.2  1997/09/25  16:53:08  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:20:48  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : a_sets.c                              */
/*                                                              */
/*      Entries         : void a_sets(rounding)                 */
/*                        int rounding;                         */
/*                                                              */
/*      Arguments       : rounding = rounding mode              */
/*                                                              */
/*      Description     : Set rounding mode in hardware status. */
/*                                                              */
/*      Note            : Version for IBM_RT_C                  */
/*                                                              */
/*      Date            : 1991-12-18                            */
/*      1991-12-18 : empty routine if not supported             */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
/*
extern a_bool e_efdz;
extern a_bool e_efie;
extern a_bool e_efio;
extern a_bool e_efof;
extern a_bool e_efuf;
*/
#endif

#ifdef IEEE_HARDWARE
#if IBM_RT_C

#undef MININT
#include <sys/FP.h>
#undef MININT

#ifdef LINT_ARGS
void a_sets(int rounding)
#else
void a_sets(rounding)

int rounding;
#endif
        {
        FP_STATUS status;

        /* get status from processor */
        *((unsigned *)&status) =
           (*(unsigned (*)())_fpfpf[(int)FP_getst])();

        /* set/reset trap enable flags if kill flag is set */
/*
        *((unsigned *)&status) |= 0x80000000L;
        if (e_efio) *((unsigned *)&status) |= 0x10000000L;
        else        *((unsigned *)&status) &= 0xefffffffL;
        if (e_efdz) *((unsigned *)&status) |= 0x04000000L;
        else        *((unsigned *)&status) &= 0xfbffffffL;
        if (e_efof) *((unsigned *)&status) |= 0x01000000L;
        else        *((unsigned *)&status) &= 0xfeffffffL;
        if (e_efuf) *((unsigned *)&status) |= 0x00400000L;
        else        *((unsigned *)&status) &= 0xffbfffffL;
        if (e_efie) *((unsigned *)&status) |= 0x00000020L;
        else        *((unsigned *)&status) &= 0xffffffdfL;
*/

        /* reset exception occurrence flags and rounding */
        /* reset kill flag */
/*
        *((unsigned *)&status) &= 0x957ffe3fL;
        *((unsigned *)&status) &= 0x7fffffffL;
*/
        *((unsigned *)&status) &= 0x157ffe3fL;

        /* set rounding mode */
        status.rnd_mode = rounding;

        /* set status in processor */
        (*(unsigned (*)())_fpfpf[(int)FP_setst])(status);
        return;
        }
#else
#ifdef LINT_ARGS
void a_sets(int rounding)
#else
void a_sets(rounding)

int rounding;
#endif
        {
        }
#endif
#else
#ifdef LINT_ARGS
void a_sets(int rounding)
#else
void a_sets(rounding)

int rounding;
#endif
        {
        }
#endif
