/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: a_sub_.c,v 1.2 1997/09/25 16:53:25 ae59 Exp $ */
/*
$Log: a_sub_.c,v $
 * Revision 1.2  1997/09/25  16:53:25  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:20:49  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : a_sub_.c                              */
/*                                                              */
/*      Entries         : a_intg a_sub_(a,b)                    */
/*                        a_intg a;                             */
/*                        a_intg b;                             */
/*                                                              */
/*      Arguments       : a = term of subtraction               */
/*                        b = term of subtraction               */
/*                                                              */
/*      Description     : Subtraction of integer values         */
/*                                                              */
/*      Note            : 0 returned in case of error           */
/*                                                              */
/*      Date            : 1990-11-15                            */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/*      1990-10-24 : NO_ERROR replaced by OVERFLOW              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_intg a_sub_(a_intg a,a_intg b)
#else
local a_intg a_sub_(a,b)

a_intg a;
a_intg b;
#endif
        {
        E_TPUSH("a_sub_")

        if (b<=0)
           {
           if (a<=MAXINT+b) a -= b;
           else
              {
              e_trap(OVERFLOW,6,E_TMSG,15,E_TINT+E_TEXT(1),&a,
                                          E_TINT+E_TEXT(2),&b);
              a = 0;
              }
           }
        else if (a>=MININT+b) a -= b;
        else
           {
           e_trap(OVERFLOW,6,E_TMSG,15,E_TINT+E_TEXT(1),&a,
                                       E_TINT+E_TEXT(2),&b);
           a = 0;
           }

        E_TPOPP("a_sub_")
        return(a);
        }

