/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: addbody.h,v 1.3 1997/09/25 16:42:17 ae59 Exp $ */
/*
$Log: addbody.h,v $
 * Revision 1.3  1997/09/25  16:42:17  ae59
 * Copyright-message
 *
 * Revision 1.2  1994/10/12  12:56:52  ae59
 * result returned in case of a=b=inf with different sign
 *
 * Revision 1.1  1994/01/27  13:20:52  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : addbody.h                             */
/*                                                              */
/*      Description     : Addition of IEEE numbers.             */
/*                                                              */
/*      Notes           : included by r_addn.c,r_addd.c,r_addu.c*/
/*                                                              */
/*      Include         : body.h                                */
/*                                                              */
/*      Date            : 1991-11-13                            */
/*      1991-11-13 : handle zero operands after NaN,infinity    */
/*      1991-04-23 : MANT_INFINITY() used                       */
/*      1991-01-07 : SIGNALING macro introduced                 */
/*      1990-11-16 : E_TPUSH+E_TPOPP                            */
/*      1990-11-12 : INV_OP                                     */
/*      1990-07-19 : missing calls to e_popp() inserted.        */
/****************************************************************/

                /* a = infinity or NaN                          */
                if (expoa>EXPO_MAX) {

                   /* a = infinity                              */
                   if (MANT_INFINITY(manta)) {

                      /* b = infinity or NaN                    */
                      if (expob>EXPO_MAX) {

                         /* a = b = infinity                    */
                         if (MANT_INFINITY(mantb)) {
                            if (vza!=vzb)
                               e_trap(INV_OP+E_IEEE,8,E_TMSG,9,
                                      E_TDBL+E_TEXT(1),&a,
                                      E_TDBL+E_TEXT(2),&b,
                                      E_TDBL+E_TRES,&a);
                            E_TPOPP("addbody")
                            return(a);
                            }

                         /* a = infinity b = NaN                */
                         if (SIGNALING(mantb[0]))
                            e_trap(INV_OP+E_IEEE,8,E_TMSG,5,
                                   E_TDBL+E_TEXT(1),&a,E_TDBL+E_TEXT(1),&b,
                                   E_TDBL+E_TRES,&b);
                         E_TPOPP("addbody")
                         return(b);
                         }

                      /* add number to infinity => a  */
                      E_TPOPP("addbody")
                      return(a);
                      }

                   /* a = NaN                                   */
                   else {
                      if (SIGNALING(manta[0]))
                         e_trap(INV_OP+E_IEEE,8,E_TMSG,5,
                                E_TDBL+E_TEXT(1),&a,E_TDBL+E_TEXT(2),&b,
                                E_TDBL+E_TRES,&a);

                      /* a = qNaN     b = sNaN                  */
                      else if (expob>EXPO_MAX && !MANT_INFINITY(mantb) && 
                               SIGNALING(mantb[0]))
                         {
                         e_trap(INV_OP+E_IEEE,8,E_TMSG,5,
                                E_TDBL+E_TEXT(1),&a,
                                E_TDBL+E_TEXT(2),&b,E_TDBL+E_TRES,&b);
                         E_TPOPP("addbody")
                         return(b);
                         }

                      E_TPOPP("addbody")
                      return(a);
                      }
                   }

                /* b = infinity or NaN                          */
                else {

                   /* b = NaN                                   */
                   if (!MANT_INFINITY(mantb))
                      {

                      /* b = NaN                                */
                      if (SIGNALING(mantb[0]))
                         e_trap(INV_OP+E_IEEE,8,E_TMSG,5,
                                E_TDBL+E_TEXT(1),&a,
                                E_TDBL+E_TEXT(2),&b,E_TDBL+E_TRES,&b);
                      }
                   E_TPOPP("addbody")
                   return(b);
                   }
                }
        if (zeroa) 
           {
           E_TPOPP("addbody")
           return(b);
           }

        if (zerob) 
           {
           E_TPOPP("addbody")
           return(a);
           }

/* equivalent part for addition and subtraction                 */
#ifdef AIX
#include "/u/p88c/runtime/real/body.h"
#else
#include "body.h"
#endif
