/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_addm.c,v 1.2 1997/09/25 16:54:53 ae59 Exp $ */
/*
$Log: b_addm.c,v $
 * Revision 1.2  1997/09/25  16:54:53  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:20:54  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : b_addm.c                              */
/*                                                              */
/*      Entry           : a_bool b_addm(k,a,b)                  */
/*                        a_intg k;                             */
/*                        a_btyp *a,*b;                         */
/*                                                              */
/*      Arguments       : a = first operand of addition         */
/*                        b = second operand of addition        */
/*                        k = size of operands                  */
/*                                                              */
/*      Function value  : TRUE if carry remains                 */
/*                                                              */
/*      Description     : Addition of a_btyp arrays             */
/*                        a = a+b                               */
/*                                                              */
/*      Date            : 1990-07-16                            */
/*      1990-07-16 : LINT_ARGS prototype                        */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_bool b_addm(a_intg k,a_btyp *a,a_btyp *b)
#else
local a_bool b_addm(k,a,b)

a_intg k;
a_btyp *a;
a_btyp *b;
#endif
        {
        a_intg cin;
        a_btyp c;

        cin = 0;
        while (--k>=0) {
#if C_P_1
                c = a[k]+b[k]+cin;
                cin = (~a[k]<b[k] || (c==ZERO && cin)) ? 1 : 0;
                a[k] = c;
#else
                b_addu(a[k],b[k],cin,a+k,&cin);
#endif
                }

        return((cin!=0) ? TRUE : FALSE);
        }


