/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_bacm.c,v 1.2 1997/09/25 16:56:21 ae59 Exp $ */
/*
$Log: b_bacm.c,v $
 * Revision 1.2  1997/09/25  16:56:21  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:00  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_bacm.c          Processor : C                   */
/*                                                                      */
/* Compare absolute value of non-zero intern numbers                    */
/*                                                                      */
/* Function value : int     0 - numbers are equal                       */
/*                         -1 - first number less than second number    */
/*                          1 - first number greater than second number */
/*                                                                      */
/* Function references : b_bmcm - compare mantissas of intern numbers   */
/*                       b_bmts - test mantissa to be non-zero          */
/*                                                                      */
/* Globals referenced : none                                            */
/*                                                                      */
/*      Date            : 1990-08-02                            */
/*      1990-07-16 : LINT_ARGS prototype                        */
/*      1990-08-02 : explicit compare                           */
/*                   result cast (int)                          */
/************************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local int b_bacm(multiprecision i1,multiprecision i2)
#else
local int b_bacm(i1,i2)

multiprecision i1;
multiprecision i2;   /* pointer to intern variables                  */
#endif
        {
        int cv;      /* !!! must be int !!! */
/*----------------------------------------------------------------------*/
        if (i1->e>i2->e) return(1);
/*----------------------------------------------------------------------*/
        if (i1->e<i2->e) return(-1);
/*----------------------------------------------------------------------*/
        if (i1->l<i2->l)
           {
           if ((cv = b_bmcm(i1->l,i1->m,i2->m))!=0) return(cv);
           return(-b_bmts(i2->l-i1->l,&i2->m[i1->l]));
           }
/*----------------------------------------------------------------------*/
        if ((cv = b_bmcm(i2->l,i1->m,i2->m))!=0) return(cv);
        return(b_bmts(i1->l-i2->l,&i1->m[i2->l]));
        }
