/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_badd.c,v 1.2 1997/09/25 16:56:29 ae59 Exp $ */
/*
$Log: b_badd.c,v $
 * Revision 1.2  1997/09/25  16:56:29  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:00  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_badd.c          Processor : C                   */
/*                                                                      */
/* Add numbers in intern representation                                 */
/*                                                                      */
/* Function value : int     0 - intern numbers added                    */
/*                      OFLOW - exponent overflow                       */
/*                      UFLOW - exponent underflow                      */
/*                      ALLOC - allocation error                        */
/*                                                                      */
/* Function references : b_bacm - compare absolute values of intern     */
/*                       b_bcpy - copy intern numbers                   */
/*                       b_baad - add absolute intern values            */
/*                       b_basu - subtract absolute intern values       */
/*                                                                      */
/*      Date            : 1990-07-16                            */
/*      1990-07-16 : LINT_ARGS prototype                        */
/************************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local int b_badd(multiprecision i1,multiprecision i2,multiprecision r)
#else
local int b_badd(i1,i2,r)

multiprecision i1;
multiprecision i2;      /* pointer to intern variables                  */
multiprecision r;       /* pointer to intern result                     */
#endif
        {
        a_intg cv;         /* compare value                                */
/*----------------------------------------------------------------------*/
        if (i1->z) return(b_bcpy(i2,r));
                        /* first operand is zero                        */
/*----------------------------------------------------------------------*/
        if (i2->z) return(b_bcpy(i1,r));
                        /* second operand is zero                       */
/*----------------------------------------------------------------------*/
        cv = b_bacm(i1,i2);
                        /* compare absolute values of intern numbers    */
/*----------------------------------------------------------------------*/
        if (i1->s==i2->s)
           {
           r->s = i1->s;
           if (cv>=0)
              return(b_baad(i1,i2,r));
           else
              return(b_baad(i2,i1,r));
           }            /* addition of equaly signed numbers            */
/*----------------------------------------------------------------------*/
        if (cv<0)
           {
           r->s = i2->s;
           return(b_basu(i2,i1,r));
           }            /* subtract first from second absolute value    */
/*----------------------------------------------------------------------*/
        if (cv)
           {
           r->s = i1->s;
           return(b_basu(i1,i2,r));
           }            /* subtract second from first absolute value    */
/*----------------------------------------------------------------------*/
        if (r->l) { r->l = 0; B_FREE(r->m) }
        r->z = 1;
        r->r = 0;       /* subtraction of equal absolute values         */
/*----------------------------------------------------------------------*/
        return(0);
        }
