/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_bcpy.c,v 1.2 1997/09/25 16:57:45 ae59 Exp $ */
/*
$Log: b_bcpy.c,v $
 * Revision 1.2  1997/09/25  16:57:45  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:05  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_bcpy.c          Processor : C                   */
/*                                                                      */
/* Copy number in intern representation                                 */
/*                                                                      */
/* Function value : int     0 - data copied                             */
/*                      ALLOC - allocation error                        */
/*                                                                      */
/* Function references :                                                */
/*                       b_ball - allocate unsigned array               */
/*                       b_bmts - test unsigned arrat to be non-zero    */
/*                                                                      */
/* Rounding : none                                                      */
/*                                                                      */
/*      Date            : 1990-08-02                    */
/*      1990-07-13 : LINT_ARGS prototype, Maxl renamed  */
/*      1990-08-02 : explicit compare                   */
/********************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_btyp b_maxl;
#endif

#ifdef LINT_ARGS
local int b_bcpy(multiprecision i,multiprecision r)
#else
local int b_bcpy(i,r)

multiprecision i;
multiprecision r;     /* pointer to intern variables                  */
#endif
        {
        a_btyp *s;    /* pointer to result mantissa                   */
        a_intg m;          /* length of result mantissa                    */
/*----------------------------------------------------------------------*/
        if ((r->z = i->z)!=0)
           {
           r->r = 0;
           if (r->l)
              {
              r->l = 0;
#ifdef HEAP_CHECK
b_freh((a_char *)&r->m,(a_char *)r->m,(a_char *)"b_bcpy");
#endif
              B_FREE(r->m)
              }
           return(0);
           }
                        /* number to be copied is zero                  */
/*----------------------------------------------------------------------*/
        m = (i->l>b_maxl) ? b_maxl : i->l;
/*----------------------------------------------------------------------*/
        if (i!=r)
           {
           r->e = i->e;
           r->s = i->s;
           }
        else if (i->l==m) { r->r = 0; return(0); }
/*----------------------------------------------------------------------*/
        r->r = b_bmts(i->l-m,i->m+m);
/*----------------------------------------------------------------------*/
        if (b_ball(m,&s)) return(ALLOC);
/*----------------------------------------------------------------------*/
        B_COPY(s,i->m,m)
/*----------------------------------------------------------------------*/
        if (r->l)
           {
#ifdef HEAP_CHECK
b_freh((a_char *)&r->m,(a_char *)r->m,(a_char *)"b_bcpy");
#endif
           B_FREE(r->m)
           }
        r->l = m;
        r->m = s;
/*----------------------------------------------------------------------*/
        return(0);
        }
