/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_blgx.c,v 1.2 1997/09/25 16:58:46 ae59 Exp $ */
/*
$Log: b_blgx.c,v $
 * Revision 1.2  1997/09/25  16:58:46  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:09  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : b_blgx.c                              */
/*                                                              */
/*      Entries         : a_btyp b_blgx(a,res)                  */
/*                        a_real a;                             */
/*                        a_real res;                           */
/*                                                              */
/*      Arguments       : a = real argument of function         */
/*                      : res = real result of function         */
/*                                                              */
/*      Description     : logarithm to base 10 (exact)          */
/*                                                              */
/*      Date            : 1991-04-22                            */
/*      1991-04-22 : real assignment replaced by R_ASSIGN()     */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/*      1990-10-18 : real operations                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_real *r_ten_,*r_one_;
#endif

#ifdef LINT_ARGS
local a_btyp b_blgx( a_real a, a_real *res )
#else
local a_btyp b_blgx( a, res )
a_real a;
a_real *res;
#endif

{
        a_real          k;
        int             i;
        a_btyp          rc;

        E_TPUSH("b_blgx")

        rc= 0;
        R_ASSIGN(k,*r_one_);
        for (i=1; i<=23; i++) {
          R_ASSIGN(k,r_muld(k,*r_ten_));
          if (r_eq(k,a)) {
            R_ASSIGN(*res,r_flot((a_intg)i));
            rc= 1;
          }
        } /* end for */

        E_TPOPP("b_blgx")
        return(rc);  /*result not exactly representable */
        }
