/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_bmat.c,v 1.2 1997/09/25 16:58:53 ae59 Exp $ */
/*
$Log: b_bmat.c,v $
 * Revision 1.2  1997/09/25  16:58:53  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:09  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_bmat.c          Processor : C                   */
/*                                                                      */
/* Carry from addition of mantissas                                     */
/*                                                                      */
/* Function value :   int     - value of carry                          */
/*                                                                      */
/* Functione references : none                                          */
/*                                                                      */
/*      Date            : 1990-08-02                            */
/*      1990-07-16 : LINT_ARGS prototype                        */
/*      1990-08-02 : result cast (int)                          */
/************************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local int b_bmat(a_intg n,a_btyp *i1,a_btyp *i2,a_intg carry,a_intg *r)
#else
local int b_bmat(n,i1,i2,carry,r)

a_intg n;               /* length of mantissas added                    */
a_btyp *i1;
a_btyp *i2;           /* pointer to intern mantissas                  */
a_intg carry;           /* carry value at lsb position                  */
a_intg *r;              /* non-zero mantissa                            */
#endif
        {
        a_btyp rn;    /* sum of digits                                */
/*----------------------------------------------------------------------*/
        i1 += n;
        i2 += n;
        rn = 0;
        while (--n>=0)
        if (~*(--i1)>*(--i2))
           {
           rn |= *i1+*i2+carry;
           carry = 0;
           }
        else if (~*i1<*i2)
           {
           if (*i1 & MSB)
              if (*i2 & MSB)
                 rn |= (*i1 ^ MSB) + (*i2 ^ MSB) + carry;
              else
                 rn |= ((*i1 ^ MSB) + *i2 + carry) ^ MSB;
           else
              rn |= (*i1 + (*i2 ^ MSB) + carry) ^ MSB;
           carry = 1;
           }
        else
           rn |= ((carry) ? ZERO : MAX_BASETYPE);
/*----------------------------------------------------------------------*/
        *r = (rn) ? 1 : 0;
/*----------------------------------------------------------------------*/
        return((int)carry);
        }
