/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_bmdv.c,v 1.2 1997/09/25 16:59:06 ae59 Exp $ */
/*
$Log: b_bmdv.c,v $
 * Revision 1.2  1997/09/25  16:59:06  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:10  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_bmdv.c          Processor : C                   */
/*                                                                      */
/* Divide 3 digit number by 2 digit number to get a 1 digit result.     */
/*                                                                      */
/* Note : First digit of dividend < first digit of divisor.             */
/*                                                                      */
/* Entry type          : static                                         */
/* Function type       : int                                            */
/* Function value      : 0 - division done                              */
/* Error codes         : -                                              */
/* Include files       : defs.h                                         */
/* Function references : -                                              */
/* Globals referenced  : -                                              */
/* Rounding            : -                                              */
/*                                                                      */
/*      Date            : 1990-07-16                            */
/*      1990-07-16 : LINT_ARGS prototype                        */
/************************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local int b_bmdv(a_btyp *i1,a_btyp *i2,a_btyp *r)
#else
local int b_bmdv(i1,i2,r)

a_btyp *i1;                           /* pointer to dividend          */
a_btyp *i2;                           /* pointer to divisor           */
a_btyp *r;                            /* pointer to result digit      */
#endif
        {
        a_intg k;                       /* loop variable                */
        a_btyp s;                     /* indicates subtraction        */
        a_btyp d,e,f;                 /* digits of dividend           */
/*----------------------------------------------------------------------*/
        *r = 0;                         /* initialize result            */
/*----------------------------------------------------------------------*/
        if ((d = *i1)==ZERO) return(0); /* result is zero               */
/*----------------------------------------------------------------------*/
        e = *(i1+1);                    /* copy dividend i1 => d,e,f    */
        f = *(i1+2);
/*----------------------------------------------------------------------*/
        if ((d==*i2) && e==*(i2+1))
           {
           *r = MAX_BASETYPE;
           return(0);
           }
/*----------------------------------------------------------------------*/
        for (k=0;k<B_LENGTH;k++)
           {
           *r <<= 1;                    /* shift result 1 bit left      */
           s = d & MSB;                 /* MSB of dividend              */
                                        /* shift dividend 1 bit left    */
           d = (d<<1) | (e>>(B_LENGTH-1));
           e = (e<<1) | (f>>(B_LENGTH-1));
           f <<= 1;
           if (s==ZERO)                 /* MSB not set, divid.>=divis.  */
              if (d>*i2 || (d==*i2 && e>=*(i2+1))) s = 1;
           if (s)
              {
              (*r)++;                   /* increment result             */
              if (e<*(i2+1))
                 {
                 if (d) d--; else d = MAX_BASETYPE;
                 }
              d -= *i2;
              e -= *(i2+1);
              }
           }
/*----------------------------------------------------------------------*/
        return(0);
        }
