/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_bmsh.c,v 1.2 1997/09/25 16:59:24 ae59 Exp $ */
/*
$Log: b_bmsh.c,v $
 * Revision 1.2  1997/09/25  16:59:24  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:11  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_bmsh.c          Processor : C                   */
/*                                                                      */
/* Shift unsigned array to the left by several positions.               */
/* Bits shifted out are lost. Shift value : 0<n<B_LENGTH                */
/*                                                                      */
/* Function value : int     0 -                                         */
/*                                                                      */
/* Function references : none                                           */
/*                                                                      */
/*      Date            : 1990-07-16                            */
/*      1990-07-16 : LINT_ARGS prototype                        */
/************************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local int b_bmsh(a_intg l,a_btyp *s,a_intg n)
#else
local int b_bmsh(l,s,n)

a_intg l;       /* length of unsigned array                             */
a_btyp *s;      /* pointer to unsigned array                            */
a_intg n;       /* number of bits to be shifted                         */
#endif
        {
/*----------------------------------------------------------------------*/
        while (--l>0)
           {
           *s = ((*s)<<n) | (*(s+1)>>(B_LENGTH-n));
           s++;
           }
/*----------------------------------------------------------------------*/
        *s <<= n;
/*----------------------------------------------------------------------*/
        return(0);
        }
