/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_bmun.c,v 1.2 1997/09/25 16:59:51 ae59 Exp $ */
/*
$Log: b_bmun.c,v $
 * Revision 1.2  1997/09/25  16:59:51  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:13  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_bmun.c          Processor : C                   */
/*                                                                      */
/* Multiply number in internal format with unsigned integer             */
/*                                                                      */
/* Function value : int     0 - multiplication done                     */
/*                      OFLOW - overflow                                */
/*                      ALLOC - allocation error                        */
/*                                                                      */
/* Rounding : towards zero                                              */
/*                                                                      */
/*      Date            : 1990-07-12                                    */
/*      1990-07-12 : LINT_ARGS prototype, cp,Maxl renamed               */
/*                   a_btyp *cp -> dotprecision cp                      */
/************************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_btyp b_maxl;
extern dotprecision b_cp__;
#endif

#ifdef LINT_ARGS
local int b_bmun(multiprecision i,a_btyp n,multiprecision r)
#else
local int b_bmun(i,n,r)

multiprecision i;       /* pointer to intern variables                  */
a_btyp n;             /* unsigned integer factor                      */
multiprecision r;       /* pointer to intern result                     */
#endif
        {
        a_intg ii;         /* current length of mantissa part              */
        a_intg m;          /* length of exact product                      */
        a_intg k;          /* loop variable                                */
        a_intg cv;         /* count value                                  */
        a_btyp *s;    /* array holding complete product of mantissas  */
/*----------------------------------------------------------------------*/
        r->r = 0;
                        /* no rounding expected                         */
/*----------------------------------------------------------------------*/
        if (i->z || n==0) { r->z = 1; return(0); }
                        /* result is zero                               */
/*----------------------------------------------------------------------*/
        r->z = 0;
                        /* result is non-zero                           */
/*----------------------------------------------------------------------*/
        r->s = i->s;
                        /* sign of product                              */
/*----------------------------------------------------------------------*/
        if (i->e>=0)
        if (MAXINT-i->e<1) return(OFLOW);
                        /* check overflow                               */
/*----------------------------------------------------------------------*/
        r->e = i->e+1;
                        /* determine exponent of first part of product  */
/*----------------------------------------------------------------------*/
        m = i->l+1;     /* length of exact product                      */
/*----------------------------------------------------------------------*/
        if (m>A_LENGTH)
           {
           if (b_ball(m,&s)) return(ALLOC);
           }
        else
           {
           s = b_cp__;
           B_CLEAR(s,m)
           }
/*----------------------------------------------------------------------*/
        for (k=i->l-1;k>=0;k--)
           b_muad(i->m[k],n,s+k+1);
                        /* multiply and add product                     */
/*----------------------------------------------------------------------*/
        cv = 0;         /* digit count                                  */
/*----------------------------------------------------------------------*/
        if (!*s)
           {
           r->e--;
           cv = 1;
           }            /* adjust leading digit to be non-zero          */
/*----------------------------------------------------------------------*/
        ii = (m-cv<b_maxl) ? m-cv : b_maxl;
/*----------------------------------------------------------------------*/
        b_badj(ii,r);
/*----------------------------------------------------------------------*/
        for (k=0;k<ii;k++) r->m[k] = s[cv+k];
                        /* copy first result mantissa                   */
/*----------------------------------------------------------------------*/
        r->r = b_bmts(m-ii-cv,s+ii+cv);
                        /* result rounded                               */
/*----------------------------------------------------------------------*/
        if (m>A_LENGTH)
           {
#ifdef HEAP_CHECK
b_freh((a_char *)&s,(a_char *)s,(a_char *)"b_bmun");
#endif
           B_FREE(s)
           }
/*----------------------------------------------------------------------*/
        return(0);
        }
