/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_bnxt.c,v 1.2 1997/09/25 16:59:59 ae59 Exp $ */
/*
$Log: b_bnxt.c,v $
 * Revision 1.2  1997/09/25  16:59:59  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:14  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_bnxt.c          Processor : C                   */
/*                                                                      */
/* Determine next number away from zero.                                */
/* If zero was input zero is returned.                                  */
/*                                                                      */
/* Function value : int     0 - next number returned                    */
/*                      OFLOW - exponent overflow                       */
/*                      ALLOC - allocation error                        */
/*                                                                      */
/* Function references :                                                */
/*                       b_banx - next number in absolute value         */
/*                                                                      */
/*      Date            : 1990-07-16                            */
/*      1990-07-16 : LINT_ARGS prototype                        */
/************************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local int b_bnxt(multiprecision i,multiprecision r)
#else
local int b_bnxt(i,r)

multiprecision i;               /* pointer to intern variable           */
multiprecision r;               /* pointer to intern result             */
#endif
        {
/*----------------------------------------------------------------------*/
        if (i->z)
           {
           r->r = 0;
           r->z = 1;
           return(0);
           }            /* input is zero   zero returned                */
/*----------------------------------------------------------------------*/
        r->r = 0;
/*----------------------------------------------------------------------*/
        r->z = 0;       /* result is non-zero                           */
/*----------------------------------------------------------------------*/
        r->s = i->s;    /* copy sign of number                          */
/*----------------------------------------------------------------------*/
        return(b_banx(i,r));
                        /* next absolute number                         */
        }
