/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_brnd.c,v 1.2 1997/09/25 17:00:15 ae59 Exp $ */
/*
$Log: b_brnd.c,v $
 * Revision 1.2  1997/09/25  17:00:15  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:14  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_brnd.c          Processor : C                   */
/*                                                                      */
/* Determine intern floating point representation which is greater      */
/* or equal to input number + rounding ulps. Zero is returned if        */
/* zero was input.                                                      */
/*                                                                      */
/* Function value : int     0 - next number returned                    */
/*                      OFLOW - exponent overflow                       */
/*                      ALLOC - allocation error                        */
/*                                                                      */
/* Function references : b_bcpy - copy intern numbers                   */
/*                       b_banx - next number in absolute value         */
/*                                                                      */
/*      Date            : 1990-08-02                            */
/*      1990-07-16 : LINT_ARGS prototype                        */
/*      1990-08-02 : explicit compare                           */
/************************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local int b_brnd(multiprecision i,multiprecision r)
#else
local int b_brnd(i,r)

multiprecision i;       /* pointer to intern variable                   */
multiprecision r;       /* pointer to intern result                     */
#endif
        {
        int rc;            /* !!! must be int !!! */
        a_intg k;          /* loop variable                                */
/*----------------------------------------------------------------------*/
        if (i->r==0)
           {
           if ((rc = b_bcpy(i,r))!=0) return(rc);
           if (r->r==0) return(rc);
           return(b_banx(r,r));
           }
                        /* rounding indicator not set                   */
/*----------------------------------------------------------------------*/
        if (i->z)
           {
           r->r = 0;
           r->z = 1;
           return(0);
           }            /* input is zero   zero returned                */
/*----------------------------------------------------------------------*/
        r->z = 0;       /* result is non-zero                           */
/*----------------------------------------------------------------------*/
        r->s = i->s;    /* copy sign of number                          */
/*----------------------------------------------------------------------*/
        if ((rc = b_banx(i,r))!=0) return(rc);
/*----------------------------------------------------------------------*/
        for (k=1;k<i->r;k++) if ((rc = b_banx(r,r))!=0) return(rc);
/*----------------------------------------------------------------------*/
        r->r = 0;
/*----------------------------------------------------------------------*/
        return(rc);     /* next absolute number                         */
        }
