/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_busp.c,v 1.2 1997/09/25 17:00:35 ae59 Exp $ */
/*
$Log: b_busp.c,v $
 * Revision 1.2  1997/09/25  17:00:35  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:16  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_busp.c          Processor : C                   */
/*                                                                      */
/* Subtract product of unsigned factors from unsigned array.            */
/* Factors must be non-zero.                                            */
/*                                                                      */
/* Function value : int       - borrow value                            */
/*                                                                      */
/* Function references : b_bms1 - subtract 1 digit number from 1 digit  */
/*                       b_bms2 - subtract 1 digit number from 2 digit  */
/*                                                                      */
/*      Date            : 1990-08-02                            */
/*      1990-07-16 : LINT_ARGS prototype                        */
/*      1990-08-02 : explicit result cast (int)                 */
/************************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local int b_busp(a_btyp i,a_btyp u,a_btyp *r)
#else
local int b_busp(i,u,r)

a_btyp i;
a_btyp u;             /* unsigned factors                             */
a_btyp *r;            /* pointer to result mantissa of length 2       */
#endif
        {
        a_btyp ih;    /* upper half of i                              */
        a_btyp uh;    /* upper half of u                              */
        a_btyp p;     /* intermediate product                         */
        a_intg borrow;     /* borrow value                                 */
/*----------------------------------------------------------------------*/
        ih = i >> (B_LENGTH/2);
        i &= LOW_MASK;
        uh = u >> (B_LENGTH/2);
        u &= LOW_MASK;
                        /* split unsigned                               */
/*----------------------------------------------------------------------*/
        borrow = 0;
/*----------------------------------------------------------------------*/
        if (u)
           {
           if (i) borrow += b_bms2(i*u,r);
           if (ih)
              {
              p = ih*u;
              borrow += b_bms2(p<<(B_LENGTH/2),r)+
                        b_bms1(p>>(B_LENGTH/2),r);
              }
           }
/*----------------------------------------------------------------------*/
        if (uh)
           {
           if (i)
              {
              p = i*uh;
              borrow += b_bms2(p<<(B_LENGTH/2),r)+
                        b_bms1(p>>(B_LENGTH/2),r);
              }
           if (ih) borrow += b_bms1(ih*uh,r);
           }
/*----------------------------------------------------------------------*/
        return((int)borrow);
        }
