/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_deko.c,v 1.2 1997/09/25 17:01:53 ae59 Exp $ */
/*
$Log: b_deko.c,v $
 * Revision 1.2  1997/09/25  17:01:53  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:21  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : b_deko.c                              */
/*                                                              */
/*      Entries         : a_bool b_deko(x,expo,mant,vz)         */
/*                        a_real x;                             */
/*                        a_btyp *mant;                         */
/*                        a_intg *expo;                         */
/*                        a_bool *vz;                           */
/*                                                              */
/*      Description     : Decomposition of an IEEE double value */
/*                        x into exponent, mantissa and sign    */
/*                                                              */
/*      Function value  : FALSE if x!=0                         */
/*                        TRUE if x==0                          */
/*                                                              */
/*      Date            : 1991-09-09                            */
/*      1991-09-09 : reduce max. line length                    */
/*      1991-07-01 : NO! swap words within a_btyp for VAX_VMS_C */
/*      1991-04-30 : HIDDEN_BIT set in infinity mantissa        */
/*                   statement sequence changed                 */
/*      1990-11-09 : swap words within a_btyp for VAX_VMS_C     */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_bool b_deko(a_real x,a_intg *expo,a_btyp *mant,a_bool *vz)
#else
local a_bool b_deko(x,expo,mant,vz)

a_real x;
a_intg *expo;
a_btyp *mant;
a_bool *vz;
#endif
        {
        register a_btyp *u;

        u = (a_btyp *)&x;

        /* low part of mantissa */
        mant[1] = u[B_LPART];

        /* sign of real value   */
        *vz = (u[B_HPART] & MSB) ? TRUE : FALSE;

        /* high part of mantissa */
        mant[0] = (u[B_HPART] & MANT_HIGH) | HIDDEN_BIT;

        /* exponent of number   */
        if ((*expo = ((u[B_HPART] & EXPO_MASK)>>EXPO_SHIFT)-CHARAC)
            ==-CHARAC)
           {

           /* value is zero     */
           if (!((mant[0] &= NOT_HIDDEN_BIT) | mant[1]))
              return(TRUE);

           /* denormalized number  */
           *expo = -CHARAC+1;
           }

        return(FALSE);
        }

