/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_prod.c,v 1.2 1997/09/25 17:05:51 ae59 Exp $ */
/*
$Log: b_prod.c,v $
 * Revision 1.2  1997/09/25  17:05:51  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:37  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : b_prod.c                              */
/*                                                              */
/*      Entry           : void b_prod(a,b,lang)                 */
/*                        a_btyp *a,*b,*lang;                   */
/*                                                              */
/*      Arguments       : a = first operand for product         */
/*                        b = second operand for product        */
/*                        lang = product                        */
/*                                                              */
/*      Description     : Multiply 2-digit a_btyp numbers       */
/*                                                              */
/*      Note            : length of "lang" at least 4           */
/*                        length of "a","b" is 2                */
/*                                                              */
/*      Date            : 1991-04-30                            */
/*      1991-04-30 : new routine                                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void b_prod(a_btyp *a,a_btyp *b,a_btyp *lang)
#else
local void b_prod(a,b,lang)

a_btyp *a;
a_btyp *b;
a_btyp *lang;
#endif
        {
        a_btyp a0,a1,a2,a3,b0,b1,b2,b3;
        a_btyp n2;
        register a_btyp n0,n1,n3;

        /* split mantissas */
        a0 = GETHIGH(a[0]);
        a1 = GETLOW(a[0]);
        a2 = GETHIGH(a[1]);
        a3 = GETLOW(a[1]);
        b0 = GETHIGH(b[0]);
        b1 = GETLOW(b[0]);
        b2 = GETHIGH(b[1]);
        b3 = GETLOW(b[1]);

        n1 = a3*b0+a0*b3;
        if (~(lang[2] = a2*b3)<(n0 = a3*b2)) n1++;
        lang[3] = (lang[2] += n0)<<16;
        n3 = a1*b0+a0*b1;
        if (~(n0 = a1*b2)<n1) n3++;
        if (~(n1 += n0)<(n2 = a2*b1)) n3++;
        lang[2] = (lang[2]>>16) | ((n1 += n2)<<16);
        lang[1] = (n1>>16) | (n3<<16);
        lang[0] = (n3>>16)+a0*b0;
        n2 = a2*b2;
        if (~(n0 = a3*b3)<lang[3]) n2++;
        lang[3] += n0;
        n1 = a0*b2+a2*b0;
        if (~(n0 = a1*b3)<n2) n1++;
        if (~(n2 += n0)<(n3 = a3*b1)) n1++;
        if (~(n2 += n3)<lang[2]) n1++;
        lang[2] += n2;
        if (~(n0 = a1*b1)<n1) lang[0]++;
        if (~(n1 += n0)<lang[1]) lang[0]++;
        lang[1] += n1;

        return;
        }
