/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_tdek.c,v 1.2 1997/09/25 17:08:58 ae59 Exp $ */
/*
$Log: b_tdek.c,v $
 * Revision 1.2  1997/09/25  17:08:58  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:48  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : b_tdek.c                              */
/*                                                              */
/*      Entries         : void b_tdek(a,expo,mant,vz)           */
/*                        tenbyte *a;                           */
/*                        a_intg *expo;                         */
/*                        a_btyp mant[BSIZE];                   */
/*                        a_bool  *vz;                          */
/*                                                              */
/*      Arguments       : a = tenbyte value                     */
/*                        expo = exponent                       */
/*                        mant = mantissa                       */
/*                        vz = sign                             */
/*                                                              */
/*      Description     : Decomposition of a tenbyte value.     */
/*                                                              */
/*      Date            : 1992-11-23                            */
/*      1992-11-23 : add E_Ieee for e_trap(inv_op... =b=        */
/*      1991-09-10 : reduced max. line length                   */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_bool b_tdek(tenbyte *a,a_intg *expo,a_btyp *mant,a_bool  *vz)
#else
local a_bool b_tdek(a,expo,mant,vz)

tenbyte *a;
a_intg *expo;
a_btyp mant[BSIZE];
a_bool  *vz;
#endif
        {
        E_TPUSH("b_tdek")

        /* sign of real value                                   */
#if O_P_4
        *vz = (a->c[9] & tMSB) ? TRUE : FALSE;
#else
        *vz = (a->c[0] & tMSB) ? TRUE : FALSE;
#endif

        /* exponent of real value                               */
#if O_P_4
        *expo = (((a_intg)a->c[9] & ~tMSB)<<tSHIFT)+
                (a_intg)a->c[8]-tCHARAC;
#else
        *expo = (((a_intg)a->c[0] & ~tMSB)<<tSHIFT)+
                (a_intg)a->c[1]-tCHARAC;
#endif

        /* mantissa of real value                               */
#if O_P_4
        mant[0] = ((((a_btyp)a->c[7]<<tSHIFT)+
                     (a_btyp)a->c[6])<<tSHIFT)
                    +(a_btyp)a->c[5];
        mant[1] = (((((a->c[4]<<tSHIFT)+
                     (a_btyp)a->c[3])<<tSHIFT)
                    +(a_btyp)a->c[2])<<tSHIFT)+(a_btyp)a->c[1];
        mant[2] = (a_btyp)a->c[0]<<(3*tSHIFT);
        mant[3] = ZERO;
        mant[4] = ZERO;
#else
        mant[0] = ((((a_btyp)a->c[2]<<tSHIFT)
                    +(a_btyp)a->c[3])<<tSHIFT)
                    +(a_btyp)a->c[4];
        mant[1] = ((((((a_btyp)a->c[5]<<tSHIFT)
                    +(a_btyp)a->c[6])<<tSHIFT)
                    +(a_btyp)a->c[7])<<tSHIFT)+(a_btyp)a->c[8];
        mant[2] = (a_btyp)a->c[9]<<(3*tSHIFT);
        mant[3] = ZERO;
        mant[4] = ZERO;
#endif

        if (!(mant[0] | mant[1] | mant[2]))
           {

           /* real value is zero                                */
           if (*expo==-tCHARAC)
              {
              E_TPOPP("b_tdek")
              return(TRUE);
              }

           /* value is infinity or NaN                          */
           e_trap(INV_OP+E_IEEE,2,E_TMSG,70);
           }

        /* denormalized number                                  */
        else if (*expo==-tCHARAC)
           *expo = -tCHARAC+1;

        E_TPOPP("b_tdek")
        return(FALSE);
        }
