/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: c_csub.c,v 1.2 1997/09/25 17:10:15 ae59 Exp $ */
/*
$Log: c_csub.c,v $
 * Revision 1.2  1997/09/25  17:10:15  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:53  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : c_csub.c                              */
/*                                                              */
/*      Entries         : void c_csub(cr,ci,a)                  */
/*                        dotprecision *cr,*ci;                 */
/*                        a_cmpx a;                             */
/*                                                              */
/*      Arguments       : cr= dotprecision variable(real)       */
/*                        ci= dotprecision variable(imaginary)  */
/*                        a = complex value                     */
/*                                                              */
/*      Description     : Subtract complex from dotprecision    */
/*                        variable                              */
/*                        c = c-a                               */
/*                                                              */
/*      Date            : 1990-11-22                            */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void c_csub(dotprecision *cr,dotprecision *ci,a_cmpx a)
#else
local void c_csub(cr,ci,a)

dotprecision *cr;
dotprecision *ci;
a_cmpx a;
#endif
        {
        E_TPUSH("c_csub")

        d_rsub(cr,a.RE);
        d_rsub(ci,a.IM);

        E_TPOPP("c_csub")
        return;
        }

