/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: c_dadd.c,v 1.2 1997/09/25 17:10:24 ae59 Exp $ */
/*
$Log: c_dadd.c,v $
 * Revision 1.2  1997/09/25  17:10:24  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:53  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : c_dadd.c                              */
/*                                                              */
/*      Entries         : void c_dadd(cr,ci,a)                  */
/*                        dotprecision *cr,*ci;                 */
/*                        d_otpc a;                             */
/*                                                              */
/*      Arguments       : cr= dotprecision variable(real)       */
/*                        ci= dotprecision variable(imaginary)  */
/*                        a = complex dotprecision value        */
/*                                                              */
/*      Description     : Add complex to complex dotprecision   */
/*                        variable c = c+a                      */
/*                                                              */
/*      Date            : 1992-07-22                            */
/*      1992-07-22 : changed to ptemp name, casts deleted =b=   */
/*      1992-02-27 : New function                               */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void c_dadd(dotprecision *cr,dotprecision *ci,d_otpc a)
#else
local void c_dadd(cr,ci,a)

dotprecision *cr;
dotprecision *ci;
d_otpc a;
#endif
{
  E_TPUSH("c_dadd")

  d_otpc *ptemp= &a;

  d_vlcp((dotprecision*) &(ptemp)->RE);
  d_vlcp((dotprecision*) &(ptemp)->IM);

  d_dadd(cr,a.RE);
  d_dadd(ci,a.IM);

  ptemp= &a;
  d_free((dotprecision*) &(ptemp)->RE);
  d_free((dotprecision*) &(ptemp)->IM);

  E_TPOPP("c_dadd")
  return;
}
