/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: c_dsta.c,v 1.2 1997/09/25 17:10:35 ae59 Exp $ */
/*
$Log: c_dsta.c,v $
 * Revision 1.2  1997/09/25  17:10:35  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:54  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : c_dsta.c                              */
/*                                                              */
/*      Entries         : d_otpc c_dsta(cr,ci)                  */
/*                        dotprecision cr,ci;                   */
/*                                                              */
/*      Arguments       : cr= dotprecision variable(real)       */
/*                        ci= dotprecision variable(imaginary)  */
/*                                                              */
/*      Description     : Convert dotprecision to complex       */
/*                        dotprecision                          */
/*                                                              */
/*      Date            : 1992-07-22                            */
/*      1992-07-22 : local vars renamed,changed init. =b=       */
/*      1992-02-27 : new function                               */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local d_otpc c_dsta (dotprecision cr,dotprecision ci)
#else
local d_otpc c_dsta ( cr,ci)

dotprecision cr;
dotprecision ci;
#endif
{
       d_otpc  res;
       d_otpc  *ptemp = &res;

       E_TPUSH("c_dsta")

       d_vlcp((dotprecision*) &cr);
       d_vlcp((dotprecision*) &ci);

       d_init((dotprecision*) &(ptemp)->RE);
       d_init((dotprecision*) &(ptemp)->IM);
  

        d_ass(&res.RE,cr);
        d_ass(&res.IM,ci);

        d_free((dotprecision*) &cr);
        d_free((dotprecision*) &ci);

        ptemp= &res;
        d_temp((dotprecision*) &(ptemp)->RE);
        d_temp((dotprecision*) &(ptemp)->IM);
        E_TPOPP("c_dsta")
        return res;
}
