/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: c_dsub.c,v 1.2 1997/09/25 17:10:44 ae59 Exp $ */
/*
$Log: c_dsub.c,v $
 * Revision 1.2  1997/09/25  17:10:44  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:54  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : c_dsub.c                              */
/*                                                              */
/*      Entries         : void c_dsub(cr,ci,a)                  */
/*                        dotprecision *cr,*ci;                 */
/*                        d_otpc a;                             */
/*                                                              */
/*      Arguments       : cr= dotprecision variable(real)       */
/*                        ci= dotprecision variable(imaginary)  */
/*                        a = complex dotprecision value        */
/*                                                              */
/*      Description     : Subtract complex dotprecision from    */
/*                        dotprecision variable                 */
/*                        c = c-a                               */
/*                                                              */
/*      Date            : 1992-07-22                            */
/*      1992-07-22 : local vars renamed, initi. changed =b=     */
/*      1992-02-27 : new function                               */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void c_dsub(dotprecision *cr,dotprecision *ci,d_otpc a)

#else
local void c_dsub(cr,ci,a)

dotprecision *cr;
dotprecision *ci;
d_otpc a;
#endif
{
       E_TPUSH("c_dsub")
       d_otpc *ptemp= &a;

       d_vlcp((dotprecision*) &(ptemp)->RE);
       d_vlcp((dotprecision*) &(ptemp)->IM);

       d_dsub(cr,a.RE);
       d_dsub(ci,a.IM);

       ptemp= &a;
       d_free((dotprecision*) &(ptemp)->RE);
       d_free((dotprecision*) &(ptemp)->IM);

       E_TPOPP("c_dsub")
       return;
}

