/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: c_psub.c,v 1.2 1997/09/25 17:11:02 ae59 Exp $ */
/*
$Log: c_psub.c,v $
 * Revision 1.2  1997/09/25  17:11:02  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:55  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : c_psub.c                              */
/*                                                              */
/*      Entries         : void c_psub(cr,ci,a,b)                */
/*                        dotprecision *cr,*ci;                 */
/*                        a_cmpx a,b;                           */
/*                                                              */
/*      Arguments       : cr= dotprecision variable(real)       */
/*                        ci= dotprecision variable(imaginary)  */
/*                        a = complex value                     */
/*                        b = complex value                     */
/*                                                              */
/*      Description     : Subtract complex product from         */
/*                        dotprecision variable                 */
/*                        c = c-a*b                             */
/*                                                              */
/*      Date            : 1990-11-22                            */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void c_psub(dotprecision *cr,dotprecision *ci,a_cmpx a,a_cmpx b)
#else
local void c_psub(cr,ci,a,b)

dotprecision *cr;
dotprecision *ci;
a_cmpx a;
a_cmpx b;
#endif
        {
        E_TPUSH("c_psub")

        d_psub(cr,a.RE,b.RE);
        d_padd(cr,a.IM,b.IM);
        d_psub(ci,a.IM,b.RE);
        d_psub(ci,a.RE,b.IM);

        E_TPOPP("c_psub")
        return;
        }

