/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: c_scps.c,v 1.2 1997/09/25 17:11:26 ae59 Exp $ */
/*
$Log: c_scps.c,v $
 * Revision 1.2  1997/09/25  17:11:26  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:56  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : c_scps.c                              */
/*                                                              */
/*      Entries         : a_cmpx c_scps(r,s,n,rnd)              */
/*                        a_cmpx r[];                           */
/*                        a_cmpx s[];                           */
/*                        a_intg n;                             */
/*                        a_intg rnd;                           */
/*                                                              */
/*      Arguments       : n   = size of arrays r and s          */
/*                        r   = complex vector                  */
/*                        s   = complex vector                  */
/*                        rnd = rounding mode                   */
/*                              +1 rounding upwards             */
/*                               0 round to nearest             */
/*                              -1 rounding downwards           */
/*                          addition of 4 does not clear accu   */
/*                                                              */
/*      Function value  : Rounded complex dotproduct            */
/*                                                              */
/*      Description     : Dotproduct for static complex arrays  */
/*                        with directed rounding                */
/*                                                              */
/*      Date            : 1991-01-22                            */
/*      1991-01-22 : VAX_VMS_C considered                       */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/*      1990-10-31 : force linkage of global variables          */
/*      1990-07-16 : LINT_ARGS prototype                        */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern dotprecision b_acrl;
extern dotprecision b_acil;
#endif

#ifdef LINT_ARGS
local a_cmpx c_scps(a_cmpx r[],a_cmpx s[],a_intg n,a_intg rnd)
#else
local a_cmpx c_scps(r,s,n,rnd)

a_cmpx r[];
a_cmpx s[];
a_intg n;
a_intg rnd;
#endif
        {
        a_intg i;
        a_cmpx res;

        E_TPUSH("c_scps")

        /* force linkage of module containing global variables only */
#if VAX_VMS_C
        b_accu();
#endif

        if (rnd<3)
           {
           d_clr(&b_acrl);
           d_clr(&b_acil);
           }

        for (i=0;i<n;i++)
           c_padd(&b_acrl,&b_acil,r[i],s[i]);

        if (rnd==0)     res = c_stan(b_acrl,b_acil);
        else if (rnd>0) res = c_stau(b_acrl,b_acil);
        else            res = c_stad(b_acrl,b_acil);

        E_TPOPP("c_scps")
        return(res);
        }

