/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: c_scpy.c,v 1.2 1997/09/25 17:11:32 ae59 Exp $ */
/*
$Log: c_scpy.c,v $
 * Revision 1.2  1997/09/25  17:11:32  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:57  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : c_scpy.c                              */
/*                                                              */
/*      Entries         : a_cmpx c_scpy(r,s,rnd)                */
/*                        y_desc *r;                            */
/*                        y_desc *s;                            */
/*                        a_intg rnd;                           */
/*                                                              */
/*      Arguments       : r   = descriptor of complex array     */
/*                        s   = descriptor of complex array     */
/*                        rnd = rounding mode                   */
/*                              +1 rounding upwards             */
/*                               0 round to nearest             */
/*                              -1 rounding downwards           */
/*                           addition of 4 does not clear accus */
/*                                                              */
/*      Function value  : Rounded complex dotproduct            */
/*                                                              */
/*      Description     : Dotproduct for dynamic complex arrays */
/*                        with directed rounding                */
/*                                                              */
/*      Date            : 1991-04-22                            */
/*      1991-04-22 : real assignment replaced by R_ASSIGN()     */
/*      1991-01-22 : VAX_VMS_C considered                       */
/*      1990-12-11 : initialize result                          */
/*      1990-11-12 : E_TPUSH+E_TPOPP                            */
/*      1990-10-31 : force linkage of global variables          */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern dotprecision b_acrl;
extern dotprecision b_acil;
extern a_real *r_zero;
#endif

#ifdef LINT_ARGS
local a_cmpx c_scpy(y_desc *r,y_desc *s,a_intg rnd)
#else
local a_cmpx c_scpy(r,s,rnd)

y_desc *r;
y_desc *s;
a_intg rnd;
#endif
        {
        size_t i,k;
        a_cmpx res;

        E_TPUSH("c_scpy")

        /* force linkage of module containing global variables only */
#if VAX_VMS_C
        b_accu();
#endif

        R_ASSIGN(res.RE,*r_zero);
        R_ASSIGN(res.IM,*r_zero);

        if (r->numdim!=1 || s->numdim!=1)
           {
           i = r->numdim;
           k = s->numdim;
           e_trap(INV_ARG,6,E_TMSG,26,E_TINT+E_TEXT(11),&i,
                                      E_TINT+E_TEXT(11),&k);
           }
        else if (r->elnum!=s->elnum)
           {
           i = r->elnum;
           k = s->elnum;
           e_trap(INV_ARG,6,E_TMSG,27,E_TINT+E_TEXT(12),&i,
                                      E_TINT+E_TEXT(12),&k);
           }
        else
           {
           if (rnd<3)
              {
              d_clr(&b_acrl);
              d_clr(&b_acil);
              }

           for (i=0;i<r->elnum;i++)
              /* possible pointer allignment problems              */
              c_padd(&b_acrl,&b_acil,
                  *(a_cmpx *)y_inxn(r,(r->fd[0]).lbound+i),
                  *(a_cmpx *)y_inxn(s,(s->fd[0]).lbound+i));

           if (rnd==0)     res = c_stan(b_acrl,b_acil);
           else if (rnd>0) res = c_stau(b_acrl,b_acil);
           else            res = c_stad(b_acrl,b_acil);
           }

        E_TPOPP("c_scpy")
        return(res);
        }

