/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: d_ass.c,v 1.2 1997/09/25 17:12:01 ae59 Exp $ */
/*
$Log: d_ass.c,v $
 * Revision 1.2  1997/09/25  17:12:01  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:59  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : d_ass.c                               */
/*                                                              */
/*      Entries         : void d_ass(a,b)                       */
/*                        dotprecision *a,b;                    */
/*                                                              */
/*      Arguments       : a = dotprecision variable assigned to */
/*                        b = dotprecision value to be assigned */
/*                                                              */
/*      Description     : Assignment of dotprecision variables  */
/*                                                              */
/*      Date            : 1990-08-09                            */
/*      1990-07-13 : LINT_ARGS prototype                        */
/*      1990-08-09 : Copy only if not temporary                 */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void d_ass(dotprecision *a,dotprecision b)
#else
local void d_ass(a,b)

dotprecision *a;
dotprecision b;
#endif
        {
        if (b[A_STATUS] & A_TEMPORARY)
            {
            d_free(a);
            *a = &b[0];
            (*a)[A_STATUS] &= ~A_TEMPORARY;
            }
        else
           B_COPY((*a),b,A_LENGTH)

        return;
        }
