/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: d_assz.c,v 1.2 1997/09/25 17:12:24 ae59 Exp $ */
/*
$Log: d_assz.c,v $
 * Revision 1.2  1997/09/25  17:12:24  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:00  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : d_assz.c                              */
/*                                                              */
/*      Entries         : void d_assz(a,b)                      */
/*                        d_otpz *a, b     ;                    */
/*                                                              */
/*      Arguments       : a = complex interval dotprecision     */
/*                            variable assigned to              */
/*                        b = complex interval dotprecision     */
/*                            value to be  assigned             */
/*                                                              */
/*      Description     : Assignment of intervall dotprecision  */
/*                        variables                             */
/*                                                              */
/*      Date            : 1992-10-21                            */
/*      1992-10-21 : new                                        */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void d_assz(d_otpz *a,d_otpz b)
#else
local void d_assz(a,b)

d_otpz *a;
d_otpz b;
#endif
{
     E_TPUSH("d_assz")
	d_ass(&(a->RE.INF ),b.RE.INF );
     d_ass(&(a->IM.INF ),b.IM.INF );
	d_ass(&(a->RE.SUP ),b.RE.SUP );
     d_ass(&(a->IM.SUP ),b.IM.SUP );
     E_TPOPP("d_assz")

     return;
}

