/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: d_free.c,v 1.2 1997/09/25 17:13:07 ae59 Exp $ */
/*
$Log: d_free.c,v $
 * Revision 1.2  1997/09/25  17:13:07  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:04  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : d_free.c                              */
/*                                                              */
/*      Entries         : void d_free(a)                        */
/*                        dotprecision *a;                      */
/*                                                              */
/*      Arguments       : a = dotprecision variable             */
/*                                                              */
/*      Description     : Free allocated dotprecision value     */
/*                                                              */
/*      Date            : 1990-09-06                            */
/*      1990-09-06 : nott freed if NO_DOTPRECISION              */
/*      1990-07-13 : LINT_ARGS prototype                        */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void d_free(dotprecision *a)
#else
local void d_free(a)

dotprecision *a;
#endif
        {
        if ((*a)!=NO_DOTPRECISION)
           {
#ifdef HEAP_CHECK
b_freh((a_char *)a,(a_char *)(*a),(a_char *)"d_free");
#endif
           B_FREE(*a)
           *a = NO_DOTPRECISION;
           }
#ifdef HEAP_CHECK
else
b_freh((a_char *)a,(a_char *)(*a),(a_char *)"d_free");
#endif

        return;
        }
