/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: d_init.c,v 1.2 1997/09/25 17:13:32 ae59 Exp $ */
/*
$Log: d_init.c,v $
 * Revision 1.2  1997/09/25  17:13:32  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:05  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : d_init.c                              */
/*                                                              */
/*      Entries         : void d_init(a)                        */
/*                        d_otpr *a;                            */
/*                                                              */
/*      Arguments       : a = dotprecision variable             */
/*                                                              */
/*      Description     : Initialization of dotprecision        */
/*                        variable with zero.                   */
/*                                                              */
/*      Notes           : stdio.h required for NULL             */
/*                        calloc is used to initialize the      */
/*                        allocated array with Nulls            */
/*                                                              */
/*      Date            : 1990-11-12                            */
/*      1990-11-12 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void d_init(d_otpr *a)
#else
local void d_init(a)

d_otpr *a;
#endif
        {
        E_TPUSH("d_init")

        /* allocate accu                                        */
        /* possible pointer allignment problems                 */
        if ( (*a = (d_otpr)calloc(A_LENGTH,sizeof(a_btyp))) ==NULL)
           e_trap(ALLOCATION,2,E_TMSG,40);
#ifdef HEAP_CHECK
b_geth((a_char *)a,(a_char *)(*a),(a_char *)"d_init");
#endif

        E_TPOPP("d_init")
        return;
        }
