/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: e_data.c,v 1.2 1997/09/25 17:15:56 ae59 Exp $ */
/*
$Log: e_data.c,v $
 * Revision 1.2  1997/09/25  17:15:56  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:13  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : e_data.c                              */
/*                                                              */
/*      Description     : Declaration of constant data for      */
/*                        error handling routines.              */
/*                                                              */
/*      Date            : 1991-11-28                            */
/*      1991-11-28 : UNDEFLOW set to be continued after trap    */
/*      1991-01-22 : VAX_VMS_C considered                       */
/*      1990-11-28 : default is trace back on                   */
/*      1990-11-12 : INV_OP                                     */
/*      1990-10-31 : dummy function which forces linkage        */
/*      1990-08-08 : macros for default settings                */
/*      1990-07-13 : global variables moved to b_glbl.c         */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

local aentry e_aset =
    { INDEX_RANGE    , TRUE , TRUE , EXIT_CONT, TRUE , TRUE,
      (aentry *)NULL , e_xset };
local aentry e_aarg =
    { INV_ARG        , TRUE , TRUE , EXIT_CONT, TRUE , TRUE ,
      &e_aset , e_xarg };
local aentry e_aiob =
    { I_O_BUFFER     , TRUE , TRUE , EXIT_CONT, TRUE , TRUE ,
      &e_aarg , e_xiob };
local aentry e_aios =
    { I_O_ERROR      , TRUE , TRUE , EXIT_CONT, TRUE , TRUE ,
      &e_aiob , e_xios };
local aentry e_aall =
    { ALLOCATION     , TRUE , TRUE , EXIT_CONT, TRUE , TRUE ,
      &e_aios , e_xall };
local aentry e_aine =
    { INEXACT        , TRUE , TRUE , TRUE,      TRUE , TRUE ,
      &e_aall , e_xine };
local aentry e_aufl =
    { UNDERFLOW      , TRUE , TRUE , TRUE,      TRUE , TRUE ,
      &e_aine , e_xufl };
local aentry e_aofl =
    { OVERFLOW       , TRUE , TRUE , EXIT_CONT, TRUE , TRUE ,
      &e_aufl , e_xofl };
local aentry e_adbz =
    { DIV_BY_ZERO    , TRUE , TRUE , EXIT_CONT, TRUE , TRUE ,
      &e_aofl , e_xdbz };
local aentry e_aiop =
    { INV_OP         , TRUE , TRUE , EXIT_CONT, TRUE , TRUE ,
      &e_adbz , e_xiop };
local aentry e_anor =
    { NO_ERROR       , TRUE , TRUE , TRUE , TRUE , TRUE ,
      &e_aiop , e_xnor };

#if VAX_VMS_C
#ifdef LINT_ARGS
local void e_data(void)
#else
local void e_data()
#endif
        {
        }
#endif
