/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: e_push.c,v 1.2 1997/09/25 17:16:24 ae59 Exp $ */
/*
$Log: e_push.c,v $
 * Revision 1.2  1997/09/25  17:16:24  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:16  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : e_push.c                              */
/*                                                              */
/*      Entries         : void e_push(function,filename)        */
/*                        char *function;                       */
/*                        char *filename;                       */
/*                                                              */
/*      Arguments       : function - name of function           */
/*                        filename - name of file               */
/*                                                              */
/*      Description     : push function name and file name      */
/*                        to trace back stack                   */
/*                                                              */
/*      Date            : 1992-02-26                            */
/*      1992-02-26 : change a_char to char in argument =b=      */
/*      1992-01-16 : e_renv replaced by o_text[6]               */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern bentry *e_btop,*e_bstk;
extern int e_line;
extern char *e_head;
#ifdef TRACEC_ENABLE
extern a_bool f_pptr;
extern int e_tlvl;
#endif
#ifdef STATTB_ENABLE
extern a_bool f_pptb;
#endif
extern f_text f_errr;
extern char *o_text[];
#endif

#ifdef LINT_ARGS
local void e_push(char *function,char *filename)
#else
local void e_push(function,filename)

char *function;
char *filename;
#endif
        {
#ifdef TRACEC_ENABLE
        int i;

        if (f_pptr)
#ifdef STATTB_ENABLE
#ifndef RTSTRC_DISABLE
        if (NOT(f_pptb) || (char *)filename!=o_text[6])
#endif
#endif
           {
           fprintf(f_errr.fp,"%s",e_head);
           for (i=0;i<e_tlvl;i++)
              fprintf(f_errr.fp,"%c",((i%5) ? '.' : '+'));
           fprintf(f_errr.fp,"%s in %s entered.\n",
                   (char *)function,(char *)filename);
           e_tlvl++;
           }
#endif

        /* stack not yet generated                              */
        if (e_bstk==(bentry *)NULL) {
            /* possible pointer allignment problems             */
            e_bstk = e_btop = (bentry *)malloc(sizeof(bentry));
#ifdef HEAP_CHECK
b_geth((a_char *)&e_bstk,(a_char *)e_bstk,(a_char *)"e_push");
#endif
            if (e_btop==(bentry *)NULL)
                {
                fprintf(f_errr.fp,"%se_push : ",e_head);
                fprintf(f_errr.fp,"Insufficient virtual storage\n");
                return;
                }
            else
               {
               e_btop->pred = e_btop->succ = (bentry *)NULL;
               e_btop->line = e_line;
               e_btop->function = (char *)function;
               e_btop->filename = (char *)filename;
               }
            return;
            }

        /* actually no stack entries                            */
        if (e_btop==(bentry *)NULL) e_btop = e_bstk;
        else if (e_btop->succ==(bentry *)NULL)
            {
            /* possible pointer allignment problems             */
            e_btop->succ = (bentry *)malloc(sizeof(bentry));
            if (e_btop->succ==(bentry *)NULL)
                {
                fprintf(f_errr.fp,"%se_push : ",e_head);
                fprintf(f_errr.fp,"Insufficient virtual storage\n");
                return;
                }
#ifdef HEAP_CHECK
b_geth((a_char *)&e_btop->succ,(a_char *)e_btop->succ,(a_char *)"e_push");
#endif
            e_btop->succ->pred = e_btop;
            e_btop->succ->succ = (bentry *)NULL;
            e_btop = e_btop->succ;
            }
        else
            e_btop = e_btop->succ;

        e_btop->line = e_line;
        e_btop->function = (char *)function;
        e_btop->filename = (char *)filename;

        return;
        }
