/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: e_xine.c,v 1.2 1997/09/25 17:17:25 ae59 Exp $ */
/*
$Log: e_xine.c,v $
 * Revision 1.2  1997/09/25  17:17:25  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:19  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : e_xine.c                              */
/*                                                              */
/*      Entry           : void e_xine(code,e_argc,e_argv)       */
/*                        a_btyp code;                          */
/*                        va_list e_argv;                       */
/*                                                              */
/*      Arguments       : code - error code                     */
/*                        e_argc - number of arguments          */
/*                        e_argv - reference to arguments       */
/*                                                              */
/*      Description     : Inexact result.                       */
/*                                                              */
/*      Date            : 1991-11-11                            */
/*      1991-11-11 : display message only if print==TRUE        */
/*      1991-05-02 : use status flags                           */
/*      1990-11-28 : rewritten                                  */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern f_text f_errr;
extern a_bool e_efie;
extern a_bool e_ofie;
#endif

#ifdef LINT_ARGS
local void e_xine(a_btyp code,int e_argc,va_list e_argv)
#else
local void e_xine(code,e_argc,e_argv)

a_btyp code;
int e_argc;
va_list e_argv;
#endif
        {
        a_bool print;

        if (code & E_IEEE)
           {
           if ((print = e_efie ||
                        ((code & E_EXIT) ? TRUE : FALSE))==TRUE)
              {
              e_tmsg(8);

              if (code & E_EARG) e_tprt(e_argc,e_argv);
              else if (code & E_EMSG) e_tmrt(e_argc,e_argv,print);

              if (code & E_ETBC) e_back(f_errr.fp);
              else if (print) e_bmsg(f_errr.fp);
              }
           e_ofie = TRUE;
           }
        else if (!(code & E_EQIE))
           {
           if ((print = ((code & (E_EMSG+E_EXIT)) ? TRUE : FALSE))==TRUE)
              e_tmsg(8);

           if (code & E_EARG) e_tprt(e_argc,e_argv);
           else if (code & E_EMSG) e_tmrt(e_argc,e_argv,print);

           if (code & E_ETBC) e_back(f_errr.fp);
           else if (print) e_bmsg(f_errr.fp);
           }

        if (code & E_EXIT)
           {
           e_tmsg(25);
           exit(EXIT_VALUE);
           }

        return;
        }

