/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: e_xiop.c,v 1.2 1997/09/25 17:17:40 ae59 Exp $ */
/*
$Log: e_xiop.c,v $
 * Revision 1.2  1997/09/25  17:17:40  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:20  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : e_xiop.c                              */
/*                                                              */
/*      Entry           : void e_xiop(code,e_argc,e_argv)       */
/*                        a_btyp code;                          */
/*                        va_list e_argv;                       */
/*                                                              */
/*      Arguments       : code - error code                     */
/*                        e_argc - number of arguments          */
/*                        e_argv - reference to arguments       */
/*                                                              */
/*      Description     : Invalid operation.                    */
/*                                                              */
/*      Date            : 1993-02-16                            */
/*      1993-02-16 : update from Dr. Cordes =b=                 */
/*      1992-12-26 : E_TLNG case added                          */
/*      1991-11-11 : display message only if print==TRUE        */
/*      1991-05-02 : use status flags                           */
/*      1991-01-07 : SET_QUIET used                             */
/*      1990-11-28 : rewritten                                  */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern f_text f_errr;
extern int e_rtyp;
extern a_VOID e_rptr;
extern a_bool e_efio;
extern a_bool e_ofio;
#endif

#ifdef LINT_ARGS
local void e_xiop(a_btyp code,int e_argc,va_list e_argv)
#else
local void e_xiop(code,e_argc,e_argv)

a_btyp code;
int e_argc;
va_list e_argv;
#endif
        {
        a_bool print;

        if (!(code & E_EQIE))
           {
           if (code & E_IEEE)
              {
              if ((print = e_efio ||
                           ((code & E_EXIT) ? TRUE : FALSE))==TRUE)
                 e_tmsg(3);
              e_ofio = TRUE;
              }
           else if ((print = ((code & E_EMSG) ? TRUE : FALSE))==TRUE)
              e_tmsg(3);

           if (code & E_EARG) e_tprt(e_argc,e_argv);
           else if (code & E_EMSG) e_tmrt(e_argc,e_argv,print);

           if (code & E_ETBC) e_back(f_errr.fp);
           else if (print) e_bmsg(f_errr.fp);
           }
        else if (code & E_IEEE) e_ofio = TRUE;

        if (e_rtyp==E_TDBL)
           {
           ((a_btyp *)e_rptr)[B_HPART] = SET_QUIET(EXPO_MASK);
           ((a_btyp *)e_rptr)[B_LPART] = INV_OP;
           }
        else if (e_rtyp==E_TLNG)
           {
           int i;
           a_btyp x = INV_OP;
           for (i=0; i<12; i++)
              ((char *)e_rptr)[i] = 0x00;
           ((char *)e_rptr)[0] = 0x3f;
           ((char *)e_rptr)[1] = 0xf0;
           for (i=0; i<4; i++)
              ((char *)e_rptr)[i+4] = ((char *)&x)[i];
           }

        if (code & E_EXIT)
           {
           e_tmsg(25);
           exit(EXIT_VALUE);
           }

        return;
        }

