/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: e_xufl.c,v 1.2 1997/09/25 17:18:17 ae59 Exp $ */
/*
$Log: e_xufl.c,v $
 * Revision 1.2  1997/09/25  17:18:17  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:22  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : e_xufl.c                              */
/*                                                              */
/*      Entry           : void e_xufl(code,e_argc,e_argv)       */
/*                        a_btyp code;                          */
/*                        va_list e_argv;                       */
/*                                                              */
/*      Arguments       : code - error code                     */
/*                        e_argc - number of arguments          */
/*                        e_argv - reference to arguments       */
/*                                                              */
/*      Description     : Underflow.                            */
/*                                                              */
/*      Date            : 1993-02-16                            */
/*      1993-02-16 : update from Dr. Cordes =b=                 */
/*      1992-12-26 : E_TLNG case added                          */
/*      1991-11-11 : display message only if print==TRUE        */
/*      1991-09-06 : reduce maximum line length                 */
/*      1991-05-02 : use status flags                           */
/*      1991-04-22 : real assignment replaced by R_ASSIGN()     */
/*      1990-11-28 : rewritten                                  */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern f_text f_errr;
extern int e_rtyp;
extern a_VOID e_rptr;
extern a_real *r_zero;
extern a_real *r_sero;
extern a_bool e_efuf;
extern a_bool e_ofuf;
#endif

#ifdef LINT_ARGS
local void e_xufl(a_btyp code,int e_argc,va_list e_argv)
#else
local void e_xufl(code,e_argc,e_argv)

a_btyp code;
int e_argc;
va_list e_argv;
#endif
        {
        a_bool print;

        if (!(code & E_EQIE))
           {
           if (code & E_IEEE)
              {
              if ((print = e_efuf ||
                           ((code & E_EXIT) ? TRUE : FALSE))==TRUE)
                 e_tmsg(7);
              e_ofuf = TRUE;
              }
           else if ((print = ((code & E_EMSG) ? TRUE : FALSE))==TRUE)
              e_tmsg(7);

           if (code & E_EARG) e_tprt(e_argc,e_argv);
           else if (code & E_EMSG) e_tmrt(e_argc,e_argv,print);

           if (code & E_ETBC) e_back(f_errr.fp);
           else if (print) e_bmsg(f_errr.fp);
           }
        else if (code & E_IEEE) e_ofuf = TRUE;

        /* set result to +/- zero */
        if (e_rtyp==E_TDBL)
           {
           R_ASSIGN(*((a_real *)e_rptr),
            (((a_btyp *)e_rptr)[B_HPART] & MSB) ? *r_sero : *r_zero);
           }
        else if (e_rtyp==E_TLNG)
           {
           int i;
           ((char *)e_rptr)[0] = ((char *)e_rptr)[0] & 0x80;
           for (i=1; i<12; i++)
              ((char *)e_rptr)[i] = 0x00;
           }

        if (code & E_EXIT)
           {
           e_tmsg(25);
           exit(EXIT_VALUE);
           }

        return;
        }

