/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_rdln.c,v 1.2 1997/09/25 17:20:57 ae59 Exp $ */
/*
$Log: f_rdln.c,v $
 * Revision 1.2  1997/09/25  17:20:57  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:32  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_rdln.c                              */
/*                                                              */
/*      Entry           : void f_rdln(desc)                     */
/*                        f_text *desc;                         */
/*                                                              */
/*      Arguments       : desc   - device descriptor            */
/*                                                              */
/*      Description     : perform PASCAL 'readln' command.      */
/*                                                              */
/*      Date            : 1991-02-01                            */
/*      1991-02-01 : f_getc() used instead of fgetc()           */
/*      1991-01-29 : code reduced using b_text()                */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/*      1990-07-16 : LINT_ARGS prototype                        */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void f_rdln(f_text *desc)
#else
local void f_rdln(desc)

f_text *desc;
#endif
        {
        E_TPUSH("f_rdln")

        if (b_text(desc,TRUE))
           {
           while (desc->eoln==FALSE) f_getc(desc);
           if (desc->eof==FALSE) f_getc(desc);
           }

        E_TPOPP("f_rdln")
        }
