/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_rdr1.c,v 1.2 1997/09/25 17:21:05 ae59 Exp $ */
/*
$Log: f_rdr1.c,v $
 * Revision 1.2  1997/09/25  17:21:05  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:32  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_rdr1.c                              */
/*                                                              */
/*      Entry           : void f_rdr1(desc,r)                   */
/*                        f_text *desc;                         */
/*                        a_real *r;                            */
/*                                                              */
/*      Arguments       : desc   - device descriptor            */
/*                        r      - real variable                */
/*                                                              */
/*      Description     : perform PASCAL read(real).            */
/*                                                              */
/*      Date            : 1991-05-14                            */
/*      1991-05-02 : use status flags                           */
/*      1991-02-01 : f_getc() used instead of fgetc()           */
/*      1991-01-29 : code reduced using b_text()                */
/*      1990-12-07 : consider flag f_ppcc                       */
/*      1990-12-03 : display message if inexact conversion      */
/*      1990-11-12 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_bool f_ppcc;
extern a_bool e_ofie;
#endif

#ifdef LINT_ARGS
local void f_rdr1(f_text *desc,a_real *r)
#else
local void f_rdr1(desc,r)

f_text *desc;
a_real *r;
#endif
        {
        a_bool ie_flag;

        E_TPUSH("f_rdr1")

        if (b_text(desc,TRUE))
           {
           ie_flag = e_ofie;
           e_ofie = FALSE;
           r_read(desc->fp,r,(a_intg)0,(int)desc->win.ch[0]);
           f_getc(desc);
           if (e_ofie)
              {
              if (f_ppcc)
                 e_trap(NO_ERROR+E_EMSG+E_ECNT,6,E_TMSG,68,E_TMSG,60,
                        E_TDBL,r);
              e_ofie = TRUE;
              }
           else if (ie_flag) e_ofie = TRUE;
           }

        E_TPOPP("f_rdr1")
        return;
        }
