/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_read.c,v 1.2 1997/09/25 17:21:35 ae59 Exp $ */
/*
$Log: f_read.c,v $
 * Revision 1.2  1997/09/25  17:21:35  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:34  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_read.c                              */
/*                                                              */
/*      Entry           : void f_read(desc,value)               */
/*                        f_text *desc;                         */
/*                        a_VOID value;                         */
/*                                                              */
/*      Arguments       : desc   - device descriptor            */
/*                        value  - value read                   */
/*                                                              */
/*      Description     : perform PASCAL unformatted read.      */
/*                                                              */
/*      Date            : 1991-04-16                            */
/*      1991-04-16 : check for text file is optional            */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/*      1990-08-08 : arg. type changed to a_VOID                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void f_read(f_text *desc,a_VOID value)
#else
local void f_read(desc,value)

f_text *desc;
a_VOID value;
#endif
        {
        size_t i;

        E_TPUSH("f_read")

        if (desc->asgd==FALSE || desc->fp==NULL)
           e_trap(I_O_ERROR,4,E_TMSG,17,E_TSTR+E_TEXT(8),desc->name);
        else if(desc->infl==FALSE)
           e_trap(I_O_ERROR,4,E_TMSG,18,E_TSTR+E_TEXT(8),desc->name);
        else if(desc->eof==TRUE)
           e_trap(I_O_ERROR,4,E_TMSG,20,E_TSTR+E_TEXT(8),desc->name);
#ifdef CHECK_TEXT_FILE
        else if (desc->text==TRUE)
           e_trap(I_O_ERROR,4,E_TMSG,36,E_TSTR+E_TEXT(8),desc->name);
#endif
        else
           {
           for (i=0;i<desc->ellen;i++)
               ((char *)value)[i] = desc->win.ch[i];
           f_getc(desc);
           }

        E_TPOPP("f_read")
        }
