/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_srse.c,v 1.2 1997/09/25 17:22:36 ae59 Exp $ */
/*
$Log: f_srse.c,v $
 * Revision 1.2  1997/09/25  17:22:36  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:37  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_srse.c                              */
/*                                                              */
/*      Entry           : void f_srse(desc,device)              */
/*                        f_text *desc;                         */
/*                        s_trng device;                        */
/*                                                              */
/*      Arguments       : desc   - descriptor of device         */
/*                        device - name of device               */
/*                          ""   = standard input (text only)   */
/*                          file = filename used for fopen      */
/*                                                              */
/*      Description     : reset PASCAL device.                  */
/*                                                              */
/*      Date            : 1991-07-09                            */
/*      1991-07-09 : put final '\n' to open output textfile     */
/*      1991-02-13 : open for binary access if required         */
/*      1991-02-01 : f_getc() used instead of fgetc()           */
/*      1990-11-22 : replace strncpy by memcpy                  */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/*      1990-10-30 : filename replaced by device.ptr in e_trap  */
/*                   name argument removed from argument list   */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void f_srse(f_text *desc,s_trng device)
#else
local void f_srse(desc,device)

f_text *desc;
s_trng device;
#endif
        {
        char *filename = NULL;

        E_TPUSH("f_srse")

        /* put final newline character to textfile if opened for output */
        if (desc->asgd==TRUE && desc->fp!=NULL && desc->text==TRUE &&
            desc->outf==TRUE && desc->err==FALSE && desc->eoln==FALSE)
           f_putc((a_char)'\n',desc);

        if (desc->stdo==FALSE && desc->stdi==FALSE && desc->fp!=NULL)
           fclose(desc->fp);
        desc->fp = NULL;

        desc->infl = TRUE;
        desc->outf = desc->err = FALSE;

        /* open standard input                          */
        if (device.clen<=0)
           {
           if (desc->temp)
              {
              remove(desc->name);
              desc->temp = FALSE;
              }

           if (desc->text==TRUE)
              {
              desc->stdi = TRUE;
              desc->name[0] = '\0';
              }
           else
              {
              e_trap(I_O_ERROR,2,E_TMSG,33);
              E_TPOPP("f_srse")
              return;
              }
           }

        /* use filename                                 */
        else
           {
           if (desc->temp)
              {
              remove(desc->name);
              desc->temp = FALSE;
              }

           if (device.clen>=f_fnsz-1)
              {
              e_trap(I_O_BUFFER,6,E_TMSG,29,E_TMSG,30,
                                  E_TSTG+E_TEXT(8),device);
              E_TPOPP("f_srse")
              return;
              }
           filename = &desc->name[0];
           memcpy(filename,device.ptr,device.clen);
           filename[device.clen] = '\0';

           desc->stdi = FALSE;
           }

        desc->eof = desc->eoln = desc->stdo = FALSE;
        desc->asgd = TRUE;

        if (desc->stdi)
           {
           desc->fp = stdin;
           desc->eoln = TRUE;
           desc->win.ch[0] = ' ';
           }
        else if ((desc->fp =
                  fopen(filename,((desc->text) ? "r" : "rb")))==NULL)
           {
           e_trap(I_O_ERROR,4,E_TMSG,31,E_TSTR+E_TEXT(8),filename);
           desc->err = TRUE;
           }
        else
           f_getc(desc);

        if (device.tmp) s_free(&device);

        E_TPOPP("f_srse")
        }
