/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_wrb2.c,v 1.2 1997/09/25 17:23:14 ae59 Exp $ */
/*
$Log: f_wrb2.c,v $
 * Revision 1.2  1997/09/25  17:23:14  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:39  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_wrb2.c                              */
/*                                                              */
/*      Entry           : void f_wrb2(desc,b,w)                 */
/*                        f_text *desc;                         */
/*                        a_bool b;                             */
/*                        a_intg w;                             */
/*                                                              */
/*      Arguments       : desc   - device descriptor            */
/*                        b      - logical value                */
/*                        w      - width of output field        */
/*                                                              */
/*      Description     : perform PASCAL WRITE(BOOLEAN:W).      */
/*                                                              */
/*      Date            : 1992-01-16                            */
/*      1992-01-16 : use global o_text instead of constants     */
/*      1991-01-28 : output always starts at beginning of text  */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern char *o_text[];
#endif

#ifdef LINT_ARGS
local void f_wrb2(f_text *desc,a_bool b,a_intg w)
#else
local void f_wrb2(desc,b,w)

f_text *desc;
a_bool b;
a_intg w;
#endif
        {
        int p;

        E_TPUSH("f_wrb2")

        if (b_text(desc,FALSE))
           {
           p = 0;
           if (b)
              {
              if ((w<0) && (w>-strlen(o_text[35])))
                 p = (int)(strlen(o_text[35])+w);
              f_wrc2(desc,(a_char *)o_text[35],
                          strlen(o_text[35])-p,w);
              }
           else
              {
              if ((w<0) && (w>-strlen(o_text[34])))
                 p = (int)(strlen(o_text[34])+w);
              f_wrc2(desc,(a_char *)o_text[34],
                          strlen(o_text[34])-p,w);
              }
           }

        E_TPOPP("f_wrb2")
        return;
        }
