/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_wrd1.c,v 1.8 1997/09/25 17:23:36 ae59 Exp $ */
/*
$Log: f_wrd1.c,v $
 * Revision 1.8  1997/09/25  17:23:36  ae59
 * Copyright-message
 *
 * Revision 1.7  1995/07/12  11:27:19  ae59
 * called function is f_wrid not f_wrd1
 *
 * Revision 1.6  1995/06/28  10:34:09  ae59
 * native c version moved to f_wrid, this routine
 * interfaces only pxsc file descriptors
 *
 * Revision 1.2  1995/06/23  08:02:22  ae59
 * added function counters for testing, add files to complete native
 * C interface.
 *
 * Revision 1.1  1995/05/11  15:10:41  ae59
 * inlined 64 bit version is running now
 *
 * Revision 1.2  1995/01/19  11:33:24  ae59
 * casts in output routines to specified data types (unsigned)
 *
 * Revision 1.1  1994/10/27  17:25:20  ae59
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_wrd1.c                              */
/*                                                              */
/*      Entry           : void f_wrd1(desc,r,mode)              */
/*                        f_text *desc;                         */
/*                        d_otpr r;                             */
/*                        a_char mode ;                         */
/*                                                              */
/*      Arguments       : desc   - device descriptor            */
/*                        r      - real value                   */
/*                                                              */
/*      Description     : performs accu hex dump                */
/*                        The first 6 words contain status      */
/*                        information. 64 Bit of guard digits   */
/*                        are build by A_LOWnan and a_Start.    */
/*                        The accu is left aligned. On the      */
/*                        right side there are 28 bits unused   */
/*                        f_wrd1 writes status information      */
/*                        In respect of mode the output is:     */
/*                        'x' : prints all words in the accu in */
/*                              lower case or upper case if 'X' */
/*                        'z' : prints only nonzero words in the*/ 
/*                              accu in lower case or upper if  */
/*                              'Z' is specified.               */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void f_wrd1(f_text *desc,d_otpr r, a_char mode )
#else
local void f_wrd1(desc,r,mode )

f_text *desc;
d_otpr r;
a_char mode ;
#endif
{
        E_TPUSH("f_wrd1")


        if (b_text(desc,FALSE))
	   {
		 f_wrid(desc->fp,r,(char)mode);
	   }
        E_TPOPP("f_wrd1");
	   return ;
}

