/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_wrf3.c,v 1.2 1997/09/25 17:23:59 ae59 Exp $ */
/*
$Log: f_wrf3.c,v $
 * Revision 1.2  1997/09/25  17:23:59  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:42  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_wrf3.c                              */
/*                                                              */
/*      Entry           : void f_wrf3(desc,r,w,f)               */
/*                        FILE *desc;                           */
/*                        real r;                               */
/*                        a_intg w;                             */
/*                        a_intg f;                             */
/*                                                              */
/*      Arguments       : desc   - device descriptor            */
/*                        r      - real value                   */
/*                        w      - width of output field        */
/*                        f      - fractional digits            */
/*                                                              */
/*      Description     : perform PASCAL write(real).           */
/*                        real is C-supported real              */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : e format changed to f                      */
/*      1991-01-29 : code reduced using b_text()                */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void f_wrf3(f_text *desc,a_real r,a_intg w,a_intg f)
#else
local void f_wrf3(desc,r,w,f)

f_text *desc;
a_real r;
a_intg w;
a_intg f;
#endif
        {
        E_TPUSH("f_wrf3")

        if (b_text(desc,FALSE))
           {
           /* TotalWidth = ExpDigits+4+(301*DBL_MANT_DIG/1000+1); */
           if (w<=0) w = 2+4+(301*DBL_MANT_DIG/1000+1);

           fprintf(desc->fp,"%*.*f",(int)w,(int)f,r);
           }

        E_TPOPP("f_wrf3")
        }
