/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_wrh2.c,v 1.2 1997/09/25 17:24:23 ae59 Exp $ */
/*
$Log: f_wrh2.c,v $
 * Revision 1.2  1997/09/25  17:24:23  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:43  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_wrh2.c                              */
/*                                                              */
/*      Entry           : void f_wrh2(desc,h,w)                 */
/*                        f_text *desc;                         */
/*                        a_char h;                             */
/*                        a_intg w;                             */
/*                                                              */
/*      Arguments       : desc   - device descriptor            */
/*                        h      - character                    */
/*                        w      - width of output field        */
/*                                                              */
/*      Description     : perform PASCAL write(character)       */
/*                                                              */
/*      Date            : 1991-02-01                            */
/*      1991-02-01 : f_putc() used instead of fputc()           */
/*      1991-01-29 : code reduced using b_text()                */
/*      1991-01-25 : case w==0 yields no output.                */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/*      1990-10-31 : left adjust output if width is negative    */
/*                   fprintf replaced by fputc                  */
/*      1990-07-30 : char replaced by a_char                    */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void f_wrh2(f_text *desc,a_char h,a_intg w)
#else
local void f_wrh2(desc,h,w)

f_text *desc;
a_char h;
a_intg w;
#endif
        {
        E_TPUSH("f_wrh2")

        if (b_text(desc,FALSE))
           {
           if (w>0)
              {
              while (--w>0) f_putc((a_char)' ',desc);
              f_putc(h,desc);
              }
           else if (w<0)
              {
              f_putc(h,desc);
              while (++w<0) f_putc((a_char)' ',desc);
              }
           }

        E_TPOPP("f_wrh2")
        }
