/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_wrl4.c,v 1.2 1997/09/25 17:25:27 ae59 Exp $ */
/*
$Log: f_wrl4.c,v $
 * Revision 1.2  1997/09/25  17:25:27  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:46  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_wrl4.c                              */
/*                                                              */
/*      Entry           : void f_wrl4(desc,r,w,f,rnd)           */
/*                        f_text *desc;                         */
/*                        multiprecision r;                     */
/*                        a_intg w;                             */
/*                        a_intg f;                             */
/*                        a_intg rnd;                           */
/*                                                              */
/*      Arguments       : desc   - device descriptor            */
/*                        r      - multiprecision value         */
/*                        w      - width of output field        */
/*                        f      - fractional digits            */
/*                        rnd    - rounding                     */
/*                                                              */
/*      Description     : perform PASCAL                        */
/*                             write(multiprecision:w:f:rnd).   */
/*                                                              */
/*      Date            : 1993-08-07                            */
/*      1993-08-07 : l_writ() accepts f_text argument =b=       */
/*      1993-01-06 : l_writ() accepts f_text argument           */
/*      1991-01-29 : code reduced using b_text()                */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void f_wrl4(f_text *desc,multiprecision r,a_intg w,a_intg f,a_intg rnd)
#else
local void f_wrl4(desc,r,w,f,rnd)

f_text *desc;
multiprecision r;
a_intg w;
a_intg f;
a_intg rnd;
#endif
        {
        E_TPUSH("f_wrl4")

        if (b_text(desc,FALSE))
           l_writ(desc,r,w,f,rnd);

        E_TPOPP("f_wrl4")

        return;
        }
