/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_wrs1.c,v 1.2 1997/09/25 17:26:13 ae59 Exp $ */
/*
$Log: f_wrs1.c,v $
 * Revision 1.2  1997/09/25  17:26:13  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:48  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_wrs1.c                              */
/*                                                              */
/*      Entry           : void f_wrs1(desc,s)                   */
/*                        f_text *desc;                         */
/*                        s_trng s;                             */
/*                                                              */
/*      Arguments       : desc   - device descriptor            */
/*                        s      - string                       */
/*                                                              */
/*      Description     : perform PASCAL write(string).         */
/*                                                              */
/*      Date            : 1991-02-01                            */
/*      1991-02-01 : f_putc() used instead of fputc()           */
/*      1991-01-29 : code reduced using b_text()                */
/*      1990-11-28 : do not abort if '\0' occurs                */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/*      1990-10-16 : '0' replaced by '\0'                       */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void f_wrs1(f_text *desc,s_trng s)
#else
local void f_wrs1(desc,s)

f_text *desc;
s_trng s;
#endif
        {
        size_t n;

        E_TPUSH("f_wrs1")

        if (b_text(desc,FALSE))
           {
           for (n=0;n<s.clen;n++)
              f_putc((a_char)s.ptr[n],desc);
           }

        if (s.tmp) s_free(&s);

        E_TPOPP("f_wrs1")
        }
