/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: f_wrs2.c,v 1.2 1997/09/25 17:26:22 ae59 Exp $ */
/*
$Log: f_wrs2.c,v $
 * Revision 1.2  1997/09/25  17:26:22  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:49  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : f_wrs2.c                              */
/*                                                              */
/*      Entry           : void f_wrs2(desc,s,w)                 */
/*                        f_text *desc;                         */
/*                        s_trng s;                             */
/*                        a_intg w;                             */
/*                                                              */
/*      Arguments       : desc   - device descriptor            */
/*                        s      - string                       */
/*                        w      - width                        */
/*                                                              */
/*      Description     : perform PASCAL write(string : w).     */
/*                                                              */
/*      Date            : 1992-07-22                            */
/*      1992-07-22 : cast to size_t of n assignment =b=         */
/*      1991-06-27 : update w if w<0                            */
/*      1991-02-01 : f_putc() used instead of fputc()           */
/*      1991-01-29 : code reduced using b_text()                */
/*      1991-01-25 : right-most chars if left adjust            */
/*      1990-11-28 : do not abort if '\0' occurs                */
/*                   change loop if fix is TRUE                 */
/*      1990-11-15 : E_TPUSH+E_TPOPP                            */
/*      1990-11-12 : right adjust allocated string              */
/*      1990-10-31 : chop if field width is smaller than length */
/*                   left adjust output if width is neagtive    */
/*      1990-10-16 : '0' replaced by '\0'                       */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void f_wrs2(f_text *desc,s_trng s,a_intg w)
#else
local void f_wrs2(desc,s,w)

f_text *desc;
s_trng s;
a_intg w;
#endif
        {
        size_t n;

        E_TPUSH("f_wrs2")

        if (b_text(desc,FALSE))
           {
           if (w>0)
              {
              for (n = (s.fix) ? s.alen : s.clen;w>n;w--)
                 f_putc((a_char)' ',desc);
              for (n=0;n<s.clen && n<w;n++)
                 f_putc((a_char)s.ptr[n],desc);
              while (++n<=w)
                 f_putc((a_char)' ',desc);
              }
           else if (w<0)
              {
              w = -w;
              if (s.fix)
                 {
                 n = (size_t) ((w>=s.alen) ? 0 : s.alen-w);
                 w += n;
                 }
              else
                 n = (size_t) ((w>=s.clen) ? 0 : s.clen-w);
              for (;n<s.clen;n++)
                 f_putc((a_char)s.ptr[n],desc);
              while (++n<=w)
                 f_putc((a_char)' ',desc);
              }
           }

        if (s.tmp) s_free(&s);

        E_TPOPP("f_wrs2")
        }
