/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_acos.c,v 1.2 1997/09/25 17:26:29 ae59 Exp $ */
/*
$Log: i_acos.c,v $
 * Revision 1.2  1997/09/25  17:26:29  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:49  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_acos.c                              */
/*                                                              */
/*      Entries         : a_intv i_acos(a)                      */
/*                        a_intv a;                             */
/*                                                              */
/*      Arguments       : a = interval argument of function     */
/*                                                              */
/*      Description     : Interval arcus cosine function        */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-02-21 : extern L...() declaration removed          */
/*      1990-10-18 : real constants and compare operations      */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_real *r_mone,*r_one_;
#endif

#ifdef LINT_ARGS
local a_intv i_acos( a_intv a )
#else
local a_intv i_acos( a )
a_intv a;
#endif

{
        a_btyp          rc;
        a_intv          res;
        a_real          dummy;

        E_SPUSH("i_acos")

        if ( r_lt(a.INF,*r_mone) || r_gt(a.SUP,*r_one_) ) {
            rc= 1;  /* invalid argument */
        }
        /* --- point argument --- */
        else if (i_point(a)) {
            /* printf("point argument!\n"); */
            rc =  i_invp(Larccos,a.INF,&res.INF,&res.SUP);
        }
        /* --- interval argument --- */
        else if (i_iv(a)) {     /* decreasing */
            /* printf("interval argument!\n"); */

            rc =  i_invp(Larccos,a.SUP,&res.INF,&dummy);
            rc += i_invp(Larccos,a.INF,&dummy,&res.SUP);
        }
        /* --- invalid argument --- */
        else rc = 1;

        /* --- error --- */
        if (rc)
            e_trap(INV_ARG,4,E_TDBL+E_TEXT(5),&a.INF,
                             E_TDBL+E_TEXT(6),&a.SUP);

        E_SPOPP("i_acos")
        return(res);
}
