/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_acth.c,v 1.2 1997/09/25 17:26:54 ae59 Exp $ */
/*
$Log: i_acth.c,v $
 * Revision 1.2  1997/09/25  17:26:54  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:50  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_acth.c                              */
/*                                                              */
/*      Entries         : a_intv i_acth(a)                      */
/*                        a_intv a;                             */
/*                                                              */
/*      Arguments       : a = interval argument of function     */
/*                                                              */
/*      Description     : Interval area cotangent function      */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-02-21 : extern L...() declaration removed          */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_real *r_one_,*r_mone;
#endif

#ifdef LINT_ARGS
local a_intv i_acth( a_intv a )
#else
local a_intv i_acth( a )
a_intv a;
#endif

{
        a_btyp          rc;
        a_intv          res;
        a_real          dummy;

        E_SPUSH("i_acth")

        if ( (r_le(a.SUP,*r_one_) && r_ge(a.SUP,*r_mone)) ||
             (r_le(a.INF,*r_one_) && r_ge(a.INF,*r_mone)) )
         {
            rc = 1;  /* invalid argument - range */
         }
        /* --- point argument --- */
        else if ( i_point(a) ) {
            rc =  i_invp(b_acth,a.INF,&res.INF,&res.SUP);
        }
        /* --- interval argument --- */
        else if (i_iv(a)) {     /* decreasing */
            /* printf("interval argument!\n");  */

                rc =  i_invp(Larcoth,a.SUP,&res.INF,&dummy);
                rc += i_invp(Larcoth,a.INF,&dummy,&res.SUP);
        }
        /* --- invalid argument --- */
        else rc = 1;

        /* --- error --- */
        if (rc) {
            /* printf("Fehlercode: %d\n", rc ); */
            e_trap(INV_ARG,4,E_TDBL+E_TEXT(5),&a.INF,
                             E_TDBL+E_TEXT(6),&a.SUP);
        }

        E_SPOPP("i_acth")
        return(res);
}
