/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_cns2.c,v 1.2 1997/09/25 17:27:33 ae59 Exp $ */
/*
$Log: i_cns2.c,v $
 * Revision 1.2  1997/09/25  17:27:33  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:52  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_cns2.c                              */
/*                                                              */
/*      Entries         : a_intv i_cns2(stl,str)                */
/*                        a_char *stl;                          */
/*                        a_char *str;                          */
/*                                                              */
/*      Arguments       : stl - input string for lower bound    */
/*                        str - input string for upper bound    */
/*                                                              */
/*      Description     : Convert a character string            */
/*                        to IEEE double format rounded         */
/*                        to interval.                          */
/*                                                              */
/*      Date            : 1991-04-22                            */
/*      1991-04-22 : real assignment replaced by R_ASSIGN()     */
/*      1990-11-20 : E_TPUSH+E_TPOPP                            */
/*      1990-11-20 : last arg. of type a_char *                 */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_real *r_zero;
#endif

#ifdef LINT_ARGS
local a_intv i_cns2(a_char *stl,a_char *str)
#else
local a_intv i_cns2(stl,str)

a_char *stl;
a_char *str;
#endif
        {
        a_intv s;
        a_char *next;

        E_TPUSH("i_cns2")

        R_ASSIGN(s.INF,*r_zero);
        R_ASSIGN(s.SUP,*r_zero);

        r_conv(stl,&s.INF,(a_intg)-1,&next);
        r_conv(str,&s.SUP,(a_intg)1,&next);

        E_TPOPP("i_cns2")
        return(s);
        }

