/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_dsta.c,v 1.2 1997/09/25 17:28:27 ae59 Exp $ */
/*
$Log: i_dsta.c,v $
 * Revision 1.2  1997/09/25  17:28:27  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:56  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_dsta.c                              */
/*                                                              */
/*      Entries         : d_otpi i_dsta(cl,cu)                  */
/*                        dotprecision cl,cu;                   */
/*                                                              */
/*      Arguments       : cl= dotprecision value(lower bound)   */
/*                        cu= dotprecision value(upper bound)   */
/*                                                              */
/*      Description     : Round to dotprecision interval        */
/*                                                              */
/*      Date            : 1992-07-22                            */
/*      1992-07-22 : changed local names, initial. =b=          */
/*      1992-02-27 : new routine                                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local d_otpi i_dsta(dotprecision cl,dotprecision cu)
#else
local d_otpi i_dsta(cl,cu)

dotprecision cl;
dotprecision cu;
#endif
{
        d_otpi  res;
        d_otpi  *ptemp= &res;

        E_TPUSH("i_dsta")

        d_vlcp((dotprecision*) &cl);
        d_vlcp((dotprecision*) &cu);

        d_init((dotprecision*) &(ptemp)->INF);
        d_init((dotprecision*) &(ptemp)->SUP);
  
        d_ass(&res.INF,cl);
        d_ass(&res.SUP,cu);

        d_free((dotprecision*) &cl);
        d_free((dotprecision*) &cu);

        ptemp= &res;
        d_temp((dotprecision*) &(ptemp)->INF);
        d_temp((dotprecision*) &(ptemp)->SUP);

        E_TPOPP("i_dsta")
        return res;
}
