/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_dsub.c,v 1.2 1997/09/25 17:28:35 ae59 Exp $ */
/*
$Log: i_dsub.c,v $
 * Revision 1.2  1997/09/25  17:28:35  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:56  ae59
 * Put under RCS control
 *
 */

/****************************************************************/
/*                                                              */
/*      Filename        : i_dsub.c                              */
/*                                                              */
/*      Entries         : void i_dsub(cl,cu,a)                  */
/*                        dotprecision *cl,*cu;                 */
/*                        d_otpi a;                             */
/*                                                              */
/*      Arguments       : cl= dotprecision variable(lower bound)*/
/*                        cu= dotprecision variable(upper bound)*/
/*                        a = interval dotprecision value       */
/*                                                              */
/*      Description     : Substract dotprecision variable from  */
/*                        interval dotprecision variable        */
/*                        c = c-a                               */
/*                                                              */
/*      Date            : 1992-07-22                            */
/*      1992-07-22 : changed local vars, initial. =b=           */
/*      1992-02-27 : new routine                                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void i_dsub(dotprecision *cl,dotprecision *cu,d_otpi a)
#else
local void i_dsub(cl,cu,a)

dotprecision *cl;
dotprecision *cu;
d_otpi a;
#endif
{
        E_TPUSH("i_dsub")

        d_otpi *ptemp= &a;
        d_vlcp((dotprecision*) &(ptemp)->INF);
        d_vlcp((dotprecision*) &(ptemp)->SUP);

        d_dsub(cl,a.SUP);
        d_dsub(cu,a.INF);

        ptemp= &a;
        d_free((dotprecision*) &(ptemp)->INF);
        d_free((dotprecision*) &(ptemp)->SUP);

        E_TPOPP("i_dsub")
        return;
}

