/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_iadd.c,v 1.2 1997/09/25 17:29:07 ae59 Exp $ */
/*
$Log: i_iadd.c,v $
 * Revision 1.2  1997/09/25  17:29:07  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:58  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_iadd.c                              */
/*                                                              */
/*      Entries         : void i_iadd(cl,cu,a)                  */
/*                        dotprecision *cl,*cu;                 */
/*                        a_intv a;                             */
/*                                                              */
/*      Arguments       : cl= dotprecision variable(lower bound)*/
/*                        cu= dotprecision variable(upper bound)*/
/*                        a = interval value                    */
/*                                                              */
/*      Description     : Add interval to dotprecision variable */
/*                        c = c+a                               */
/*                                                              */
/*      Date            : 1990-11-22                            */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void i_iadd(dotprecision *cl,dotprecision *cu,a_intv a)
#else
local void i_iadd(cl,cu,a)

dotprecision *cl;
dotprecision *cu;
a_intv a;
#endif
        {
        E_TPUSH("i_iadd")

        d_radd(cl,a.INF);
        d_radd(cu,a.SUP);

        E_TPOPP("i_iadd")
        return;
        }

