/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_lg10.c,v 1.2 1997/09/25 17:29:31 ae59 Exp $ */
/*
$Log: i_lg10.c,v $
 * Revision 1.2  1997/09/25  17:29:31  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:59  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_lg10.c                              */
/*                                                              */
/*      Entries         : a_intv i_lg10(a)                      */
/*                        a_intv a;                             */
/*                                                              */
/*      Arguments       : a = interval argument of function     */
/*                                                              */
/*      Description     : Interval logarithm to base 10         */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-04-22 : real assignment replaced by R_ASSIGN()     */
/*      1991-02-21 : extern L...() declaration removed          */
/*      1991-01-22 : compare with r_zero replaced by r_sign()   */
/*      1990-11-15 : explicit compare                           */
/*      1990-10-18 : real constants and operations              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_real *r_ten_;
#endif

#ifdef LINT_ARGS
local a_intv i_lg10( a_intv a )
#else
local a_intv i_lg10( a )
a_intv a;
#endif

{
        a_btyp        rc;
        a_intv          res;
        a_real            dummy;

        E_SPUSH("i_lg10")

        /* --- invalid argument --- */
        if (r_sign(a.INF)<=0) rc = 1;

        /* --- point argument --- */
        else if ( i_point(a) ) {
            /* printf("point argument!\n"); */
            if ( i_lgex(a.INF, &dummy) ) {
                R_ASSIGN(res.INF,dummy);
                R_ASSIGN(res.SUP,dummy);
                rc = 0;
            }
            else {
              rc =  i_inv2(Lloga,a.INF,*r_ten_,&res.INF,&res.SUP);
            }
        }

        /* --- interval argument --- */
        else if ((rc = i_iv(a))!=0) {
            /* printf("interval argument!\n"); */
            if ( i_lgex(a.INF, &dummy) ) {
                rc= 0;
                R_ASSIGN(res.INF,dummy);
            }
            else {
              rc =  i_inv2(Lloga,a.INF,*r_ten_,&res.INF,&dummy);
            }

            if ( i_lgex(a.SUP, &dummy) ) {
                R_ASSIGN(res.SUP,dummy);
            }
            else {
              rc += i_inv2(Lloga,a.SUP,*r_ten_,&dummy,&res.SUP);
            }
        }
        /* --- invalid argument --- */
        else rc = 1;

        /* --- error --- */
        if (rc)
            e_trap(INV_ARG,4,E_TDBL+E_TEXT(5),&a.INF,
                             E_TDBL+E_TEXT(6),&a.SUP);

        /* --- exit --- */
        E_SPOPP("i_lg10")
        return(res);
        }
