/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_read.c,v 1.2 1997/09/25 17:30:28 ae59 Exp $ */
/*
$Log: i_read.c,v $
 * Revision 1.2  1997/09/25  17:30:28  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:02  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_read.c                              */
/*                                                              */
/*      Entries         : void i_read(device,s,i)               */
/*                        FILE *device;                         */
/*                        a_intv *s;                            */
/*                        int i;                                */
/*                                                              */
/*      Arguments       : device - input device reading string  */
/*                        s - resultant interval                */
/*                        i - window character                  */
/*                                                              */
/*      Description     : Read a real value in form of a        */
/*                        character string from input device    */
/*                        convert to an interval                */
/*                                                              */
/*      Date            : 1992-01-15                            */
/*      1992-01-15 : result added to e_trap()                   */
/*      1991-04-24 : check for exceding exponent range          */
/*                   remove e_trap() in case 5:                 */
/*      1991-02-18 : variable 'buffer' introduced               */
/*                   b_scan argument changed                    */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern dotprecision b_cp__;
#endif

#ifdef LINT_ARGS
local void i_read(FILE *device,a_intv *s,int i)
#else
local void i_read(device,s,i)

FILE *device;
a_intv *s;
int i;
#endif
        {
        a_intg dp,expo,length,size;
        a_bool sign;
        a_btyp rc;
        char *buffer;

        E_TPUSH("i_read")

        buffer = (char *)b_cp__;
        size = BUFFERSIZE;

        switch (b_scan(device,&buffer,&size,&expo,&dp,&length,&sign,i))
           {
           case  1: e_trap(ALLOCATION,2,E_TMSG,66);
                    break;
           case  2:
           case  3:
           case  4: e_trap(I_O_ERROR,2,E_TMSG,58);
                    break;
           case  5: /* e_trap(NO_ERROR+E_EMSG+E_ECNT,2,E_TMSG,64); */
           default:
              if (expo>DBL_MAX_10_EXP+2)
                 expo = DBL_MAX_10_EXP+2;
              else if (expo<DBL_MIN_10_EXP-DBL_MANT_DIG-2)
                 expo = DBL_MIN_10_EXP-DBL_MANT_DIG-2;
              if ((rc = b_ifrm((a_btyp *)buffer,expo,dp,length,sign,s))!=0)
                 e_trap(rc,6,E_TMSG,56,E_TDBL+E_TEXT(5),&s->INF,
                                       E_TDBL+E_TEXT(6),&s->SUP);
           }

        if (size!=BUFFERSIZE)
           {
#ifdef HEAP_CHECK
b_freh((a_char *)&buffer,(a_char *)buffer,(a_char *)"i_read");
#endif
           free(buffer);
           }

        E_TPOPP("i_read")
        }
