/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_riad.c,v 1.2 1997/09/25 17:30:37 ae59 Exp $ */
/*
$Log: i_riad.c,v $
 * Revision 1.2  1997/09/25  17:30:37  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:03  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_riad.c                              */
/*                                                              */
/*      Entries         : void i_riad(cl,cu,a,b)                */
/*                        dotprecision *cl,*cu;                 */
/*                        a_real a;                             */
/*                        a_intv b;                             */
/*                                                              */
/*      Arguments       : cl= dotprecision variable(lower bound)*/
/*                        cu= dotprecision variable(upper bound)*/
/*                        a = real value                        */
/*                        b = interval value                    */
/*                                                              */
/*      Description     : Add real*interval product to          */
/*                        dotprecision variable                 */
/*                        c = c+a*b                             */
/*                                                              */
/*      Date            : 1991-01-22                            */
/*      1991-01-22 : compare with r_zero replaced by r_sign()   */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void i_riad(dotprecision *cl,dotprecision *cu,a_real a,a_intv b)
#else
local void i_riad(cl,cu,a,b)

dotprecision *cl;
dotprecision *cu;
a_real a;
a_intv b;
#endif
        {
        E_TPUSH("i_riad")

        if (r_sign(a)>=0)
           {
           d_padd(cl,a,b.INF);
           d_padd(cu,a,b.SUP);
           }
        else
           {
           d_padd(cl,a,b.SUP);
           d_padd(cu,a,b.INF);
           }

        E_TPOPP("i_riad")
        return;
        }

