/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_scps.c,v 1.2 1997/09/25 17:30:52 ae59 Exp $ */
/*
$Log: i_scps.c,v $
 * Revision 1.2  1997/09/25  17:30:52  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:03  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_scps.c                              */
/*                                                              */
/*      Entries         : a_intv i_scps(r,s,n,rnd)              */
/*                        a_intv r[];                           */
/*                        a_intv s[];                           */
/*                        a_intg n;                             */
/*                        a_intg rnd;                           */
/*                                                              */
/*      Arguments       : n   = size of arrays r and s          */
/*                        r   = real interval vector            */
/*                        s   = real interval vector            */
/*                        rnd = mode                            */
/*                              0  clear accus first            */
/*                              4  do not clera accus           */
/*                                                              */
/*      Function value  : Real interval dotproduct              */
/*                                                              */
/*      Description     : Dotproduct for static real interval   */
/*                        arrays.                               */
/*                                                              */
/*      Date            : 1991-01-22                            */
/*      1991-01-22 : VAX_VMS_C considered                       */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/*      1990-10-31 : force linkage of global variables          */
/*      1990-07-16 : LINT_ARGS prototype                        */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern dotprecision b_acrl;
extern dotprecision b_acru;
#endif

#ifdef LINT_ARGS
local a_intv i_scps(a_intv r[],a_intv s[],a_intg n,a_intg rnd)
#else
local a_intv i_scps(r,s,n,rnd)

a_intv r[];
a_intv s[];
a_intg n;
a_intg rnd;
#endif
        {
        a_intg i;
        a_intv res;

        E_TPUSH("i_scps")

        /* force linkage of module containing global variables only */
#if VAX_VMS_C
        b_accu();
#endif

        if (rnd<3)
           {
           d_clr(&b_acrl);
           d_clr(&b_acru);
           }

        for (i=0;i<n;i++)
           i_padd(&b_acrl,&b_acru,r[i],s[i]);

        res = i_ista(b_acrl,b_acru);

        E_TPOPP("i_scps")
        return(res);
        }

