/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: i_sqrt.c,v 1.2 1997/09/25 17:31:24 ae59 Exp $ */
/*
$Log: i_sqrt.c,v $
 * Revision 1.2  1997/09/25  17:31:24  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:05  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : i_sqrt.c                              */
/*                                                              */
/*      Entries         : a_intv i_sqrt(a)                      */
/*                        a_intv a;                             */
/*                                                              */
/*      Arguments       : a = interval argument of function     */
/*                                                              */
/*      Description     : Interval square root function         */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-02-21 : extern L...() declaration removed          */
/*      1991-01-22 : compare with r_zero replaced by r_sign()   */
/*      1990-10-18 : real operations                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_intv i_sqrt( a_intv a )
#else
local a_intv i_sqrt(a)
a_intv a;
#endif
        {
        a_intv        res;
        a_btyp      rc;
        a_real          dummy;

        E_SPUSH("i_sqrt")

        if (r_sign(a.INF)<0)
           rc = 1;     /* invalid argument */
        else if ( i_point(a) )
          {
/*        printf("point argument!\n");  */
          rc =  i_invp(Lsqrt,a.INF,&res.INF,&res.SUP);
          }
        else {
/*        printf("interval argument!\n");  */
          rc =  i_invp(Lsqrt,a.INF,&res.INF,&dummy);
          rc += i_invp(Lsqrt,a.SUP,&dummy,&res.SUP);
        }

        if (rc) {
           e_trap(INV_ARG,4,E_TDBL+E_TEXT(5),&a.INF,
                            E_TDBL+E_TEXT(6),&a.SUP);
        }

        E_SPOPP("i_sqrt")
        return(res);
        }
