/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: l_abs.c,v 1.2 1997/09/25 17:31:49 ae59 Exp $ */
/*
$Log: l_abs.c,v $
 * Revision 1.2  1997/09/25  17:31:49  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:07  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : l_abs.c                               */
/*                                                              */
/*      Entries         : multiprecision l_abs(a)               */
/*                        multiprecision a;                     */
/*                                                              */
/*      Arguments       : a = mulitprecision value              */
/*                                                              */
/*      Description     : Return positive value of argument.    */
/*                                                              */
/*      Date            : 1990-11-22                            */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/*      1990-10-30 : temporary flag                             */
/*      1990-07-16 : LINT_ARGS prototype                        */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_btyp b_maxl;
#endif

#ifdef LINT_ARGS
local multiprecision l_abs(multiprecision a)
#else
local multiprecision l_abs(a)

multiprecision a;
#endif
        {
        multiprecision res;

        E_TPUSH("l_abs")

        if (a->f && a->l<=b_maxl)
           {
           res = a;
           res->s = 0;
           }
        else
           {
           l_init(&res);
           if (res==NULL)
              e_trap(ALLOCATION,2,E_TMSG,65);
           else if (b_bcpy(a,res))
              e_trap(ALLOCATION,2,E_TMSG,65);
           else
              {
              res->s = 0;
              res->f = 1;
              }
           }

        E_TPOPP("l_abs")
        return(res);
        }

