/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: l_ass.c,v 1.2 1997/09/25 17:33:12 ae59 Exp $ */
/*
$Log: l_ass.c,v $
 * Revision 1.2  1997/09/25  17:33:12  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:11  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : l_ass.c                               */
/*                                                              */
/*      Entries         : void l_ass(a,b)                       */
/*                        multiprecision *a;                    */
/*                        multiprecision b;                     */
/*                                                              */
/*      Arguments       : a = multiprecision variable           */
/*                        b = multiprecision value              */
/*                                                              */
/*      Description     : Assign multiprecision value.          */
/*                                                              */
/*      Date            : 1990-11-15                            */
/*      1990-11-15 : E_TPUSH+E_TPOPP / consider temporary flag  */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void l_ass(multiprecision *a,multiprecision b)
#else
local void l_ass(a,b)

multiprecision *a;
multiprecision b;
#endif
        {
        E_TPUSH("l_ass")

        if (b_bcpy(b,*a))
           e_trap(ALLOCATION,2,E_TMSG,65);

        if (b->f) l_free(&b);

        E_TPOPP("l_ass")
        return;
        }

