/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: l_atn2.c,v 1.2 1997/09/25 17:33:28 ae59 Exp $ */
/*
$Log: l_atn2.c,v $
 * Revision 1.2  1997/09/25  17:33:28  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:12  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : l_atn2.c                              */
/*                                                              */
/*      Entries         : multiprecision l_atn2(a,b)            */
/*                        multiprecision a,b;                   */
/*                                                              */
/*      Arguments       : a = 1. argument of standard function  */
/*                        b = 2. argument of standard function  */
/*                                                              */
/*      Description     : Inverse tangent function for          */
/*                        quotient argument a/b.                */
/*                                                              */
/*      Date            : 1991-02-21                            */
/*      1991-02-21 : extern L...() declaration removed          */
/*      1990-11-16 : E_TPUSH+E_TPOPP / consider temporary flag  */
/*      1990-08-06 : explicit compare/rc type changed to a_intg */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local multiprecision l_atn2(multiprecision a,multiprecision b)
#else
local multiprecision l_atn2(a,b)

multiprecision a;
multiprecision b;
#endif
        {
        multiprecision res;
        a_intg rc;

        E_TPUSH("l_atn2")

        l_init(&res);
        if (res==NULL)
           e_trap(ALLOCATION,2,E_TMSG,65);
        else if ((rc = Latan2(a,b,res))!=0) {
           e_trap(NO_ERROR,6,E_TMLT,&a,E_TMLT,&b,E_TINT,&rc);
           (void)b_bclr(res);
           }

        if (a->f) l_free(&a);
        if (b->f) l_free(&b);

        E_TPOPP("l_atn2")
        return(res);
        }
