/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: l_ge.c,v 1.2 1997/09/25 17:35:52 ae59 Exp $ */
/*
$Log: l_ge.c,v $
 * Revision 1.2  1997/09/25  17:35:52  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:20  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : l_ge.c                                */
/*                                                              */
/*      Entries         : a_bool l_ge(a,b)                      */
/*                        multiprecision a,b;                   */
/*                                                              */
/*      Arguments       : a = first operand                     */
/*                        b = second operand                    */
/*                                                              */
/*      Function value  : TRUE if 1.value greater/equal 2.value */
/*                        FALSE otherwise                       */
/*                                                              */
/*      Description     : compare multiprecision values         */
/*                                                              */
/*      Date            : 1990-11-16                            */
/*      1990-11-16 : E_TPUSH+E_TPOPP / consider temporary flag  */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_bool l_ge(multiprecision a,multiprecision b)
#else
local a_bool l_ge(a,b)

multiprecision a;
multiprecision b;
#endif
        {
        int res; /* !!! must be int !!! */

        E_TPUSH("l_ge")

        res = b_bcmp(a,b);

        if (a->f) l_free(&a);
        if (b->f) l_free(&b);

        E_TPOPP("l_eg")
        return((res>=0) ? TRUE : FALSE);
        }
