/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: l_rond.c,v 1.2 1997/09/25 17:38:13 ae59 Exp $ */
/*
$Log: l_rond.c,v $
 * Revision 1.2  1997/09/25  17:38:13  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:27  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : l_rond.c                              */
/*                                                              */
/*      Entries         : a_intg l_rond(a)                      */
/*                        multiprecision a;                     */
/*                                                              */
/*      Arguments       : a = multiprecision value              */
/*                                                              */
/*      Description     : Round INTERN value to next integer    */
/*                        number.                               */
/*                                                              */
/*      Date            : 1990-11-22                            */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/*      1990-10-30 : temporary flag                             */
/*      1990-07-16 : LINT_ARGS prototype                        */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_intg l_rond(multiprecision a)
#else
local a_intg l_rond(a)

multiprecision a;
#endif
        {
        a_intg res = 0;

        E_TPUSH("l_rond")

        if (a->z)
           {
           }
        else if (a->e>0 || (a->e==0 && (a->m[0] & MSB)))
           e_trap(OVERFLOW,4,E_TMSG,15,E_TMLT+E_TEXT(7),&a);
        else if (a->e<0)
           {
           if (a->e==-1 && (a->m[0] & MSB)) res = 1-2*a->s;
           }
        else
           {
           res = a->m[0];

           if (a->l>1 && (a->m[1] & MSB))
              {
              if (res>MAXINT)
                 {
                 e_trap(OVERFLOW,4,E_TMSG,15,E_TMLT+E_TEXT(7),&a);
                 res = 0;
                 }
              else
                 res++;
              }

           if (a->s)
              {
#if C_P_2
              res = -res;
#else
              res = ~res+1;
#endif
              }
           }

        if (a->f) l_free(&a);

        E_TPOPP("l_rond")
        return(res);
        }
