/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: r_atn2.c,v 1.2 1997/09/25 17:43:07 ae59 Exp $ */
/*
$Log: r_atn2.c,v $
 * Revision 1.2  1997/09/25  17:43:07  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:48  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : r_atn2.c                              */
/*                                                              */
/*      Entries         : a_real r_atn2(a,b)                    */
/*                        a_real a,b;                           */
/*                                                              */
/*      Arguments       : a = real argument of standard function*/
/*                        b = real argument of standard function*/
/*                                                              */
/*      Description     : Inverse tangent function for          */
/*                        quotient argument a/b.                */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-02-21 : extern L...() declaration removed          */
/*      1990-08-06 : code reduced                               */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_real r_atn2(a_real a,a_real b)
#else
local a_real r_atn2(a,b)

a_real a;
a_real b;
#endif
        {
        a_real res;
        a_btyp rc;

        E_SPUSH("r_atn2")

        if ((rc = b_inv2(Latan2,a,b,&res,0))!=0)
           e_trap(INV_ARG,6,E_TDBL,&a,E_TDBL,&b,E_TINT+E_TEXT(16),&rc);

        E_SPOPP("r_atn2")
        return(res);
        }
