/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: r_cnst.c,v 1.2 1997/09/25 17:43:57 ae59 Exp $ */
/*
$Log: r_cnst.c,v $
 * Revision 1.2  1997/09/25  17:43:57  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:23:51  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : r_cnst.c                              */
/*                                                              */
/*      Entries         : a_real r_cnst(str)                    */
/*                        char *str;                            */
/*                                                              */
/*      Arguments       : str - input string                    */
/*                                                              */
/*      Description     : Convert a character string            */
/*                        to IEEE double format rounded         */
/*                        to nearest.                           */
/*                                                              */
/*      Date            : 1992-02-07                            */
/*      1992-02-07 : chg a_char* str to char * str =b=          */
/*      1991-05-14 : E_TMSG 68 added                            */
/*      1991-05-02 : use status flags                           */
/*      1991-04-22 : real assignment replaced by R_ASSIGN()     */
/*      1990-12-07 : consider flag f_ppcc                       */
/*      1990-12-03 : message displayed if inexact conversion    */
/*      1990-11-19 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_real *r_zero;
extern a_bool f_ppcc;
extern a_bool e_ofie;
#endif

#ifdef LINT_ARGS
local a_real r_cnst(char *str)
#else
local a_real r_cnst(str)

char *str;
#endif
        {
        a_real s;
        a_char *next;
        a_bool ie_flag;

        E_TPUSH("r_cnst")

        R_ASSIGN(s,*r_zero);

        ie_flag = e_ofie;
        e_ofie = FALSE;
        r_conv((a_char*) str,&s,(a_intg)0,&next);
        if (e_ofie)
           {
           if (f_ppcc)
              e_trap(NO_ERROR+E_EMSG+E_EARG+E_ECNT,6,E_TMSG,68,E_TMSG,59,
                     E_TSTR+E_TEXT(10),str);
           e_ofie = TRUE;
           }
        else if (ie_flag) e_ofie = TRUE;

        E_TPOPP("r_cnst")
        return(s);
        }

