/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: r_loga.c,v 1.2 1997/09/25 17:47:52 ae59 Exp $ */
/*
$Log: r_loga.c,v $
 * Revision 1.2  1997/09/25  17:47:52  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:03  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : r_loga.c                              */
/*                                                              */
/*      Entries         : a_real r_loga(x,a)                    */
/*                        a_real x,a;                           */
/*                                                              */
/*      Arguments       : x = real argument of standard function*/
/*                        a = base of logarithm                 */
/*                                                              */
/*      Description     : logarithm of base a                   */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-02-21 : extern L...() declaration removed          */
/*      1990-08-06 : code reduced                               */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_real r_loga(a_real x,a_real a)
#else
local a_real r_loga(x,a)

a_real x;
a_real a;
#endif
        {
        a_real res;
        a_btyp rc;

        E_SPUSH("r_loga")

        if ((rc = b_inv2(Lloga,x,a,&res,0))!=0)
           e_trap(INV_ARG,6,E_TDBL+E_TEXT(17),&a,
                            E_TDBL+E_TEXT(7),&x,
                            E_TINT+E_TEXT(16),&rc);

        E_SPOPP("r_loga")
        return(res);
        }
