/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: r_ne.c,v 1.2 1997/09/25 17:48:47 ae59 Exp $ */
/*
$Log: r_ne.c,v $
 * Revision 1.2  1997/09/25  17:48:47  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:07  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : r_ne.c                                */
/*                                                              */
/*      Entries         : a_bool r_ne(a,b)                      */
/*                        a_real a,b;                           */
/*                                                              */
/*      Arguments       : a = IEEE operand                      */
/*                        b = IEEE operand                      */
/*                                                              */
/*      Function value  : TRUE if values are not equal          */
/*                        FALSE if values are equal             */
/*                                                              */
/*      Description     : compare IEEE values                   */
/*                                                              */
/*      Note            : FALSE returned in case of error       */
/*                                                              */
/*      Date            : 1991-04-23                            */
/*      1991-04-23 : MANT_INFINITY() used                       */
/*      1990-11-19 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_bool r_ne(a_real a,a_real b)
#else
local a_bool r_ne(a,b)

a_real a;
a_real b;
#endif
        {
        a_bool res,vza,vzb,zeroa,zerob;
        a_intg expoa,expob;
        a_btyp manta[D_U_RATIO];
        a_btyp mantb[D_U_RATIO];

        E_TPUSH("r_ne")

        zeroa = b_deko(a,&expoa,manta,&vza);
        zerob = b_deko(b,&expob,mantb,&vzb);

        if (expoa>=EXPO_MAX+1 || expob>=EXPO_MAX+1)
           {
           if (expoa==EXPO_MAX+1 && expob==EXPO_MAX+1)
              {
#if C_P_3
              if (manta[0]==mantb[0] && manta[1]==mantb[1])
#else
              if (b_bmcm(D_U_RATIO,manta,mantb)==0)
#endif
                 {
                 if (MANT_INFINITY(manta))
                    res = (vza!=vzb) ? TRUE : FALSE;
                 else res = FALSE;
                 }
              else res = TRUE;
              }
           else
              res = TRUE;
           }
        else if (zeroa) res = (zerob) ? FALSE : TRUE;
        else if (zerob) res = TRUE;
        else if (vza!=vzb) res = TRUE;
        else if (expoa!=expob) res = TRUE;
#if C_P_3
        else if ((manta[0]!=mantb[0]) ||
                 (manta[1]!=mantb[1])) res = TRUE;
#else
        else if (b_bmcm(D_U_RATIO,manta,mantb[1])!=0) res = TRUE;
#endif
        else res = FALSE;

        E_TPOPP("r_ne")
        return(res);
        }
