/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_aacc.c,v 1.2 1997/09/25 17:52:45 ae59 Exp $ */
/*
$Log: s_aacc.c,v $
 * Revision 1.2  1997/09/25  17:52:45  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:19  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_aacc.c                              */
/*                                                              */
/*      Entries         : a_VOID s_aacc(s,t,u)                  */
/*                        a_char s[];                           */
/*                        a_char t[];                           */
/*                        a_char u[];                           */
/*                                                              */
/*      Arguments       : s = concatenated string               */
/*                        t = string                            */
/*                        u = string                            */
/*                                                              */
/*      Return value    : concatenated string                   */
/*                                                              */
/*      Description     : Concatenate strings.                  */
/*                                                              */
/*      Date    : 1991-09-06                                    */
/*      1991-09-06 : reduce maximum line length                 */
/*      1991-04-09 : avoid loops without body                   */
/*      1990-11-19 : E_TPUSH+E_TPOPP / (a_VOID) in result       */
/*      1990-08-06 : explicit compare                           */
/*      1990-07-30 : string replaced by a_char[]                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_VOID s_aacc(a_char s[],a_char t[],a_char u[])
#else
local a_VOID s_aacc(s,t,u)

a_char s[];
a_char t[];
a_char u[];
#endif
        {
        a_char *p,*q;

        E_TPUSH("s_aacc")

        p = &s[0];
        q = &t[0];

        while ((*p++ = *q++)!=0) { /* empty */ }
        p--;
        q = &u[0];
        while ((*p++ = *q++)!=0) { /* empty */ }

        E_TPOPP("s_aacc")
        return((a_VOID)&s[0]);
        }

