/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_accc.c,v 1.2 1997/09/25 17:53:56 ae59 Exp $ */
/*
$Log: s_accc.c,v $
 * Revision 1.2  1997/09/25  17:53:56  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:22  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_accc.c                              */
/*                                                              */
/*      Entries         : a_VOID s_accc(s,t,u)                  */
/*                        a_char s[],t[];                       */
/*                        a_char u;                             */
/*                                                              */
/*      Arguments       : s = concatenated string               */
/*                        t = string                            */
/*                        u = character                         */
/*                                                              */
/*      Return value    : concatenated string                   */
/*                                                              */
/*      Description     : Concatenate string with character.    */
/*                                                              */
/*      Date            : 1991-04-09                            */
/*      1991-04-09 : avoid loop without body                    */
/*      1990-11-19 : E_TPUSH+E_TPOPP / (a_VOID) in result       */
/*      1990-08-06 : explicit compare                           */
/*      1990-07-30 : string replaced by a_char[]                */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_VOID s_accc(a_char s[],a_char t[],a_char u)
#else
local a_VOID s_accc(s,t,u)

a_char s[];
a_char t[];
a_char u;
#endif
        {
        a_char *p,*q;

        E_TPUSH("s_accc")

        p = &s[0];
        q = &t[0];

        while ((*p++ = *q++)!=0) { /* empty */ }
        p[-1] = u;
        *p = '\0';

        E_TPOPP("s_accc")
        return((a_VOID)&s[0]);
        }

