/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_aimg.c,v 1.2 1997/09/25 17:55:09 ae59 Exp $ */
/*
$Log: s_aimg.c,v $
 * Revision 1.2  1997/09/25  17:55:09  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:26  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_aimg.c                              */
/*                                                              */
/*      Entries         : a_char *s_aimg(str,n,s,Totalwidth,    */
/*                                    FracDigits,rnd)           */
/*                        a_char str[];                         */
/*                        a_intg n;                             */
/*                        a_real s;                             */
/*                        a_intg rnd,Totalwidth,FracDigits;     */
/*                                                              */
/*      Arguments       : str - output string                   */
/*                        n - length of output string           */
/*                        s - IEEE value                        */
/*                        Totalwidth - total length of string   */
/*                        FracDigits - number of fraction digits*/
/*                        rnd - rounding mode                   */
/*                              -1 = round downwards            */
/*                               0 = round to nearest           */
/*                               1 = round upwards              */
/*                                                              */
/*      Description     : Convert an IEEE double format number  */
/*                        to a character string.                */
/*                                                              */
/*      Date            : 1990-11-20                            */
/*      1990-11-20 : E_TPUSH+E_TPOPP                            */
/*      1990-10-16 : set default TotalWidth                     */
/*      1990-10-15 : new argument n                             */
/*      1990-07-30 : string replaced by a_char[]                */
/*      1990-07-12 : LINT_ARGS prototype, cp renamed            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern dotprecision b_cp__;
#endif

#ifdef LINT_ARGS
local a_char *s_aimg(a_char str[],a_intg n,a_real s,a_intg TotalWidth,
                     a_intg FracDigits,a_intg rnd)
#else
local a_char *s_aimg(str,n,s,TotalWidth,FracDigits,rnd)

a_char str[];
a_intg n;
a_real s;
a_intg TotalWidth;
a_intg FracDigits;
a_intg rnd;
#endif
        {
        a_intg length;
        char *buffer;
        a_intg i;

        E_TPUSH("s_aimg")

        if (TotalWidth<=0)
           {
           TotalWidth = ExpDigits+4+3*MANTL/10;
           if (TotalWidth<n && n>0) TotalWidth = n;
           }

        if (n<TotalWidth)
           {
           i = 0;
           e_trap(I_O_BUFFER,2,E_TMSG,57);
           }
        else
           {
           buffer = (char *)&b_cp__[0];

           r_outp(buffer,s,TotalWidth,FracDigits,rnd,&length);

           for (i=0;i<length;i++) str[i] = *buffer++;
           }

        while (i<n) str[i] = ' ';

        E_TPOPP("s_aimg")
        return(&str[0]);
        }
