/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_cacc.c,v 1.2 1997/09/25 17:55:34 ae59 Exp $ */
/*
$Log: s_cacc.c,v $
 * Revision 1.2  1997/09/25  17:55:34  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:27  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_cacc.c                              */
/*                                                              */
/*      Entries         : a_VOID s_cacc(s,t,u)                  */
/*                        a_char s[],u[];                       */
/*                        a_char t;                             */
/*                                                              */
/*      Arguments       : s = concatenated string               */
/*                        t = character                         */
/*                        u = string                            */
/*                                                              */
/*      Return value    : concatenated string                   */
/*                                                              */
/*      Description     : Concatenate character with string.    */
/*                                                              */
/*      Date            : 1991-04-09                            */
/*      1991-04-09 : avoid loop without body                    */
/*      1991-01-17 : (a_VOID) cast in return()                  */
/*      1990-08-06 : explicit compare                           */
/*      1990-07-30 : string replaced by a_char[]                */
/*      1990-07-17 : LINT_ARGS prototype                        */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_VOID s_cacc(a_char s[],a_char t,a_char u[])
#else
local a_VOID s_cacc(s,t,u)

a_char s[];
a_char t;
a_char u[];
#endif
        {
        a_char *p,*q;
        p = &s[0];
        q = &u[0];

        *p++ = t;
        while ((*p++ = *q++)!=0) { /* empty */ }

        return((a_VOID)&s[0]);
        }

