/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_char.c,v 1.2 1997/09/25 17:56:47 ae59 Exp $ */
/*
$Log: s_char.c,v $
 * Revision 1.2  1997/09/25  17:56:47  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:30  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_char.c                              */
/*                                                              */
/*      Entry           : s_trng s_char(s)                      */
/*                        a_char s;                             */
/*                                                              */
/*      Arguments       : s - character                         */
/*                                                              */
/*      Function value  : dynamic string descriptor             */
/*                                                              */
/*      Description     : copy character to dynamic string      */
/*                        (descriptor is initialized)           */
/*                                                              */
/*      Date            : 1990-11-22                            */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/*      1990-10-30 : set current length                         */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local s_trng s_char(a_char s)
#else
local s_trng s_char(s)

a_char s[];
#endif
        {
        s_trng res;

        E_TPUSH("s_char")

        s_init(&res,1);

        if (res.ptr!=NULL)
           {
           res.ptr[0] = (char)s;
           res.clen = 1;
           }
        res.tmp = TRUE;

#ifdef HEAP_CHECK
b_tmph((a_char *)&res);
#endif

        E_TPOPP("s_char")
        return(res);
        }
