/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_etin.c,v 1.2 1997/09/25 17:58:56 ae59 Exp $ */
/*
$Log: s_etin.c,v $
 * Revision 1.2  1997/09/25  17:58:56  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:37  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_etin.c                              */
/*                                                              */
/*      Entries         : a_bool s_etin(e,s)                    */
/*                        a_intg e;                             */
/*                        s_etof s;                             */
/*                                                              */
/*      Arguments       : s = set                               */
/*                        e = element                           */
/*                                                              */
/*      Description     : Test for element in set.              */
/*                                                              */
/*      Date            : 1991-07-10                            */
/*      1991-07-10 : no range error caused by element           */
/*      1991-01-29 : 0x80 casted with (unsigned char)           */
/*      1990-11-20 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_bool s_etin(a_intg e,s_etof s)
#else
local a_bool s_etin(e,s)

a_intg e;
s_etof s;
#endif
        {
        a_bool res;

        E_TPUSH("s_etin")

        if (e<0 || e>s_SIZE*BITS_PER_CHAR-1)
           res = FALSE;
        else if (s[e/BITS_PER_CHAR] &
                 (((unsigned char)0x80)>>(e%BITS_PER_CHAR)))
           res = TRUE;
        else
           res = FALSE;

        E_TPOPP("s_etin")
        return(res);
        }
