/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_int_.c,v 1.2 1997/09/25 18:00:17 ae59 Exp $ */
/*
$Log: s_int_.c,v $
 * Revision 1.2  1997/09/25  18:00:17  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:41  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_int_.c                              */
/*                                                              */
/*      Entries         : s_trng s_int_(s,Totalwidth)           */
/*                        a_intg s,Totalwidth;                  */
/*                                                              */
/*      Arguments       : s - integer value                     */
/*                        Totalwidth - total length of string   */
/*                                                              */
/*      Description     : Convert an integer value              */
/*                        to a character string.                */
/*                                                              */
/*      Date            : 1992-07-22                            */
/*      1992-07-22 : cast to char at buffer assignm. =b=        */
/*                   and size_t at length calculation           */
/*      1991-01-17 : (size_t) cast in s_init()                  */
/*      1991-01-02 : reverse digits in output string            */
/*      1990-12-21 : str.clen set appropriately                 */
/*      1990-11-22 : replace strncpy by memcpy                  */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern dotprecision b_cp__;
#endif

#ifdef LINT_ARGS
local s_trng s_int_(a_intg s,a_intg TotalWidth)
#else
local s_trng s_int_(s,TotalWidth)

a_intg s;
a_intg TotalWidth;
#endif
        {
        a_intg i,IntDigits;
        a_bool sign;
        char *buffer;
        a_btyp b;
        s_trng str;

        buffer = (char *)b_cp__;

        IntDigits = 0;
        if (s<0)
           {
           if (s==MININT) b = MSB;
           else b = -s;
           sign = TRUE;
           }
        else
           {
           b = s;
           sign = FALSE;
           }

        do
           {
           buffer[IntDigits++] = (char)(b%10+'0');
           b /= 10;
           }
        while (b>0);

        i = 0;
        if (TotalWidth>=IntDigits+1)
           {
           s_init(&str,(size_t)TotalWidth);
           if (str.ptr!=NULL)
              {
              for (;i<TotalWidth-IntDigits-1;i++) str.ptr[i] = ' ';
              str.ptr[i++] = ((sign) ? '-' : ' ');
              str.clen = (size_t) TotalWidth;
              }
           }
        else if (sign)
           {
           s_init(&str,(size_t)(IntDigits+1));
           if (str.ptr!=NULL)
              {
              str.ptr[0] = '-';
              i = 1;
              str.clen = (size_t) (IntDigits+1);
              }
           }
        else
           {
           s_init(&str,(size_t)IntDigits);
           if (str.ptr!=NULL) str.clen = (size_t) IntDigits;
           }

        if (str.ptr!=NULL)
           while (IntDigits-->0) str.ptr[i++] = buffer[IntDigits];
        str.tmp = TRUE;

#ifdef HEAP_CHECK
b_tmph((a_char *)&str.ptr);
#endif

        return(str);
        }
