/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_stat.c,v 1.2 1997/09/25 18:03:39 ae59 Exp $ */
/*
$Log: s_stat.c,v $
 * Revision 1.2  1997/09/25  18:03:39  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:51  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_stat.c                              */
/*                                                              */
/*      Entry           : s_trng s_stat(s,n)                    */
/*                        a_char s[];                           */
/*                        a_intg n;                             */
/*                                                              */
/*      Arguments       : s - static string                     */
/*                        n - length of static string           */
/*                                                              */
/*      Function value  : dynamic string descriptor             */
/*                                                              */
/*      Description     : copy static string to dynamic string  */
/*                        (descriptor is initialized)           */
/*                                                              */
/*      Date            : 1992-07-22                            */
/*      1992-07-22 : cast to size_t at length assignment =b=    */
/*      1990-11-06 : initialize fix flag                        */
/*      1990-10-17 : new flag suba in s_trng                    */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local s_trng s_stat(a_char s[],a_intg n)
#else
local s_trng s_stat(s,n)

a_char s[];
a_intg n;
#endif
        {
        s_trng res;

        /* tmp- and fix-flag must not be TRUE since static array   */
        /* is referenced by pointer of dynamic string              */
        res.fix = res.tmp = FALSE;
        res.suba = TRUE;
        res.ptr = (char *) &s[0];
        res.alen = res.clen = (size_t) n;

        return(res);
        }
