/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_sub.c,v 1.2 1997/09/25 18:03:50 ae59 Exp $ */
/*
$Log: s_sub.c,v $
 * Revision 1.2  1997/09/25  18:03:50  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:51  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_sub.c                               */
/*                                                              */
/*      Entries         : a_VOID s_sub(res,s,t)                 */
/*                        s_etof s,t,res;                       */
/*                                                              */
/*      Arguments       : s = first set                         */
/*                        t = second set                        */
/*                        res = result set                      */
/*                                                              */
/*      Function value  : pointer to result set                 */
/*                                                              */
/*      Description     : res = difference of two sets s and t. */
/*                                                              */
/*      Date            : 1990-11-19                            */
/*      1990-11-19 : E_TPUSH+E_TPOPP / (a_VOID) in result       */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_VOID s_sub(s_etof res,s_etof s,s_etof t)
#else
local a_VOID s_sub(res,s,t)

s_etof res;
s_etof s;
s_etof t;
#endif
        {
        size_t i;

        E_TPUSH("s_sub")

        for (i=0;i<s_SIZE;i++) res[i] = s[i] & (~t[i]);

        E_TPOPP("s_sub")
        return((a_VOID)&res[0]);
        }
