/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_subs.c,v 1.2 1997/09/25 18:04:08 ae59 Exp $ */
/*
$Log: s_subs.c,v $
 * Revision 1.2  1997/09/25  18:04:08  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:52  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_subs.c                              */
/*                                                              */
/*      Entries         : s_trng s_subs(s,pos,len)              */
/*                        s_trng s;                             */
/*                        a_intg pos,len;                       */
/*                                                              */
/*      Arguments       : s = string                            */
/*                        pos = position                        */
/*                        len = length                          */
/*                                                              */
/*      Return value    : substring                             */
/*                                                              */
/*      Description     : Substring of string beginning at      */
/*                        position pos with length len.         */
/*                                                              */
/*      Date            : 1992-11-09                            */
/*      1992-11-09 : corrected computation of n       =b=       */
/*      1992-07-22 : cast to size_t at n computation, =b=       */
/*                   void* cast in memcpy                       */
/*      1990-11-22 : replace strncpy by memcpy                  */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local s_trng s_subs(s_trng s,a_intg pos,a_intg len)
#else
local s_trng s_subs(s,pos,len)

s_trng s;
a_intg pos;
a_intg len;
#endif
        {
        s_trng res;
        size_t n;

        if (pos<=s.clen && len>0)
           {
           if (pos<1) pos = 1;
           if (len<=(n = s.clen-(size_t)pos+1)) n = (size_t) len ;
           s_init(&res,n);
           if (res.ptr!=NULL) memcpy((void*) res.ptr,(void*)(s.ptr+(pos-1)),n);
           res.clen = n;
           }
        else
           s_init(&res,(size_t)0);

        res.tmp = TRUE;

        if (s.tmp) s_free(&s);

        return(res);
        }

