/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: s_zero.c,v 1.2 1997/09/25 18:04:55 ae59 Exp $ */
/*
$Log: s_zero.c,v $
 * Revision 1.2  1997/09/25  18:04:55  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:55  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : s_zero.c                              */
/*                                                              */
/*      Entries         : a_VOID s_zero(s)                      */
/*                        s_etof s;                             */
/*                                                              */
/*      Arguments       : s = set to be initialized             */
/*                                                              */
/*      Function value  : pointer to result set                 */
/*                                                              */
/*      Description     : Initialize an empty set.              */
/*                                                              */
/*      Date            : 1991-08-27                            */
/*      1991-08-27 : optimized loop for initialization          */
/*      1990-11-19 : E_TPUSH+E_TPOPP / (a_VOID) in result       */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_VOID s_zero(s_etof s)
#else
local a_VOID s_zero(s)

s_etof s;
#endif
        {
        E_TPUSH("s_zero")

        (void)memset(&s[0],0x00,s_SIZE);

        E_TPOPP("s_zero")
        return((a_VOID)&s[0]);
        }
