/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_acot.c,v 1.2 1997/09/25 18:05:22 ae59 Exp $ */
/*
$Log: t_acot.c,v $
 * Revision 1.2  1997/09/25  18:05:22  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:24:56  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_acot.c                              */
/*                                                              */
/*      Entries         : a_real t_acot(arg)                    */
/*                        a_real arg;                           */
/*                                                              */
/*      Arguments       : arg  = argument of arcus cotangent    */
/*                                                              */
/*      Description     : Arcus cotangent function              */
/*                                                              */
/*      Date            : 1991-11-13                            */
/*      1991-11-13 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctReal replaced             */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-08-05 : remove unused variables a,sgn              */
/*      1991-06-21 : new routine                                */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctReal(t_acot,acotee) */
#ifdef LINT_ARGS
a_real t_acot(a_real arg)
#else
a_real t_acot(arg)

a_real arg;
#endif
        {
        int      rnd, rc;
        a_real   res;
        ExtReal  a, r;

        E_SPUSH("t_acot")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&arg, &a);

        if ((rc = acotee(&a, &r))!=0
            || (rc = extreal_to_longreal(&r, (LongReal *)&res))!=0)
           ieee_abortr1(rc, &arg);

        setrndmode(rnd);

        E_SPOPP("t_acot")
        return res;
        }
/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | Punkt Arcus Cotangens                                        |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int acotee (const ExtReal *arg, ExtReal *res)
#else
int acotee (arg, res)
const ExtReal   *arg;
      ExtReal   *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int acotee (ExtReal *arg, ExtReal *res)
#else
int acotee (arg, res)
ExtReal   *arg;
ExtReal   *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   ExtReal     t, r;       /* ZwischenErgebnis                  */
   int         rnd;        /* RundungsMode                      */
   int         ret=0;      /* Rueckgabe                         */
   int         check;      /* Rueckgabe von Makro ArgCheck      */

   /* --- pruefe Argument --- */
   ArgCheck1(Acot, arg, res);

   /* --- RundungsMode sichern, NEAR setzen --- */
   rnd  = getrndmode();
   setrndmode(NEAR);

   /* --- Arcus Kotangens --- */
   switch (cmpee(arg, &Zero)) {
   case -1: /* arg < 0 */
      divee(&One, arg, &t);
      ret = _s_atan(&t, &r);
      addee(&Pi, &r, res);
      break;
   case 0: /* arg = 0 */
      ret = copyee(&PiHalf, res);
      break;
   case  1: /* arg > 0 */
      divee(&One, arg, &t);
      ret = _s_atan(&t, res);
      break;
   }

   /* --- RundungsMode zuruecksetzen --- */
   setrndmode(rnd);

   return ret;
} /* acotee() */
