/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_atnh.c,v 1.2 1997/09/25 18:06:53 ae59 Exp $ */
/*
$Log: t_atnh.c,v $
 * Revision 1.2  1997/09/25  18:06:53  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:00  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_atnh.c                              */
/*                                                              */
/*      Entries         : a_real t_atnh(arg)                    */
/*                        a_real arg;                           */
/*                                                              */
/*      Arguments       : arg  = argument of area tangent       */
/*                                                              */
/*      Description     : Area tangent function.                */
/*                                                              */
/*      Date            : 1992-07-23                            */
/*      1992-07-23 : add SUN4_CPP_c =b=                         */
/*      1992-05-11 : changed "10" to "sizeof(ExtReal)"          */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctReal replaced             */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-06-21 : new routine                                */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* #include "atanh.h"      */
/* Teilpunkt               */
/* +3.125000000000000E-002 */
#define Tp                                  \
           EXTREAL(0x3F, 0xFA,              \
                   0x80, 0x00, 0x00, 0x00,  \
                   0x00, 0x00, 0x00, 0x00)

/* StdFctReal(t_atnh,atanhee) */
#ifdef LINT_ARGS
a_real t_atnh(a_real arg)
#else
a_real t_atnh(arg)

a_real arg;
#endif
        {
        int      rnd, rc;
        a_real   res;
        ExtReal  a, r;

        E_SPUSH("t_atnh")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&arg, &a);

        if ((rc = atanhee(&a, &r))!=0
            || (rc = extreal_to_longreal(&r, (LongReal *)&res))!=0)
           ieee_abortr1(rc, &arg);

        setrndmode(rnd);

        E_SPOPP("t_atnh")
        return res;
        }
/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | atanhee                                                      |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int atanhee (const ExtReal *arg, ExtReal *res)
#else
int atanhee (arg, res)
const ExtReal   *arg;
      ExtReal   *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int atanhee (ExtReal *arg, ExtReal *res)
#else
int atanhee (arg, res)
ExtReal   *arg;
ExtReal   *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
#ifdef ANSI_C
#if SUN4_CPP_C
   static ExtReal tp;
   static char tpc[sizeof(ExtReal)] = Tp;
#else
   static const ExtReal tp=Tp; /* Teilungspunkt 0.03125         */
#endif
#else
   static ExtReal tp;
   static char tpc[sizeof(ExtReal)] = Tp;
#endif
   ExtReal     an;         /* negatives Argument                */
   ExtReal     radd;       /* Ergebnis arg + 1                  */
   ExtReal     rsub;       /* Ergebnis arg - 1                  */
   ExtReal     rdiv;       /* Ergebnis radd / rsub              */
   ExtReal     rln;        /* Ergebnis ln                       */
   ExtReal     rp;         /* Ergebnis lnp1 pos                 */
   ExtReal     rn;         /* Ergebnis lnp1 neg                 */
   int         rnd;        /* RundungsMode                      */
   int         ret;        /* Rueckgabe                         */
   int         check;      /* Rueckgabe von Makro ArgCheck      */

#ifndef ANSI_C
   memcpy(&tp, tpc, sizeof(tp));
#else
#if SUN4_CPP_C
   memcpy(&tp, tpc, sizeof(tp));
#endif
#endif

   /* --- pruefe Argument --- */
   ArgCheck1(Atanh, arg, res);

   /* --- RundungsMode sichern, NEAR setzen --- */
   rnd  = getrndmode();
   setrndmode(NEAR);

   /* --- |arg| >= Teilungspunkt --- */
   if(-1!=cmpabsee(arg, &tp)) {
      addee(&One, arg, &radd);
      subee(&One, arg, &rsub);
      divee(&radd, &rsub, &rdiv);
      ret = lnee(&rdiv, &rln);
   }
   /* --- |arg| < Teilungspunkt --- */
   else {
      chsee(arg, &an);
      ret = lnp1ee(arg, &rp);
      ret = lnp1ee(&an, &rn);
      subee(&rp, &rn, &rln);
   }
   /* --- res = 0.5*rln --- */
   scaliee(&rln, -1, res);

   /* --- RundungsMode zuruecksetzen --- */
   setrndmode(rnd);

   return ret;
} /* atanhee() */
