/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_cos.c,v 1.2 1997/09/25 18:08:48 ae59 Exp $ */
/*
$Log: t_cos.c,v $
 * Revision 1.2  1997/09/25  18:08:48  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:07  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_cos.c                               */
/*                                                              */
/*      Entries         : a_real t_cos(arg)                     */
/*                        a_real arg;                           */
/*                                                              */
/*      Arguments       : arg  = argument of cosine             */
/*                                                              */
/*      Description     : Cosine function.                      */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctReal replaced             */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-06-21 : new routine                                */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctReal(t_cos,cosee) */
#ifdef LINT_ARGS
a_real t_cos(a_real arg)
#else
a_real t_cos(arg)

a_real arg;
#endif
        {
        int      rnd, rc;
        a_real   res;
        ExtReal  a, r;

        E_SPUSH("t_cos")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&arg, &a);

        if ((rc = cosee(&a, &r))!=0
            || (rc = extreal_to_longreal(&r, (LongReal *)&res))!=0)
           ieee_abortr1(rc, &arg);

        setrndmode(rnd);

        E_SPOPP("t_cos")
        return res;
        }
/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | Punkt Cosinus                                                |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int cosee(const ExtReal *arg, ExtReal *res)
#else
int cosee(arg, res)
const ExtReal  *arg;
      ExtReal  *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int cosee(ExtReal *arg, ExtReal *res)
#else
int cosee(arg, res)
ExtReal  *arg;
ExtReal  *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   DReal       v;          /* Produkt des Arguments mit 2/pi    */
   ExtReal     j;          /* Ganzzahliger Anteil von v         */
   int         jmod4;      /* j modulo 4                        */
   ExtReal     t;          /* reduziertes Argument              */
   int         retr;       /* Rueckgabe Reduktion               */
   int         ret;        /* Rueckgabe                         */
   int         check;      /* Rueckgabe von Makro ArgCheck      */

   /* --- pruefe Argument --- */
   ArgCheck1(Cos, arg, res);

   /* --- ganzzahliger Anteil von arg --- */
   gza_trg(arg, J_Init_Cos, Period_PiHalf, &v, &j, &jmod4);

   /* --- Reduktion --- */
   retr = red_trg(&v, &j, jmod4, &t);

   /* --- Cosinus --- */
   ret = sincos(&t, res);

   /* --- Rueckgabe ohne RundungsInfo --- */
   return (ret!=NoErr?ret:retr);
} /* cosee() */
