/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_cosh.c,v 1.2 1997/09/25 18:08:58 ae59 Exp $ */
/*
$Log: t_cosh.c,v $
 * Revision 1.2  1997/09/25  18:08:58  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:07  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_cosh.c                              */
/*                                                              */
/*      Entries         : a_real t_cosh(arg)                    */
/*                        a_real arg;                           */
/*                                                              */
/*      Arguments       : arg  = argument of hyperbolic cosine  */
/*                                                              */
/*      Description     : Hyperbolic cosine function.           */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctReal replaced             */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-08-05 : remove unused variable ret                 */
/*      1991-06-21 : new routine                                */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctReal(t_cosh,coshee) */
#ifdef LINT_ARGS
a_real t_cosh(a_real arg)
#else
a_real t_cosh(arg)

a_real arg;
#endif
        {
        int      rnd, rc;
        a_real   res;
        ExtReal  a, r;

        E_SPUSH("t_cosh")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&arg, &a);

        if ((rc = coshee(&a, &r))!=0
            || (rc = extreal_to_longreal(&r, (LongReal *)&res))!=0)
           ieee_abortr1(rc, &arg);

        setrndmode(rnd);

        E_SPOPP("t_cosh")
        return res;
        }
/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | cosh                                                         |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int coshee(const ExtReal *arg, ExtReal *res)
#else
int coshee(arg, res)
const ExtReal   *arg;
      ExtReal   *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int coshee(ExtReal *arg, ExtReal *res)
#else
int coshee(arg, res)
ExtReal   *arg;
ExtReal   *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   ExtReal     ep;         /* Ergebnis Positiver Exponent       */
   ExtReal     en;         /* Ergebnis Negativer Exponent       */
   ExtReal     radd;       /* Ergebnis Addition                 */
   int         rnd;        /* RundungsMode                      */
   int         check;      /* Rueckgabe von Makro ArgCheck      */

   /* --- pruefe Argument --- */
   ArgCheck1(Cosh, arg, res);
   arg_check = Off;

   /* --- RundungsMode sichern, NEAR setzen --- */
   rnd  = getrndmode();
   setrndmode(NEAR);

   /* --- cosh --- */
   expee(arg, &ep);
   divee(&One, &ep, &en);

   addee(&ep, &en, &radd);
   scaliee(&radd, -1, res);   /* /2                             */

   /* --- RundungsMode zuruecksetzen --- */
   setrndmode(rnd);
   arg_check = On;

   return NoErr;
} /* coshee() */
