/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_dhi1.c,v 1.2 1997/09/25 18:10:52 ae59 Exp $ */
/*
$Log: t_dhi1.c,v $
 * Revision 1.2  1997/09/25  18:10:52  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:14  ae59
 * Put under RCS control
 *
 */
/*      ISin,ICos cases considered */
/*      Date : 1992-01-23          */

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/*--------------------------------------------------------------*
 | Default Handle IntervallFunktionen mit einem Argument        |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int default_handle_i1(int fct, int exc, const IExtReal *arg, IExtReal *res)
#else
int default_handle_i1(fct, exc, arg, res)
      int      fct;
      int      exc;
const IExtReal *arg;
      IExtReal *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int default_handle_i1(int fct, int exc, IExtReal *arg, IExtReal *res)
#else
int default_handle_i1(fct, exc, arg, res)
int      fct;
int      exc;
IExtReal *arg;
IExtReal *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   switch(fct) {
   case  ITan:
   case  ICot:
   case  ICoth:
      if(exc==ExcISing) {
         copyee(&PInfty, &(res->u));
         copyee(&MInfty, &(res->l));
      }
      else {
         copyee(&Zero, &(res->u));
         copyee(&Zero, &(res->l));
      }
      break;
   case  IAtanh:
      if(exc==DOMAIN||exc==ExcISing) {
         if(-1!=cmpee(&(arg->u), &One))
            copyee(&PInfty, &(res->u));
         if(-1!=cmpee(&(arg->l), &One))
            copyee(&PInfty, &(res->l));
         if(1!=cmpee(&(arg->u), &MinusOne))
            copyee(&MInfty, &(res->u));
         if(1!=cmpee(&(arg->l), &MinusOne))
            copyee(&MInfty, &(res->l));
      }
      else {
         copyee(&Zero, &(res->u));
         copyee(&Zero, &(res->l));
      }
      break;
   case  IAcoth:
      if(exc==DOMAIN||exc==ExcISing) {
         if(1!=cmpabsee(&(arg->u), &One))
            copyee(&PInfty, &(res->u));
         if(1!=cmpabsee(&(arg->l), &One))
            copyee(&MInfty, &(res->l));
      }
      else {
         copyee(&Zero, &(res->u));
         copyee(&Zero, &(res->l));
      }
      break;
   case  IExp:
      if(exc==OVER_FLOW) {
         copyee(&PInfty, &(res->u));
         copyee(&PInfty, &(res->l));
      }
      else {
         copyee(&Zero, &(res->u));
         copyee(&Zero, &(res->l));
      }
      break;
   case  ICos:
   case  ISin:
      copyee(&One, &(res->u));
      copyee(&MinusOne, &(res->l));
      break;
   default:
      copyee(&Zero, &(res->u));
      copyee(&Zero, &(res->l));
      break;
   } /* switch(fct) */

   /* --- kein Fehler moeglich --- */
   return NoErr;
} /* default_handle_i1() */
