/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_dhl1.c,v 1.2 1997/09/25 18:11:12 ae59 Exp $ */
/*
$Log: t_dhl1.c,v $
 * Revision 1.2  1997/09/25  18:11:12  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:14  ae59
 * Put under RCS control
 *
 */
/*      Date    : 1991-09-06                                    */
/*      1991-09-06 : reduce maximum line length                 */

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/*--------------------------------------------------------------*
 | Default Handle PunktFunktionen mit einem Argument            |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int default_handle_1(int fct, int exc, const ExtReal *arg, ExtReal *res)
#else
int default_handle_1(fct, exc, arg, res)
      int      fct;
      int      exc;
const ExtReal  *arg;
      ExtReal  *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int default_handle_1(int fct, int exc, ExtReal *arg, ExtReal *res)
#else
int default_handle_1(fct, exc, arg, res)
int      fct;
int      exc;
ExtReal  *arg;
ExtReal  *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   switch(fct) {
   case  Exp:
      if(exc==OVER_FLOW)
         copyee(&PInfty, res);
      else
         copyee(&Zero, res);
      break;
   case  EToI:
      if(exc==OVER_FLOW)
         copyee(SGNE(arg)==POS ? &IntMax : &IntMin, res);
      else
         copyee(&Zero, res);
      break;
   case  EToL:
      switch(exc){
      case ExcPInf:
         copyee(&PInfty, res);
         break;
      case OVER_FLOW:
         copyee(&LongRealMax, res);
         break;
      case UNDER_FLOW:
         copyee(&LongRealDenormMin, res);
         break;
      case ExcMInf:
         copyee(&MInfty, res);
         break;
      default:
         copyee(&Zero, res);
         break;
      }
      break;
   default:
      copyee(&Zero, res);
      break;
   } /* switch(fct) */

   /* --- kein Fehler moeglich --- */
   return NoErr;
} /* default_handle_1() */
