/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_ehl1.c,v 1.2 1997/09/25 18:12:40 ae59 Exp $ */
/*
$Log: t_ehl1.c,v $
 * Revision 1.2  1997/09/25  18:12:40  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:19  ae59
 * Put under RCS control
 *
 */
/*      Date    : 1991-09-06                                    */
/*      1991-09-06 : reduce maximum line length                 */

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif
#include <stdio.h>

/*--------------------------------------------------------------*
 | Exception Handle PunktFunktionen mit einem Argument          |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int exc_handle_1(int fct, int exctype, const ExtReal *arg, ExtReal *res)
#else
int exc_handle_1(fct, exctype, arg, res)
      int      fct;        /* FunktionsNummer                   */
      int      exctype;    /* ExceptionNummer                   */
const ExtReal  *arg;
      ExtReal  *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int exc_handle_1(int fct, int exctype, ExtReal *arg, ExtReal *res)
#else
int exc_handle_1(fct, exctype, arg, res)
int      fct;              /* FunktionsNummer                   */
int      exctype;          /* ExceptionNummer                   */
ExtReal  *arg;
ExtReal  *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   struct ieee_exception exc;
   IExtReal              ia1;
   IExtReal              ia2;
   IExtReal              ir;
   char                  *name;  /* NamensString der Funktion   */

   /* --- kopiere, falls arg==res --- */
   copyee(res, &ir.u);

   /* --- hole Standard Antwort und FunktionsName --- */
   default_handle_1(fct, exctype, arg, &ir.u);
   excfct_to_a(fct, &name);

   /* --- matherr vorbereiten --- */
   copyee(arg   , &ia1.u);
   copyee(&Zero , &ia1.l);
   copyee(&Zero,  &ia2.u);
   copyee(&Zero,  &ia2.l);
   copyee(&Zero , &ir.l);

   exc.type = exctype;
   exc.name = name;
   exc.arg1 = &ia1;
   exc.arg2 = &ia2;
   exc.res  = &ir;

   /* --- Aufruf AnwenderFunktion --- */
   if (TakeOver==ieee_matherr(&exc)) {

      /* --- Uebernahme vom Anwender gesetzter Werte, Ende --- */
      copyee(&(exc.res->u), res);
      return exc.type;
   }

   /* --- sonst Ausgabe der unveraenderten FunktionsParameter --- */
   msg_exctyp(exc.type, name);
 /*  msg_exc("arg", arg);
   msg_exc("res", &ir.u); */ 

   /* --- kopiere default Antwort nach res
          (erst hier, falls arg==res) --- */
   copyee(&ir.u, res);

   return exctype;
} /* except_1() */
