/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_exc_.h,v 1.2 1997/09/25 16:47:41 ae59 Exp $ */
/*
$Log: t_exc_.h,v $
 * Revision 1.2  1997/09/25  16:47:41  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:21  ae59
 * Put under RCS control
 *
 */
/* ------------------------------------------------------------- */
/* Exception Return Codes der IEEE Math Funktionen               */
/* ------------------------------------------------------------- */

#define NoErr           0       /* no error                          */

/* --- in math.h definierte:  */
/* math.h aus ieee.h entfernt, da Namenskonflikte mit PXSC-Runtime */
/* bei Bezeichnern OVERFLOW, UNDERFLOW und (hier nicht verwendet) MAXINT. */
#define DOMAIN          1       /* argument domain error             */
#define SING            2       /* argument singularity              */
#define OVER_FLOW       3       /* overflow range error              */
#define UNDER_FLOW      4       /* underflow range error             */
#define TLOSS           5       /* total loss of precision           */
#define PLOSS           6       /* partial loss of precision         */
/* --- ende math.h --- */

/* --- exception codes (abgeleitet aus Koprozessor Exceptions) --- */
#define ExcPUnorm       101     /* +Unormal                          */
#define ExcPNAN         102     /* +NAN                              */
#define ExcMUnorm       103     /* -Unormal                          */
#define ExcMNAN         104     /* -NAN                              */
#define ExcPNorm        105     /* +Normal                           */
#define ExcPInf         106     /* +Infinity                         */
#define ExcMNorm        107     /* -Normal                           */
#define ExcMInf         108     /* -Infinity                         */
#define ExcPZero        109     /* +0                                */
#define ExcMZero        111     /* -0                                */
#define ExcEmpty        112     /* empty                             */
#define ExcPDenorm      113     /* +Denormal                         */
#define ExcMDenorm      115     /* -Denormal                         */

/* --- weitere --- */
#define ExcInvalid      220     /* ungueltiges Argument              */
#define ExcNoI          250     /* Intervallgrenzen vertauscht       */
#define ExcISing        260     /* Intervallargument enthaelt Pol    */
#define ExcUnknown      999     /* falls unbestimmt                  */

/* 241090 Baumhof */
#define ExcDBZ          270     /* Division durch Null               */
#define ExcDIZ          280     /* Division durch Intervall mit 0    */
