/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_iact.c,v 1.2 1997/09/25 18:14:56 ae59 Exp $ */
/*
$Log: t_iact.c,v $
 * Revision 1.2  1997/09/25  18:14:56  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:26  ae59
 * Put under RCS control
 *
 */

/****************************************************************/
/*      Name            : t_iact.c                              */
/*                                                              */
/*      Description     : arccot(ai) for intervals              */
/*                                                              */
/*      Date            : 1993-03-12                            */
/*      1993-03-12 : corrected lower bound if 0 in argument =b= */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctInterval replaced         */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-09-06 : reduce maximum line length                 */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctInterval(t_iact,iacotee) */
#ifdef LINT_ARGS
a_intv t_iact(a_intv ai)
#else
a_intv t_iact(ai)

a_intv ai;
#endif
        {

        a_intv   res;
        int      rnd, rc;
        IExtReal  a, r;

        E_SPUSH("t_iact")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&ai.INF, &a.l);
        longreal_to_extreal((LongReal *)&ai.SUP, &a.u);

        if ((rc = iacotee(&a, &r))!=0)
            ieee_aborti1(rc, &ai);

        setrndmode(DOWN);
        if ((rc = extreal_to_longreal(&r.l, (LongReal *)&res.INF))!=0)
             ieee_aborti1(rc, &ai);
        setrndmode(UP);
        if ((rc = extreal_to_longreal(&r.u, (LongReal *)&res.SUP))!=0)
            ieee_aborti1(rc, &ai);
        setrndmode(rnd);

        E_SPOPP("t_iact")
        return res;
        }

/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | iacot                                                        |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int iacotee (const IExtReal *arg, IExtReal *res)
#else
int iacotee (arg, res)
const IExtReal   *arg;
      IExtReal   *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int iacotee (IExtReal *arg, IExtReal *res)
#else
int iacotee (arg, res)
IExtReal   *arg;
IExtReal   *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   IExtReal    r;          /* Ergebnis vor Rundung              */
   int         retu;       /* Rueckgabe                         */
   int         retl;       /* Rueckgabe                         */
   int         check;      /* Rueckgabe von Makro ArgCheck      */

   /* --- pruefe Argument, dann Pruefung aus --- */
   ArgCheckI1(IAcot, arg, res);
   arg_check = Off;

   /* --- Arcus Cotangens --- */
   retu = acotee(&(arg->l), &r.u);
   retl = acotee(&(arg->u), &r.l);

   /* --- Abbruch bei Fehler --- */
   if(retu!=NoErr || retl!=NoErr) {
      icopyee(&r, res);
      arg_check = On;
      return max(retu, retl);
   }

   /* --- Rundungs-Fehler --- */
   iround_rel(&r, &EpsACot, res);

   /* Ergebnisverbesserung in Spezialfaellen */
#if INT_HPREC
   { int vz;
     if (1==cmpee(&(res->u), &(IPi.u)))
        /* arccot x <= pi */
        copyee(&(IPi.u), &(res->u));
     vz = SGNE(&(arg->l));
     if (vz==POS&&1==cmpee(&(res->u), &(IPiHalf.u)))
        /* arccot x <= pi/2 */
        copyee(&(IPiHalf.u), &(res->u));
     vz = SGNE(&(arg->u));
     if (vz==NEG&&-1==cmpee(&(res->l), &(IPiHalf.l)))
        /* arccot x >= pi/2 */
        copyee(&(IPiHalf.l), &(res->l));
   }
#endif /* INT_HPREC */

   /* --- ArgPruefung wieder an --- */
   arg_check = On;

   /* --- kein Fehler mehr moeglich --- */
   return NoErr;
} /* iacotee() */


