/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_iasn.c,v 1.2 1997/09/25 18:15:26 ae59 Exp $ */
/*
$Log: t_iasn.c,v $
 * Revision 1.2  1997/09/25  18:15:26  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:27  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_iasn.c                              */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctInterval replaced         */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-09-06 : reduce maximum line length                 */
/*      1991-08-27 : use absolute compare for negative numbers  */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctInterval(t_iasn,iasinee) */
#ifdef LINT_ARGS
a_intv t_iasn(a_intv ai)
#else
a_intv t_iasn(ai)

a_intv ai;
#endif
        {

        a_intv   res;
        int      rnd, rc;
        IExtReal  a, r;

        E_SPUSH("t_iasn")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&ai.INF, &a.l);
        longreal_to_extreal((LongReal *)&ai.SUP, &a.u);

        if ((rc = iasinee(&a, &r))!=0)
            ieee_aborti1(rc, &ai);

        setrndmode(DOWN);
        if ((rc = extreal_to_longreal(&r.l, (LongReal *)&res.INF))!=0)
             ieee_aborti1(rc, &ai);
        setrndmode(UP);
        if ((rc = extreal_to_longreal(&r.u, (LongReal *)&res.SUP))!=0)
            ieee_aborti1(rc, &ai);
        setrndmode(rnd);

        E_SPOPP("t_iasn")
        return res;
        }

/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | iasin                                                        |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int iasinee (const IExtReal *arg, IExtReal *res)
#else
int iasinee (arg, res)
const IExtReal   *arg;
      IExtReal   *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int iasinee (IExtReal *arg, IExtReal *res)
#else
int iasinee (arg, res)
IExtReal   *arg;
IExtReal   *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   IExtReal    r;          /* Ergebnis vor Rundung              */
   int         retu;       /* Rueckgabe                         */
   int         retl;       /* Rueckgabe                         */
   int         check;      /* Rueckgabe von Makro ArgCheck      */

   /* --- pruefe Argument, dann Pruefung aus --- */
   ArgCheckI1(IAsin, arg, res);
   arg_check = Off;

   /* --- asin --- */
   retu = asinee(&(arg->u), &r.u);
   retl = asinee(&(arg->l), &r.l);

   /* --- Abbruch bei Fehler --- */
   if(retu!=NoErr || retl!=NoErr) {
      icopyee(&r, res);
      arg_check = On;
      return max(retu, retl);
   }

   /* --- Rundungs-Fehler --- */
   iround_rel(&r, &EpsASin, res);

   /* Verbesserung des Ergebnis' in Spezialfaellen */
#if INT_HPREC
   { int vz;
     vz = SGNE(&(arg->l));
     if (vz==POS&&1==cmpee(&(arg->l), &(res->l)))    /* arcsin x >= x */
        copyee(&(arg->l), &(res->l));
     vz = SGNE(&(arg->u));
     if (vz==NEG&&1==cmpabsee(&(arg->u), &(res->u)))   /* arcsin x <= x */
        copyee(&(arg->u), &(res->u));
     if (1==cmpee(&(res->u), &(IPiHalf.u)))          /* arcsin x < pi/2 */
        copyee(&(IPiHalf.u), &(res->u));
     if (1==cmpabsee(&(res->l), &(IPiHalf.u)))       /* arcsin x > -pi/2 */
        { copyee(&(IPiHalf.u), &(res->l));
          chsee(&(res->l), &(res->l)); }
   }
#endif /* INT_HPREC */

   /* --- ArgPruefung wieder an --- */
   arg_check = On;

   /* --- kein Fehler mehr moeglich --- */
   return NoErr;
} /* iasinee() */


