/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_iexp.c,v 1.2 1997/09/25 18:17:15 ae59 Exp $ */
/*
$Log: t_iexp.c,v $
 * Revision 1.2  1997/09/25  18:17:15  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:33  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_iexp.c                              */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctInterval replaced         */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-08-05 : remove unused variable ret                 */
/*      1991-06-21 : new routine                                */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctInterval(t_iexp,iexpee) */
#ifdef LINT_ARGS
a_intv t_iexp(a_intv ai)
#else
a_intv t_iexp(ai)

a_intv ai;
#endif
        {

        a_intv   res;
        int      rnd, rc;
        IExtReal  a, r;

        E_SPUSH("t_iexp")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&ai.INF, &a.l);
        longreal_to_extreal((LongReal *)&ai.SUP, &a.u);

        if ((rc = iexpee(&a, &r))!=0)
            ieee_aborti1(rc, &ai);

        setrndmode(DOWN);
        if ((rc = extreal_to_longreal(&r.l, (LongReal *)&res.INF))!=0)
             ieee_aborti1(rc, &ai);
        setrndmode(UP);
        if ((rc = extreal_to_longreal(&r.u, (LongReal *)&res.SUP))!=0)
            ieee_aborti1(rc, &ai);
        setrndmode(rnd);

        E_SPOPP("t_iexp")
        return res;
        }

/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | iexpee                                                       |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int iexpee (const IExtReal *arg, IExtReal *res)
#else
int iexpee (arg, res)
const IExtReal *arg;
      IExtReal *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int iexpee (IExtReal *arg, IExtReal *res)
#else
int iexpee (arg, res)
IExtReal *arg;
IExtReal *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   IExtReal    r;          /* Ergebnis vor Rundung              */
   int         retu;       /* Rueckgabe                         */
   int         retl;       /* Rueckgabe                         */
   int         check;      /* Rueckgabe von Makro ArgCheck      */

   /* --- pruefe Argument, dann Pruefung aus --- */
   ArgCheckI1(IExp, arg, res);
   /* arg_check = Off; */

   /* --- exp --- */
   retu = expee(&(arg->u), &r.u);
   retl = expee(&(arg->l), &r.l);

   /* --- Abbruch bei Fehler --- */
   if(retu!=NoErr || retl!=NoErr) {
      icopyee(&r, res);
      arg_check = On;
      return max(retu, retl);
   }

   /* nicht runden, falls Argument Null ist */
   if (!cmpee(&(arg->l), &Zero)) retl |= LB_Exact;
   if (!cmpee(&(arg->u), &Zero)) retu |= UB_Exact;

   /* --- Rundungs-Fehler --- */
   if(!(retu&UB_Exact)) round_rel(UP,   &(r.u), &EpsExp, &(res->u));
   else copyee(&r.u, &res->u);
   if(!(retl&LB_Exact)) round_rel(DOWN, &(r.l), &EpsExp, &(res->l));
   else copyee(&r.l, &res->l);

   /* Verbesserung des Ergebnis' in Spezialfaellen */
#if INT_HPREC
   { int vz;
     vz = SGNE(&(arg->l));
     if (vz==POS&&-1==cmpee(&(res->l), &(One))) /* exp x >= 1 */
        copyee(&(One), &(res->l));
     vz = SGNE(&(arg->u));
     if (vz==NEG&&1==cmpee(&(res->u), &(One)))  /* exp x <= 1 */
        copyee(&(One), &(res->u));
   }
#endif /* INT_HPREC */

   /* Unterlaufbehandlung */
   if(0==cmpee(&(res->u),&Zero))
      copyee(&LongRealDenormMin,&(res->u));

   /* --- ArgPruefung wieder an --- */
   arg_check = On;

   /* --- kein Fehler mehr moeglich --- */
   return NoErr;
} /* iexpee() */
