/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_ilog.c,v 1.2 1997/09/25 18:17:47 ae59 Exp $ */
/*
$Log: t_ilog.c,v $
 * Revision 1.2  1997/09/25  18:17:47  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:34  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctInterval replaced         */
/*      1991-09-17 : remove semicolon after makro               */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctInterval(t_ilog,ilnee) */
#ifdef LINT_ARGS
a_intv t_ilog(a_intv ai)
#else
a_intv t_ilog(ai)

a_intv ai;
#endif
        {

        a_intv   res;
        int      rnd, rc;
        IExtReal  a, r;

        E_SPUSH("t_ilog")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&ai.INF, &a.l);
        longreal_to_extreal((LongReal *)&ai.SUP, &a.u);

        if ((rc = ilnee(&a, &r))!=0)
            ieee_aborti1(rc, &ai);

        setrndmode(DOWN);
        if ((rc = extreal_to_longreal(&r.l, (LongReal *)&res.INF))!=0)
             ieee_aborti1(rc, &ai);
        setrndmode(UP);
        if ((rc = extreal_to_longreal(&r.u, (LongReal *)&res.SUP))!=0)
            ieee_aborti1(rc, &ai);
        setrndmode(rnd);

        E_SPOPP("t_ilog")
        return res;
        }

/* ------------------------------------------------------------ */

#ifdef LINT_ARGS
#ifdef ANSI_C
int round_ln(int rnd, int rr, const ExtReal *arg, ExtReal *res);
#else  /* NOT ANSI_C */
int round_ln(int rnd, int rr, ExtReal *arg, ExtReal *res);
#endif /* ANSI_C */
#else  /* NOT LINT_ARGS */
int round_ln();
#endif /* LINT_ARGS */

/*--------------------------------------------------------------*
 | Intervall Ln                                                 |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int ilnee (const IExtReal *arg, IExtReal *res)
#else
int ilnee (arg, res)
const IExtReal   *arg;
      IExtReal   *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int ilnee (IExtReal *arg, IExtReal *res)
#else
int ilnee (arg, res)
IExtReal   *arg;
IExtReal   *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   IExtReal    r;          /* Ergebnis vor Rundung              */
   int         rnd;        /* RundungsMode                      */
   int         rru;        /* Rueckgabe RundungsArt             */
   int         rrl;        /* Rueckgabe RundungsArt             */
   int         retu;       /* Rueckgabe                         */
   int         retl;       /* Rueckgabe                         */
   int         check;      /* Rueckgabe von Makro ArgCheck      */

   /* --- pruefe Argument, dann Pruefung aus --- */
   ArgCheckI1(ILn, arg, res);
   arg_check = Off;

   /* --- RundungsMode sichern, NEAR setzen --- */
   rnd  = getrndmode();
   setrndmode(NEAR);

   /* --- ln --- */
   retu = _s_ln(&(arg->u), &r.u, &rru);
   retl = _s_ln(&(arg->l), &r.l, &rrl);

   /* --- RundungsMode zuruecksetzen --- */
   setrndmode(rnd);

   /* --- Abbruch bei Fehler --- */
   if(retu!=NoErr || retl!=NoErr) {
      icopyee(&r, res);
      arg_check = On;
      return max(retu, retl);
   }

   /* --- Rundungs-Fehler --- */
   round_ln(UP,   rru, &(r.u), &(res->u));
   round_ln(DOWN, rrl, &(r.l), &(res->l));

   /* --- ArgPruefung wieder an --- */
   arg_check = On;

   /* --- kein Fehler mehr moeglich --- */
   return NoErr;
} /* ilnee() */

/*--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int round_ln(int rnd, int rr, const ExtReal *arg, ExtReal *res)
#else
int round_ln(rnd, rr, arg, res)
      int      rnd;
      int      rr;
const ExtReal  *arg;
      ExtReal  *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int round_ln(int rnd, int rr, ExtReal *arg, ExtReal *res)
#else
int round_ln(rnd, rr, arg, res)
int      rnd;
int      rr;
ExtReal  *arg;
ExtReal  *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   switch(rr){
   case 1:                              /* im ApproxIntervall   */
      round_rel(rnd, arg, &EpsLn, res);
      break;
   case 2:                              /* ausserhalb ApproxIntervall   */
      sround(rnd, arg, &EpsLnRel, &EpsLnAbs, res);
      break;
   }
   return NoErr;
} /* round_ln() */
