/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_tanh.c,v 1.2 1997/09/25 18:24:10 ae59 Exp $ */
/*
$Log: t_tanh.c,v $
 * Revision 1.2  1997/09/25  18:24:10  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:52  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_tanh.c                              */
/*                                                              */
/*      Entries         : a_real t_tanh(arg)                    */
/*                        a_real arg;                           */
/*                                                              */
/*      Arguments       : arg  = argument of hyp. tangent       */
/*                                                              */
/*      Description     : Hyperbolic tangent function.          */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctReal replaced             */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-06-21 : new routine                                */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctReal(t_tanh,tanhee) */
#ifdef LINT_ARGS
a_real t_tanh(a_real arg)
#else
a_real t_tanh(arg)

a_real arg;
#endif
        {
        int      rnd, rc;
        a_real   res;
        ExtReal  a, r;

        E_SPUSH("t_tanh")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&arg, &a);

        if ((rc = tanhee(&a, &r))!=0
            || (rc = extreal_to_longreal(&r, (LongReal *)&res))!=0)
           ieee_abortr1(rc, &arg);

        setrndmode(rnd);

        E_SPOPP("t_tanh")
        return res;
        }
/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | tanh                                                         |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int tanhee(const ExtReal *arg, ExtReal *res)
#else
int tanhee(arg, res)
const ExtReal   *arg;
      ExtReal   *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int tanhee(ExtReal *arg, ExtReal *res)
#else
int tanhee(arg, res)
ExtReal   *arg;
ExtReal   *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   ExtReal     r;          /* Ergebnis Coth                     */
   int         ret;        /* Rueckgabe                         */
   int         check;      /* Rueckgabe von Makro ArgCheck      */

   /* --- pruefe Argument --- */
   ArgCheck1(Tanh, arg, res);

   /* --- Null extra --- */
   if(0==cmpee(arg, &Zero))
      ret = copyee(&Zero, res);

   /* --- Tanh --- */
   else {
      ret = cothee(arg, &r);
      divee(&One, &r, res);
   }

   return ret;
} /* tanhee() */
