/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: y_free.c,v 1.2 1997/09/25 18:25:10 ae59 Exp $ */
/*
$Log: y_free.c,v $
 * Revision 1.2  1997/09/25  18:25:10  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:55  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : y_free.c                              */
/*                                                              */
/*      Entry           : void y_free(d)                        */
/*                        y_dscp d;                             */
/*                                                              */
/*      Arguments       : d - descriptor of dynamic array       */
/*                                                              */
/*      Description     : free dynamic array                    */
/*                                                              */
/*      Date            : 1991-05-29                            */
/*      1991-05-29 : descrtype * replaced by y_dscp             */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/*      1990-10-30 : no cast for d->array                       */
/*      1990-09-18 : do not free if subarray                    */
/*      1990-09-06 : not freed if array-component is NULL       */
/*      1990-07-16 : LINT_ARGS prototype                        */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void y_free(y_dscp d)
#else
local void y_free(d)

y_dscp d;
#endif
        {
        E_TPUSH("y_free")

        if ((char *)((y_desc *)d)->array!=NULL && NOT(((y_desc *)d)->subarr))
           {
#ifdef HEAP_CHECK
b_freh((a_char *)&((y_desc *)d)->array,
(a_char *)((y_desc *)d)->array,(a_char *)"y_free");
#endif
           B_FREE(((y_desc *)d)->array)
           ((y_desc *)d)->array = NULL;
           }

#ifdef HEAP_CHECK
else if (NOT(((y_desc *)d)->subarr))
b_freh((a_char *)&((y_desc *)d)->array,
(a_char *)((y_desc *)d)->array,(a_char *)"y_free");
#endif

        E_TPOPP("y_free")
        return;
        }
