/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: y_init.c,v 1.2 1997/09/25 18:25:30 ae59 Exp $ */
/*
$Log: y_init.c,v $
 * Revision 1.2  1997/09/25  18:25:30  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:56  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : y_init.c                              */
/*                                                              */
/*      Entry           : void y_init(d,dim,elsize)             */
/*                        y_dscp d;                             */
/*                        a_byte dim;                           */
/*                        size_t elsize;                        */
/*                                                              */
/*      Arguments       : d - descriptor of dynamic array       */
/*                        dim - dimension of dynamic array      */
/*                        elsize - size of an element in bytes  */
/*                                                              */
/*      Description     : initialization of a dynamic array     */
/*                                                              */
/*      Note            : component d->fd must be set on entry. */
/*                                                              */
/*      Date            : 1993-04-07                            */
/*      1993-04-07 : introduced tmp to check size_ t overflow=b=*/
/*                   replaced y_desc* to y_dscp                 */
/*      1992-07-22 : cast to size_t at stride/elnum calc. =b=   */
/*      1991-10-22 : missing parantheses                        */
/*      1991-10-10 : (a_VOID) for malloc()                      */
/*      1991-05-29 : descrtype * replaced by y_dscp             */
/*      1990-12-12 : byte replaced by a_byte                    */
/*      1990-11-12 : E_TPUSH+E_TPOPP                            */
/*      1990-07-09 : LINT_ARGS prototype                        */
/*                   allocation error with E_TMSG               */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void y_init(y_dscp d,a_byte dim,size_t elsize)
#else
local void y_init(d,dim,elsize)

y_dscp d;
a_byte dim;
size_t elsize;
#endif
        {
        int i;  /* !!! must be int !!! */
        unsigned long tmp;

        E_TPUSH("y_init")

        ((y_dscp)d)->subarr = ((y_dscp)d)->destroy = FALSE;
        ((y_dscp)d)->elsize = elsize;
        ((y_dscp)d)->numdim = dim;
        ((y_dscp)d)->fd[dim-1].stride = 1;
        
        for (i=dim-2;i>=0;i--)
        {
           tmp = (unsigned long) ((((y_dscp)d)->fd[i+1].ubound-
                                   ((y_dscp)d)->fd[i+1].lbound+1)*
                                      ((y_dscp)d)->fd[i+1].stride);
           ((y_dscp)d)->fd[i].stride = (size_t) tmp;
           if ((unsigned long)(((y_dscp)d)->fd[i].stride ) !=tmp) 
                e_trap(ALLOCATION,2,E_TMSG,42);

        }

        tmp = (unsigned long) ((((y_dscp)d)->fd[0].ubound-
                                ((y_dscp)d)->fd[0].lbound+1)*
                                ((y_dscp)d)->fd[0].stride);
        ((y_dscp)d)->elnum = (size_t) tmp;
        if ((unsigned long)(((y_dscp)d)->elnum)!=tmp) 
                e_trap(ALLOCATION,2,E_TMSG,42);

/*
        if (((a_char *)((y_dscp)d)->array = 
(a_char *)malloc(((y_dscp)d)->elnum*((y_dscp)d)->elsize))==NULL)
*/
        tmp = (unsigned long)(((y_dscp)d)->elnum*((y_dscp)d)->elsize);
        if ((tmp-(size_t)tmp)!=0L) e_trap(ALLOCATION,2,E_TMSG,42);

        if ((((y_dscp)d)->array = malloc((size_t)tmp))==NULL)
           e_trap(ALLOCATION,2,E_TMSG,42);
#ifdef HEAP_CHECK
b_geth((a_char *)&((y_dscp)d)->array,
(a_char *)((y_dscp)d)->array,(a_char *)"y_init");
#endif

        E_TPOPP("y_init")
        return;
        }
