/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: y_new.c,v 1.2 1997/09/25 18:26:15 ae59 Exp $ */
/*
$Log: y_new.c,v $
 * Revision 1.2  1997/09/25  18:26:15  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:57  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : y_new.c                               */
/*                                                              */
/*      Entry           : void   y_new (d,e_args)               */
/*                        y_dscp d;                             */
/*                        e_list                                */
/*                                                              */
/*      Arguments       : d - descriptor of dynamic array       */
/*                        e_args - variable argument list       */
/*                                                              */
/*      Return value    : void                                  */
/*                                                              */
/*      Description     : allocate dynamic array, bounds are=b= */
/*                        trailing.                             */
/*                        check allocation of d, free if any,   */
/*                        check bounds and                      */
/*                        calls y_ init                         */
/*                                                              */
/*      Date            : 1993-01-19                            */
/*      1993-01-19      : new function                          */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
#if C_P_7
local void   y_new (y_dscp d,...)
#else
local void   y_new (d,e_args)
y_dscp d;
e_list
#endif
#else
local void   y_new (d,e_args)

y_dscp d;
e_list
#endif

{
        a_btyp v = 0;
        a_intg i;
        va_list e_argv;


        /* check if field is already allocated */
        y_free(d);

        e_open(d);

        /* assign bounds for every dimension */
        for (i=0;i<((y_dscp)d)->numdim;i++)
	   {
           ((y_dscp)d)->fd[i].lbound= e_ref(a_intg);
           ((y_dscp)d)->fd[i].ubound= e_ref(a_intg);

           /* check lbound less equal ubound */
           if (((y_dscp)d)->fd[i].lbound > ((y_dscp)d)->fd[i].ubound)
              e_trap(INDEX_RANGE,6,
                  E_TINT+E_TEXT(4),&i,
                  E_TINT+E_TEXT(5),&((y_dscp)d)->fd[i].lbound,
                  E_TINT+E_TEXT(6),&((y_dscp)d)->fd[i].ubound);
        }


        y_init(d,d->numdim,d->elsize);

        e_shut; /* end of dynamic arg list */
        E_TPOPP("y_new")
        return;
}
