/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: z_cisb.c,v 1.2 1997/09/25 18:27:58 ae59 Exp $ */
/*
$Log: z_cisb.c,v $
 * Revision 1.2  1997/09/25  18:27:58  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:26:02  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : z_cisb.c                              */
/*                                                              */
/*      Entries         : void z_cisb(crl,cil,cru,ciu,a,b)      */
/*                        dotprecision *crl,*cil,*cru,*ciu;     */
/*                        a_cmpx a;                             */
/*                        a_intv b;                             */
/*                                                              */
/*      Arguments       : crl=dotprecision variable(real lower) */
/*                        cil=dotprecision variable(imag lower) */
/*                        cru=dotprecision variable(real upper) */
/*                        ciu=dotprecision variable(imag upper) */
/*                        a = interval value                    */
/*                        b = complex value                     */
/*                                                              */
/*      Description     : Subtract complex*interval product     */
/*                        from dotprecision variable            */
/*                        c = c-a*b                             */
/*                                                              */
/*      Date            : 1990-11-22                            */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void z_cisb(dotprecision *crl,dotprecision *cil,dotprecision *cru,
                  dotprecision *ciu,a_cmpx a,a_intv b)
#else
local void z_cisb(crl,cil,cru,ciu,a,b)

dotprecision *crl;
dotprecision *cil;
dotprecision *cru;
dotprecision *ciu;
a_cmpx a;
a_intv b;
#endif
        {
        E_TPUSH("z_cisb")

        i_risb(crl,cru,a.RE,b);
        i_risb(cil,ciu,a.IM,b);

        E_TPOPP("z_cisb")
        return;
        }

