/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: z_rzad.c,v 1.2 1997/09/25 18:29:45 ae59 Exp $ */
/*
$Log: z_rzad.c,v $
 * Revision 1.2  1997/09/25  18:29:45  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:26:06  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : z_rzad.c                              */
/*                                                              */
/*      Entries         : void z_rzad(crl,cil,cru,ciu,a,b)      */
/*                        dotprecision *crl,*cil,*cru,*ciu;     */
/*                        a_real a;                             */
/*                        a_cinv b;                             */
/*                                                              */
/*      Arguments       : crl=dotprecision variable(real lower) */
/*                        cil=dotprecision variable(imag lower) */
/*                        cru=dotprecision variable(real upper) */
/*                        ciu=dotprecision variable(imag upper) */
/*                        a = real value                        */
/*                        b = complex interval value            */
/*                                                              */
/*      Description     : Add real*(complex interval) product   */
/*                        to dotprecision variable              */
/*                        c = c+a*b                             */
/*                                                              */
/*      Date            : 1990-11-22                            */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void z_rzad(dotprecision *crl,dotprecision *cil,dotprecision *cru,
                  dotprecision *ciu,a_real a,a_cinv b)
#else
local void z_rzad(crl,cil,cru,ciu,a,b)

dotprecision *crl;
dotprecision *cil;
dotprecision *cru;
dotprecision *ciu;
a_real a;
a_cinv b;
#endif
        {
        E_TPUSH("z_rzad")

        i_riad(crl,cru,a,b.RE);
        i_riad(cil,ciu,a,b.IM);

        E_TPOPP("z_rzad")
        return;
        }

