/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: z_scpy.c,v 1.2 1997/09/25 18:30:15 ae59 Exp $ */
/*
$Log: z_scpy.c,v $
 * Revision 1.2  1997/09/25  18:30:15  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:26:08  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : z_scpy.c                              */
/*                                                              */
/*      Entries         : a_cinv z_scpy(r,s,rnd)                */
/*                        y_desc *r;                            */
/*                        y_desc *s;                            */
/*                        a_intg rnd;                           */
/*                                                              */
/*      Arguments       : r   = complex interval vector         */
/*                        s   = complex interval vector         */
/*                        rnd = mode                            */
/*                              0  clears accus first           */
/*                              4  does not clear accus         */
/*                                                              */
/*      Function value  : Complex interval dotproduct           */
/*                                                              */
/*      Description     : Dotproduct for dynamic complex        */
/*                        interval arrays.                      */
/*                                                              */
/*      Date            : 1991-04-22                            */
/*      1991-04-22 : real assignment replaced by R_ASSIGN()     */
/*      1991-01-22 : VAX_VMS_C considered                       */
/*      1990-12-18 : E_TPUSH+E_TPOPP                            */
/*      1990-11-12 : E_TPUSH+E_TPOPP                            */
/*      1990-10-31 : force linkage of global variables          */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern dotprecision b_acrl;
extern dotprecision b_acru;
extern dotprecision b_acil;
extern dotprecision b_aciu;
extern a_real *r_zero;
#endif

#ifdef LINT_ARGS
local a_cinv z_scpy(y_desc *r,y_desc *s,a_intg rnd)
#else
local a_cinv z_scpy(r,s,rnd)

y_desc *r;
y_desc *s;
a_intg rnd;
#endif
        {
        a_intg i,k;
        a_cinv res;

        E_TPUSH("z_scpy")

        /* force linkage of module containing global variables only */
#if VAX_VMS_C
        b_accu();
#endif

        R_ASSIGN(res.RE.INF,*r_zero);
        R_ASSIGN(res.RE.SUP,*r_zero);
        R_ASSIGN(res.IM.INF,*r_zero);
        R_ASSIGN(res.IM.SUP,*r_zero);

        if (r->numdim!=1 || s->numdim!=1)
           {
           i = r->numdim;
           k = s->numdim;
           e_trap(INV_ARG,6,E_TMSG,26,E_TINT+E_TEXT(11),&i,
                                      E_TINT+E_TEXT(11),&k);
           }
        else if (r->elnum!=s->elnum)
           {
           i = r->elnum;
           k = s->elnum;
           e_trap(INV_ARG,6,E_TMSG,27,E_TINT+E_TEXT(11),&i,
                                      E_TINT+E_TEXT(12),&k);
           }
        else
           {
           if (rnd<3)
              {
              d_clr(&b_acrl);
              d_clr(&b_acru);
              d_clr(&b_acil);
              d_clr(&b_aciu);
              }

           for (i=0;i<r->elnum;i++)
              /* possible pointer allignment problems              */
              z_padd(&b_acrl,&b_acru,&b_acil,&b_aciu,
                             *(a_cinv *)y_inxn(r,(r->fd[0]).lbound+i),
                             *(a_cinv *)y_inxn(s,(s->fd[0]).lbound+i));

           res = z_zsta(b_acrl,b_acru,b_acil,b_aciu);
           }

        E_TPOPP("z_scpy")
        return(res);
        }

