/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: z_zsta.c,v 1.2 1997/09/25 18:30:35 ae59 Exp $ */
/*
$Log: z_zsta.c,v $
 * Revision 1.2  1997/09/25  18:30:35  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:26:09  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : z_zsta.c                              */
/*                                                              */
/*      Entries         : a_cinv z_zsta(crl,cil,cru,ciu)        */
/*                        dotprecision crl,cil,cru,ciu;         */
/*                                                              */
/*      Arguments       : crl=dotprecision value(real lower)    */
/*                        cil=dotprecision value(imag lower)    */
/*                        cru=dotprecision value(real upper)    */
/*                        ciu=dotprecision value(imag upper)    */
/*                                                              */
/*      Description     : Convert complex interval              */
/*                                                              */
/*      Date            : 1990-11-22                            */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local a_cinv z_zsta(dotprecision crl,dotprecision cil,dotprecision cru,
                    dotprecision ciu)
#else
local a_cinv z_zsta(crl,cil,cru,ciu)

dotprecision crl;
dotprecision cil;
dotprecision cru;
dotprecision ciu;
#endif
        {
        a_cinv res;

        E_TPUSH("z_zsta")

        res.RE.INF = d_stad(crl);
        res.IM.INF = d_stad(cil);
        res.RE.SUP = d_stau(cru);
        res.IM.SUP = d_stau(ciu);

        E_TPOPP("z_zsta")
        return(res);
        }

