/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: z_zsub.c,v 1.2 1997/09/25 18:30:45 ae59 Exp $ */
/*
$Log: z_zsub.c,v $
 * Revision 1.2  1997/09/25  18:30:45  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:26:09  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : z_zsub.c                              */
/*                                                              */
/*      Entries         : void z_zsub(crl,cil,cru,ciu,a)        */
/*                        dotprecision *crl,*cil,*cru,*ciu;     */
/*                        a_cinv a;                             */
/*                                                              */
/*      Arguments       : crl=dotprecision variable(real lower) */
/*                        cil=dotprecision variable(imag lower) */
/*                        cru=dotprecision variable(real upper) */
/*                        ciu=dotprecision variable(imag upper) */
/*                        a = complex interval value            */
/*                                                              */
/*      Description     : Subtract complex interval from        */
/*                        dotprecision variable                 */
/*                        c = c-a                               */
/*                                                              */
/*      Date            : 1990-11-22                            */
/*      1990-11-22 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void z_zsub(dotprecision *crl,dotprecision *cil,dotprecision *cru,
                  dotprecision *ciu,a_cinv a)
#else
local void z_zsub(crl,cil,cru,ciu,a)

dotprecision *crl;
dotprecision *cil;
dotprecision *cru;
dotprecision *ciu;
a_cinv a;
#endif
        {
        E_TPUSH("z_zsub")

        d_rsub(crl,a.RE.SUP);
        d_rsub(cil,a.IM.SUP);
        d_rsub(cru,a.RE.INF);
        d_rsub(ciu,a.IM.INF);

        E_TPOPP("z_zsub")
        return;
        }

