/*
 *  MODULE:  syntax.h
 *  Expression parser and parser utilities
{*  last modification:  29.01.91  18:06   }
 *  uli 10.01.91 : chkc and chkid are boolean functions now
 *  uli 29.01.91 : macro expression deleted
*/


#ifdef LINT_ARGS

global void syntax (void) ;                             /*  s y n t a x  */
  /* syntax performs the syntactic analysis of expressions.     */
  /* The expression will be appended as the right son of the    */
  /*  node referenced by the global variable binprev.           */
  /* At entry binprev must not have a right son.                */
  /* At return binprev is unchanged.                            */
  /* At entry the global variable bincurr is the first token    */
  /*  of the expression.                                        */
  /* At exit bincurr is the first token that does not belong to */
  /*  the expression.                                           */

#else
global void syntax () ;
#endif


			/* former module pars.h */
#ifdef LINT_ARGS
global boolean    chkc      (symctype);
global boolean    id        (void);
global boolean    chkid     (void);
global boolean    chkappend (char*s);
  /* reports an error with the function name s and returns true, */
  /* if binprev is not a right-son node. Otherwise returns false */
#else
global boolean    chkc      (/*psymc*/);
global boolean    id        ();
global boolean    chkid     ();
global boolean    chkappend ();
#endif
