/* RCS $Id: j_acos.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: j_acos.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:25:25  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_intv j_acos(a_intv x)               */
/*                        a_intv x  ;                           */
/*                                                              */
/*      Arguments       : x = interval argument of acos(x)      */
/*                                                              */
/*      Description     : Fast interval arcus cosine            */
/*                        function for double IEEE              */
/*                        Floating-Point Arithmetic             */
/*                                                              */
/*      Date            : 1996-03-08                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local a_intv j_acos(a_intv x)
#else
local a_intv j_acos(x)

a_intv x;
#endif
{
  a_intv res;
  if (x.INF==x.SUP)                  /* point interval */
    { 
          res.INF=q_acos(x.INF);
          res.SUP=res.INF*q_ccsp;
          res.INF*=q_ccsm;
    }
  else
    {
      res.INF=q_acos(x.SUP)*q_ccsm;
      res.SUP=q_acos(x.INF)*q_ccsp;
    }   
  return(res);
}
