/* RCS $Id: j_exp2.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: j_exp2.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:26:20  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_intv j_exp2(a_intv x)               */
/*                        a_intv x  ;                           */
/*                                                              */
/*      Arguments       : x = interval argument of exp2(x)      */
/*                                                              */
/*      Description     : Fast interval exponential             */
/*                        function for double IEEE              */
/*                        Floating-Point Arithmetic             */
/*                                                              */
/*      Date            : 1996-03-08                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local a_intv j_exp2(a_intv x)
#else
local a_intv j_exp2(x)

a_intv x;
#endif
{
 a_intv res;
  if (x.INF==x.SUP)                         /* point interval */
    { 
      if (x.INF<-1022)
        { 
          res.INF=0.0;
          res.SUP=q_minr;
        }
      else if (CUTINT(x.INF)==x.INF) 
        res.INF=res.SUP=q_exp2(x.INF);
      else 
        { 
          res.INF=q_exp2(x.INF);
          res.SUP=res.INF*q_e2ep;
          res.INF*=q_e2em;
        }
    }
  else
    {
      if (x.INF<-1022) 
        res.INF=0.0;
      else if (CUTINT(x.INF)==x.INF)
        res.INF=q_exp2(x.INF);
      else
        res.INF=q_exp2(x.INF)*q_e2em;
      if (x.SUP<-1022)
        res.SUP=q_minr;
      else if (CUTINT(x.SUP)==x.SUP)
        res.SUP=q_exp2(x.SUP);
      else
        res.SUP=q_exp2(x.SUP)*q_e2ep;
    }   
 if (res.INF<0.0) res.INF=0.0;
 if ((x.SUP<=0.0) && (res.SUP>1.0)) res.SUP=1.0;
 if ((x.INF>=0.0) && (res.INF<1.0)) res.INF=1.0;

 return(res);
}
