/* RCS $Id: j_sqrt.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: j_sqrt.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:26:20  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_intv j_sqrt(a_intv x)               */
/*                        a_intv x  ;                           */
/*                                                              */
/*      Arguments       : x = interval argument of sqrt(x)      */
/*                                                              */
/*      Description     : Fast interval square root function    */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1996-03-08                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local a_intv j_sqrt(a_intv x)
#else
local a_intv j_sqrt(x)

a_intv x;
#endif
{
  a_intv res;
  if (x.INF==x.SUP)                        /* point interval */
    { 
      if (x.INF==0)
        res.INF=res.SUP=0;
      else { res.INF=q_sqrt(x.INF); 
             res.SUP=r_succ(res.INF);
             res.INF=r_pred(res.INF);
           }
    }
  else
    {
      if (x.INF==0) res.INF=0;
      else res.INF=r_pred(q_sqrt(x.INF));
      res.SUP=r_succ(q_sqrt(x.SUP));
    }   
  return(res);
}

