/* RCS $Id: q_acot.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: q_acot.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_real q_acot(a_real x)               */
/*                        a_real x  ;                           */
/*                                                              */
/*      Arguments       : x = real argument of acot(x)          */
/*                                                              */
/*      Description     : Fast real arcus cotangent function    */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1997-03-10                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local double q_acot(double x)
#else
local double q_acot(x)

double x;
#endif
{
  double res;

#ifdef PXSCTRAP
  E_SPUSH("q_acot");
#endif
  if NANTEST(x)                                       /* Test: x=NaN */
      res=q_abortnan(INV_ARG,&x,17);
  else {
  /* main program with different cases */
    if ((-1e-17<x)&&(x<1e-17)) res=q_piha;
    else if (x<0) res=q_pi+q_atn1(1.0/x);
    else if (x<1e10) res= q_atn1(1.0/x); 
         else        res=1.0/x;     
  }  
#ifdef PXSCTRAP
  E_SPOPP("q_acot");
#endif
  return(res);
}

