/* RCS $Id: q_acsh.c,v 1.1 1997/05/16 13:29:06 ae13 Exp $ */
/*
$Log: q_acsh.c,v $
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_real q_acsh(a_real x)               */
/*                        a_real x  ;                           */
/*                                                              */
/*      Arguments       : x = real argument of acsh(x)          */
/*                                                              */
/*      Description     : Fast real area cosine function        */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1997-03-10                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local double q_acsh(double x)
#else
local double q_acsh(x)

double x;
#endif
{
  double res;
 
#ifdef PXSCTRAP
  E_SPUSH("q_acsh");
#endif
  if NANTEST(x)                                       /* Test: x=NaN */
      res=q_abortnan(INV_ARG,&x,23);
  else {
     if (x<1) res=q_abortr1(INV_ARG,&x,23);
     if (x<1.025) res=q_l1p1(x-1+sqrt((x-1)*(x+1)));
     else if (x>1e150) res=q_l2+q_log1(x);
          else         res=q_log1(x+sqrt((x-1)*(x+1)));
  }
#ifdef PXSCTRAP
  E_SPOPP("q_acsh");
#endif  
  return(res);
}

