/* RCS $Id: q_atnh.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: q_atnh.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_real q_atnh(a_real x)               */
/*                        a_real x  ;                           */
/*                                                              */
/*      Arguments       : x = real argument of atnh(x)          */
/*                                                              */
/*      Description     : Fast real area tangens function       */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1997-03-17                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local double q_atnh(double x)
#else
local double q_atnh(x)

double x;
#endif
{
  double absx, res;
 
#ifdef PXSCTRAP
  E_SPUSH("q_atnh");
#endif
  if NANTEST(x)                                       /* Test: x=NaN */
      res=q_abortnan(INV_ARG,&x,24);
  else {
  if ((x<=-1.0)||(1.0<=x))       
      res=q_abortr1(INV_ARG,&x,24);
  if (x<0) absx=-x; else absx=x;
  if (absx>=q_at3i) res=0.5*q_log1((1+absx)/(1-absx));
  else              res=0.5*q_l1p1((2*absx)/(1-absx));
  if (x<0) res=-res;
  }
#ifdef PXSCTRAP
  E_SPOPP("q_atnh");
#endif
  return(res);

}

