/* RCS $Id: q_cosh.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: q_cosh.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_real q_cosh(a_real x)               */
/*                        a_real x  ;                           */
/*                                                              */
/*      Arguments       : x = real argument of cosh(x)          */
/*                                                              */
/*      Description     : Fast real hyperbolic cosine function  */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1997-03-10                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local double q_cosh(double x)
#else
local double q_cosh(x)

double x;
#endif
{
  double res;
#ifdef PXSCTRAP  
  E_SPUSH("q_cosh");
#endif
  if NANTEST(x)                                       /* Test: x=NaN */
      res=q_abortnan(INV_ARG,&x,19);
  else {
    if ((x>=-q_ex2c)&&(x<=q_ex2c))
       res=0.5*(q_ep1(x)+q_ep1(-x));
    else if ((x>=-q_ex2a)&&(x<=q_ex2a))
       res=(0.5*q_exp(x))+(0.5*q_exp(-x));
    else 
      res=q_abortr1(OVER_FLOW,&x,19);                 /* Overflow */
  }
#ifdef PXSCTRAP
  E_SPOPP("q_cosh");
#endif  

  return(res);
}

