/* RCS $Id: q_coth.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: q_coth.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_real q_coth(a_real x)               */
/*                        a_real x  ;                           */
/*                                                              */
/*      Arguments       : x = real argument of coth(x)          */
/*                                                              */
/*      Description     : Fast real hyperbolic cotangent        */
/*                        function for double IEEE              */
/*                        Floating-Point Arithmetic             */
/*                                                              */
/*      Date            : 1997-03-10                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local double q_coth(double x)
#else
local double q_coth(x)

double x;
#endif
{
  double absx, res;
  int sgn;

#ifdef PXSCTRAP  
  E_SPUSH("q_coth");
#endif
  if NANTEST(x)                                       /* Test: x=NaN */
      res=q_abortnan(INV_ARG,&x,21);
  else {

  if ((x>-q_ctht)&&(x<q_ctht))
      res=q_abortr1(OVER_FLOW,&x,21);

  if (x<0) { sgn=-1; absx=-x; }
  else     { sgn=1; absx=x;  }

  if (absx>22.875) res=sgn;
  else if (absx>=q_ln2h) res=sgn*(1+2/(q_ep1(2*absx)-1));
  else res=sgn*(1+2/q_epm1(2*absx));
  }
#ifdef PXSCTRAP
  E_SPOPP("q_coth");
#endif  
  return(res);
}
