/* RCS $Id: q_log2.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: q_log2.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_real q_log2(a_real x)               */
/*                        a_real x  ;                           */
/*                                                              */
/*      Arguments       : x = real argument of log2(x)          */
/*                                                              */
/*      Description     : Fast real  function                   */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1997-07-07                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local double q_log2(double x)
#else
local double q_log2(x)

double x;
#endif
{
  double res;
#ifdef PXSCTRAP  
  E_SPUSH("q_log2");
#endif
  if NANTEST(x)                                       /* Test: x=NaN */
      res=q_abortnan(INV_ARG,&x,8);
  else 
      res=q_log(x)*q_l2i;

#ifdef PXSCTRAP  
  E_SPOPP("q_log2");
#endif
  return(res);
}

