/* RCS $Id: q_sqr.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: q_sqr.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_real q_sqr(a_real x)                */
/*                        a_real x  ;                           */
/*                                                              */
/*      Arguments       : x = real argument of sqr(x)           */
/*                                                              */
/*      Description     : Fast real square function             */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1997-03-10                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local double q_sqr(double x)
#else
local double q_sqr(x)

double x;
#endif
{
  double res;
#ifdef PXSCTRAP  
  E_SPUSH("q_sqr");
#endif
  if NANTEST(x)                                       /* Test: x=NaN */
      res=q_abortnan(INV_ARG,&x,1);
  else {
  if ((x<-q_sqra)||(x>q_sqra))
      res=q_abortr1(OVER_FLOW,&x,1);
  else
      res=x*x;
  }
#ifdef PXSCTRAP
  E_SPOPP("q_sqr");
#endif  
  return(res);
}

