/* RCS $Id: q_sqrt.c,v 1.1 1997/05/16 13:29:06 ae13 Exp $ */
/*
$Log: q_sqrt.c,v $
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_real q_sqrt(a_real x)               */
/*                        a_real x  ;                           */
/*                                                              */
/*      Arguments       : x = real argument of sqrt(x)          */
/*                                                              */
/*      Description     : Fast real function                    */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1997-03-10                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local double q_sqrt(double x)
#else
local double q_sqrt(x)

double x;
#endif
{
  double res;
#ifdef PXSCTRAP  
  E_SPUSH("q_sqrt");
#endif
  if NANTEST(x)                                       /* Test: x=NaN */
      res=q_abortnan(INV_ARG,&x,0);
  else {
  if (x<0)
      res=q_abortr1(INV_ARG,&x,0);
  else
      res=sqrt(x);
  }
#ifdef PXSCTRAP
  E_SPOPP("q_sqrt");
#endif  
  return(res);
}

