/* RCS $Id: q_tanh.c,v 1.1 1997/05/16 13:29:06 ae13 Exp $ */
/*
$Log: q_tanh.c,v $
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 * Revision 1.1  1997/05/16  13:29:06  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_real q_tanh(a_real x)               */
/*                        a_real x  ;                           */
/*                                                              */
/*      Arguments       : x = real argument of tanh(x)          */
/*                                                              */
/*      Description     : Fast real hyperbolic tangent function */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1997-03-10                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif


#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local double q_tanh(double x)
#else
local double q_tanh(x)

double x;
#endif
{
  double res;

#ifdef PXSCTRAP
  E_SPUSH("q_tanh");
#endif
  if NANTEST(x)                                       /* Test: x=NaN */
      res=q_abortnan(INV_ARG,&x,20);
  else {
   if ((-1e-10<x) && (x<1e-10)) res=x; 
   else res=1.0/q_cth1(x); 
  }
#ifdef PXSCTRAP
  E_SPOPP("q_tanh");
#endif
  return(res);
}
